
#include "stdafx.h"
#include "Excaliburl.h"




Excaliburl::Excaliburl()
{
	m_chn=m_type=m_winradio=szSerNum=0;
	ClearVariables();

}

void Excaliburl::ClearVariables()
{
	m_type=0;
	h_lib=NULL;
	WG3_GetRadioList=NULL;

	WG3_OpenRadioDevice=NULL;
	WG3_GetRawSignalStrength=NULL;
	WG3_SetFrequency=NULL;
	WG3_SetAtten=NULL;
	WG3_SetAGC=NULL;
	WG3_SetPower=NULL;
	WG3_GetInfo=NULL;
	WG3_SetLEDFlashPattern=NULL;

	WG3_InitializeDemodulator=NULL;
	WG3_SetAudioBandwidth=NULL;
	WG3_SetIFBandwidth=NULL;
	WG3_SetMode=NULL;

	WG3_SetVolume=NULL;
	WG3_SetupStreams=NULL;
	WG3_SetRFAmp=NULL;
	WG3_SetNoiseBlanker=NULL;
	WG3_SetIF2Frequency=NULL;
	WG3_SetVolume=NULL;
	WG3_SetIFShift=NULL;
	WG3_SetFMW=NULL;
	memset(&WG3_IFPntr,0,sizeof(WRG3_THREAD_PNTR));
	memset(&WG3_AFPntr,0,sizeof(WRG3_THREAD_PNTR));
}

Excaliburl::~Excaliburl()	
{
	Close();
}

#include "Radio.h"

extern UINT LastSerNum;

BOOL Excaliburl::Open()
{	

	szSerNum=0;
	int res=0,ret=0;
	myCtrl=cr;
	
	m_type=0;


	if(!LoadDLL()) goto err;

	OpenRadioDevice();
	if(!m_winradio) goto err;
	
	AGCData.bLength=sizeof(SOFTAGC_DATA);
	AGCData.iRefLevel=-6;
	AGCData.dwAttackTime=5;
	AGCData.dwDecayTime=200;

	radio_info.bLength=sizeof(radio_info);
	ret=WG3_GetInfo(m_winradio,&radio_info);
	if(!ret) goto err;

	//if (memcmp(radio_info.szProdName,"G3USBv",6)) goto err;

	myCtrl->m_MaxFreq=(double)((int)radio_info.MaxFreq)/1000.;
	myCtrl->m_MinFreq=(double)((int)radio_info.MinFreq)/1000.;
	sscanf(radio_info.szSerNum,"%08x",&szSerNum);
	myCtrl->FMWEnabled=radio_info.Features.FMWEnabled;

	IFfrq=RCfrq=48000;       
	IFnum=RCnum=2048;


	MIN_IF_SCALE[m_chn]=RCfrq>>2;
	MED_IF_SCALE[m_chn]=RCfrq>>1;

	myCtrl->InitSDR(IFfrq,IFnum,RCfrq,RCnum,(float)JetPara.LevelOffset/10.f);
	if(!myCtrl->IFDemodulator::Init(myCtrl->m_RCsample_frq,myCtrl->m_RCsample_num,myCtrl->m_offset,myCtrl->m_radiowidth,myCtrl->m_radiomode)) goto err;
	SetVolume(0);
	return TRUE;

err:
	Close();
	return FALSE;
}

void Excaliburl::Close()
{
	if(h_lib)
		{
		CodecStop();
		CloseRadioDevice();
		FreeDLL();
		}
}

BOOL Excaliburl::LoadDLL()
{
	char dll[256];

	if(h_lib) Close();

	strcpy(dll,"WRG3130API.dll");
	h_lib = LoadLibrary(dll);
	if (h_lib==NULL) 
		{
		myCtrl->DLLError=1;
		return FALSE;
		}

	if(!(WG3_GetRadioList = (int (WINAPI *)(RADIO_INFO2 *,size_t,size_t *))GetProcAddress(h_lib, "G3GetRadioList2"))) goto err;
	if(!(WG3_OpenRadioDevice = (int (WINAPI *)(int))GetProcAddress(h_lib, "OpenRadioDevice"))) goto err;
	if(!(WG3_CloseRadioDevice = (BOOL (WINAPI *)(int))GetProcAddress(h_lib, "CloseRadioDevice"))) goto err;
	if(!(WG3_GetRawSignalStrength = (DWORD (WINAPI *)(int))GetProcAddress(h_lib, "GetRawSignalStrength"))) goto err;
	if(!(WG3_SetFrequency = (BOOL (WINAPI *)(int,DWORD))GetProcAddress(h_lib, "SetFrequency"))) goto err;
	if(!(WG3_SetAtten = (BOOL (WINAPI *)(int,BOOL))GetProcAddress(h_lib, "SetAtten"))) goto err;
	if(!(WG3_SetAGC = (int (WINAPI *)(int,int))GetProcAddress(h_lib, "SetAGC"))) goto err;
	if(!(WG3_SetPower = (BOOL (WINAPI *)(int,BOOL))GetProcAddress(h_lib, "SetPower"))) goto err;
	if(!(WG3_GetInfo = (int (WINAPI *)(int,RADIO_INFO2*))GetProcAddress(h_lib, "G3GetInfo"))) goto err;
	if(!(WG3_SetLEDFlashPattern = (BOOL (WINAPI *)(int,BYTE))GetProcAddress(h_lib, "SetLEDFlashPattern"))) goto err;
	if(!(WG3_SetIFGain = (BOOL (WINAPI *)(int,int))GetProcAddress(h_lib, "SetIFGain"))) goto err;
	if(!(WG3_IsDeviceConnected = (BOOL (WINAPI *)(int))GetProcAddress(h_lib, "IsDeviceConnected"))) goto err;

	if(!(WG3_CodecStart = (BOOL (WINAPI *)(int,WG3_CALLBACKFUNC, void*))GetProcAddress(h_lib, "CodecStart"))) goto err;
	if(!(WG3_CodecStop = (BOOL (WINAPI *)(int))GetProcAddress(h_lib, "CodecStop"))) goto err;
	if(!(WG3_CodecRead = (size_t (WINAPI *)(int,void*, size_t))GetProcAddress(h_lib, "CodecRead"))) goto err;
	return TRUE;
err:

	FreeDLL();
	return FALSE;
}

BOOL Excaliburl::FreeDLL(void)
{
	if(h_lib && FreeLibrary(h_lib))
		{
		ClearVariables();
		return TRUE;
		}
	return FALSE;
}

int Excaliburl::OpenRadioDevice(int dev)
{
	if (!h_lib)	return FALSE;
	if(m_winradio) WG3_CloseRadioDevice(m_winradio);
	m_winradio=WG3_OpenRadioDevice(dev);
	return m_winradio;
}

void Excaliburl::CloseRadioDevice(void)
{
	if (m_winradio && h_lib)
		{
		SetPower(0);
		WG3_CloseRadioDevice(m_winradio);
		m_winradio=NULL;
		}
}

int Excaliburl::GetRawSignalStrength()
{
	if (!m_winradio || !h_lib) return 0;
	return WG3_GetRawSignalStrength(m_winradio);
}

BOOL Excaliburl::SetFrequency(double frq)
{
	if(!m_winradio || !h_lib) return NULL;
	if(frq<myCtrl->m_MinFreq) frq=myCtrl->m_MinFreq;
	if(frq>myCtrl->m_MaxFreq) frq=myCtrl->m_MaxFreq;
	myCtrl->m_freq=frq;
	BOOL ret=WG3_SetFrequency(m_winradio,DWORD(frq * 1000.));
	return ret;
}

BOOL Excaliburl::SetAtten(BOOL att)
{
	if(m_winradio && h_lib)	WG3_SetAtten(m_winradio,att ? TRUE : FALSE);
	return NULL;
}

void Excaliburl::SetNB(int nb)
{
	if(m_winradio && h_lib)
		{
		if(nb) WG3_SetNoiseBlanker(m_winradio,1,25);
		else WG3_SetNoiseBlanker(m_winradio,0,0);
		}
}

void Excaliburl::SetAGC(int agc)
{
	if(m_winradio && h_lib)
		{
		WG3_SetAGC(m_winradio,agc ? 1 : 3);
		}
}

void Excaliburl::SetPower(BOOL onoff)
{
	if (m_winradio && h_lib)
		{
		WG3_SetPower(m_winradio,onoff);
		if(onoff) WG3_SetLEDFlashPattern(m_winradio,0xFF);
		else WG3_SetLEDFlashPattern(m_winradio,0x01);
		}
}

BOOL Excaliburl::SetMode(int mode)
{
	if(myCtrl->m_mode==mode) return TRUE;
	BOOL m=WRG3_REC_AM,ret= NULL;
	BOOL XsetFMW=FALSE;

	if(m_winradio && h_lib)
		{
		switch(mode)
			{
			case REC_LSB:	m=WRG3_REC_LSB;
							break;
			case REC_USB:	m=WRG3_REC_USB;
							break;
			case REC_CW:	m=WRG3_REC_CW;
							break;
			default:
			case REC_AM:	m=WRG3_REC_AM;
							break;
			case REC_AMS:	m=WRG3_REC_SAM;
							break;
			case REC_FM:	m=WRG3_REC_FMN;
							break;
			case REC_WFM:	if(!m_type) return NULL;
							m=WRG3_REC_FMW;
							XsetFMW=TRUE;
							break;

			case REC_ISB:	m=WRG3_REC_ISB;
							break;
			case REC_DSB:	m=WRG3_REC_DSB;
							break;
			}
		myCtrl->Set_Mode(mode);
		if(!WG3_SetMode) ret=TRUE;
		else ret=WG3_SetMode(m_winradio,m);
		if(WG3_SetFMW && XsetFMW!=setFMW) ret=WG3_SetFMW(m_winradio,XsetFMW);
		}
	setFMW=XsetFMW;
	return ret;
}

BOOL Excaliburl::SetIFBandWidth(int width)
{
	if(myCtrl->m_IFBandWidth==width) return myCtrl->m_IFBandWidth;
	if(m_winradio && h_lib)
		{
		myCtrl->Set_IFBandWidth(width);
		if(WG3_SetIFBandwidth) WG3_SetIFBandwidth(m_winradio,width);
		}
	return myCtrl->m_IFBandWidth;
}


BOOL Excaliburl::SetVolume(int vol)
{
	BOOL ret= NULL;
	if(m_winradio && h_lib)
		{
		myCtrl->Set_Volume(vol);
		if(!WG3_SetVolume) return TRUE;
		ret=WG3_SetVolume(m_winradio,30);
		}
	return ret;
}

BOOL Excaliburl::SetPreAmp(int ampl)
{
	BOOL ret= NULL;
	if(m_winradio && h_lib && WG3_SetRFAmp)
		{
		ret=WG3_SetRFAmp(m_winradio,ampl);
		}
	return ret;
}

BOOL Excaliburl::SetIFShift(int shift)
{
	BOOL ret= NULL;
	if(m_winradio && h_lib)
		{
		myCtrl->Set_IFShift(shift);
		if(!WG3_SetIFShift) return TRUE;
		ret=WG3_SetIFShift(m_winradio,shift);
		}
	return ret;
}


BOOL Excaliburl::CodecStart()
{
	if (!m_winradio || !h_lib) return NULL;
	int ret=TRUE;

	myCtrl->recCntr=0;
	myCtrl->inCntr=0;

	memset(&WG3_IFPntr,0,sizeof(WRG3_THREAD_PNTR));
	memset(&WG3_AFPntr,0,sizeof(WRG3_THREAD_PNTR));
	WG3_AFPntr.bIsRunning=WG3_IFPntr.bIsRunning=TRUE;
	WG3_AFPntr.wr=WG3_IFPntr.wr=this;
	WG3_AFPntr.chn=WG3_IFPntr.chn=m_chn;
	WG3_IFPntr.Size=RCnum<<1;
	WG3_AFPntr.Size=SAMPLE_NUM<<1;
	WG3_IFPntr.m_receiver=myCtrl->m_receiver;
	WG3_AFPntr.mRadio=WG3_IFPntr.mRadio=myCtrl;

	if(myCtrl->m_receiver==REC_WINRADG3G || myCtrl->m_receiver==REC_WINRADG33EM || myCtrl->m_receiver==REC_WINRADG5G)
		{
		if(myCtrl->m_receiver==REC_WINRADG3G||myCtrl->m_receiver==REC_WINRADG33EM) WG3_IFPntr.flags=IF03WRITE;
		else WG3_IFPntr.flags=IF05WRITE;
		ret=WG3_CodecStart(m_winradio, CodecCallback, &WG3_IFPntr);
		}
			
	else
		{
		if(myCtrl->m_receiver==REC_WINRADG13G)
			{
			WG3_AFPntr.flags=AF13WRITE;
			WG3_IFPntr.flags=IF13WRITE;
			}
		else
			{
			WG3_AFPntr.flags=AF15WRITE;
			WG3_IFPntr.flags=IF15WRITE;
			}
		ret=WG3_SetupStreams(m_winradio,WR3_Callback,&WG3_IFPntr,WR3_Callback,&WG3_AFPntr);
		}
	return TRUE;
}

BOOL Excaliburl::CodecStop()
{
	if (!m_winradio || !h_lib) return NULL;
	memset(&WG3_IFPntr,0,sizeof(WRG3_THREAD_PNTR));
	memset(&WG3_AFPntr,0,sizeof(WRG3_THREAD_PNTR));
	if(myCtrl->m_receiver==REC_WINRADG13G || myCtrl->m_receiver==REC_WINRADG15G)
		{
		WG3_SetupStreams(m_winradio,NULL,NULL,NULL,NULL);
		}
	else  WG3_CodecStop(m_winradio);

	return TRUE;
}

void Excaliburl::SetSqlValue(int val)
{
	myCtrl->m_smval = val;
	myCtrl->SMeterChange(myCtrl->m_smval);
	int m_radiosq=0;
	if(myCtrl->m_smval>=myCtrl->m_squelch) m_radiosq=1;
	if(myCtrl->m_radiosq!= m_radiosq)
		{
		myCtrl->m_radiosq=m_radiosq;
		myCtrl->SquelchChange(m_radiosq);
		}
}

void Excaliburl::SetSquelch(int sql)
{
	if(m_winradio && h_lib) SetSqlValue(WG3_GetRawSignalStrength(m_winradio));
}

int Excaliburl::GetSquelch()
{
	if(!m_winradio || !h_lib) return NULL;
	int val=WG3_GetRawSignalStrength(m_winradio);
	if(val!=myCtrl->m_smval) SetSqlValue(val);
	return val;
}
