////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project ExtIO_G31DDC
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////
#include "stdafx.h"
#include "resource.h"

#include "ExtIO_G31DDC.h"
#include "ExternDlg.h"

#pragma pack(1)

#define WM_MYUSER			(WM_USER+7400)

#define WM_HID_EXT_ADD		(WM_MYUSER+70)
#define WM_HID_EXT_REMOVE	(WM_MYUSER+71)
#define WM_HID_EXT_AUDIO	(WM_MYUSER+72)

#define WM_EXTIQ_ATT_CHNG	(WM_MYUSER+75)	//the ATT has changet 
#define WM_EXTIQ_AGC_CHNG	(WM_MYUSER+76)  //the AGC has changet 
#define WM_EXTIQ_PRE_CHNG	(WM_MYUSER+77)	//the PreAmplifiere changet    
#define WM_EXTIQ_DIT_CHNG	(WM_MYUSER+78)	//the Dithering has changed 
#define WM_EXTIQ_NB_CHNG	(WM_MYUSER+79)	//the NoisBlanker has changed
#define WM_EXTIQ_FIL_CHNG	(WM_MYUSER+80)	//the FilterSelect has changed
#define WM_EXTIQ_SMPL_CHNG	(WM_MYUSER+81)	//the SampleRate has changed
#define WM_EXTIQ_INFO_CHNG	(WM_MYUSER+82)	//the InfoField has changed
#define WM_EXTIQ_OFFS_CHNG	(WM_MYUSER+83)	//the dBOffset has changed
#define WM_EXTIQ_CORR_CHNG	(WM_MYUSER+84)	//the FreqCorrecture has changed
#define WM_EXTIQ_SCAL_CHNG	(WM_MYUSER+85)	//the ScaleCorrecture has changed
#define WM_EXTIQ_SHOW_CHNG	(WM_MYUSER+86)  //the GUI of the extern receiver calls this message if it is hidden or shown

// the RJ10 DLL set ..... p.Ex.
//----------------------------------
// myPara.msgCORR=WM_EXTIQ_CORR_CHNG
// myPara.msgSCAL=WM_EXTIQ_SCAL_CHNG
// myPara.msgOFFS=WM_EXTIQ_OFFS_CHNG
//.......

typedef struct
{
	HWND	msgHWND;	//the window handle for callback messages
	UINT	msgARRIVAL;	//the callback messages: the receiver has been inserted and becomes available
	UINT	msgREMOVED;	//the callback messages: the receiver has been removed and is no more available
	UINT	msgSHOW;	//the GUI calls this message if it is hidden or shown
	UINT	msgATT;		//the callback messages: the ATT has changet 
	UINT	msgAGC;		//the callback messages: the AGC has changet 
	UINT	msgPRE;		//the callback messages: the PreAmplifiere changet
	UINT	msgDIT;		//the callback messages: the Dithering has changed 
	UINT	msgNB;		//the callback messages: the NoisBlanker has changed
	UINT	msgFIL;		//the callback messages: the the FilterSelect has changed
	UINT	msgSMPL;	//the callback messages: the SampleRate has changed
	UINT	msgINFO;	//the callback messages: the InfoField has changed
	UINT	msgOFFS;	//the callback messages: the dBOffset has changed
	UINT	msgCORR;	//the callback messages: the FreqCorrecture has changed
	UINT	msgSCAL;	//the callback messages: the ScaleCorrecture has changed

	//the state of the last settings 
	BYTE	SHOW;		//0=hide 1=show
	BYTE	ATT;		//0-3 off=0, on=1-3
	BYTE	AGC;		//0-3 off=0, on=1-3			
	BYTE	PRE;		//off=0, on=1
	BYTE	DIT;		//off=0, on=1
	BYTE	NB;			//off=0, on=1
	BYTE	filter;		//filter bank switch seltion
	BYTE	mode;		//sample mode (max is 0-7)	
	short	dBOffset;	//the level offset in dB
	short	FreqCorrecture;		//the chip own individual frequency offset
	short   ScaleCorrecture;	//the chip own individual frq scaling distance (difference from Low-Frq to Hi-Frq in Hz)
	BYTE	InfoField[512];     //free for your own data structure or other individual use
}EXTIQ_PARA;

#pragma pack()

int			lastFrq=7050000;
int			IQ_freq=200000,IQ_spow=13,DDCType=9;
int			mR_ATT;

CExternDlg	myCtrl;
EXTIQ_PARA	myPara={0};
UBYTE		WRT_BIT=0x08,PRE_BIT=0x10,ATT_BIT=0x80,NTIDRB32=0;

char		myDIR[256];
HCURSOR		m_Hand=NULL;
CFont		BigFont,fontBold,fontRegular;
COLORREF	COL_BACK,myLIGHT,myVLIGHT,myDARK,myVDARK,COL_BTXT;

void WINAPI RGBtoHSL( COLORREF rgb, double *H, double *S, double *L)
{   
	double delta;
	double r = (double)GetRValue(rgb)/255;
	double g = (double)GetGValue(rgb)/255;
	double b = (double)GetBValue(rgb)/255;   
	double cmax = max(r, max(g, b));
	double cmin = min(r, min(g, b));   
	*L=(cmax+cmin)/2.0;   
	
	if(cmax==cmin) 
	{
		*S = 0;      
		*H = 0; // it's really undefined   
	} 
	else 
	{
		if(*L < 0.5) 
			*S = (cmax-cmin)/(cmax+cmin);      
		else
			*S = (cmax-cmin)/(2.0-cmax-cmin);      
		
		delta = cmax - cmin;
		if(r==cmax) 
			*H = (g-b)/delta;      
		else if(g==cmax)
			*H = 2.0 +(b-r)/delta;
		else          
			*H=4.0+(r-g)/delta;
		*H /= 6.0; 
		if(*H < 0.0)
			*H += 1;  
	}
}

double WINAPI HuetoRGB(double m1, double m2, double h )
{
	if( h < 0 ) h += 1.0;
	if( h > 1 ) h -= 1.0;
	if( 6.0*h < 1 )
		return (m1+(m2-m1)*h*6.0);
	if( 2.0*h < 1 )
		return m2;
	if( 3.0*h < 2.0 )
		return (m1+(m2-m1)*((2.0/3.0)-h)*6.0);
	return m1;
}

COLORREF WINAPI HLStoRGB_ONE( double H, double L, double S )
{
	double r, g, b;
	double m1, m2;
	
	if(S==0) {
		r=g=b=L;
	} else {
		if(L <=0.5)
			m2 = L*(1.0+S);
		else
			m2 = L+S-L*S;
		m1 = 2.0*L-m2;
		r = HuetoRGB(m1, m2, H+1.0/3.0);
		g = HuetoRGB(m1, m2, H);
		b = HuetoRGB(m1, m2, H-1.0/3.0);
	}
	return RGB((BYTE)(r*255), (BYTE)(g*255), (BYTE)(b*255));
}

COLORREF WINAPI AddBasisColor(COLORREF col, double luminace)
{
	double m_dblHue,m_dblSat,m_dblLum;
	RGBtoHSL (col, &m_dblHue, &m_dblSat, &m_dblLum);
//	luminace*=.4;

	m_dblLum+=luminace;
	if(m_dblLum>.99) m_dblLum=.99;
	else if(m_dblLum<0.01) m_dblLum=0.01;

	return HLStoRGB_ONE(m_dblHue,m_dblLum,m_dblSat);
}

void WINAPI	InitMyColors()
{
	COL_BACK		=GetSysColor(COLOR_BTNFACE);
	myLIGHT			=GetSysColor(COLOR_3DLIGHT);
	myDARK			=GetSysColor(COLOR_3DSHADOW);
	myVDARK			=GetSysColor(COLOR_3DDKSHADOW);
	COL_BTXT		=GetSysColor(COLOR_BTNTEXT);
	myVLIGHT		=AddBasisColor(myLIGHT,.1);

	LOGFONT	myfont=		{	//SmallFont
					   -12,	//lfHeight;
						0,	//lfWidth;
						0,	//lfEscapement;
						0,	//lfOrientation;
				 FW_NORMAL,	//lfWeight;
						0,	//lfItalic;
						0,	//lfUnderline;
						0,	//lfStrikeOut;
						0,	//lfCharSet;
						0,	//lfOutPrecision;
						0,	//lfClipPrecision;
						0,	//lfQuality;
 DEFAULT_PITCH | FF_SWISS,	//lfPitchAndFamily;
		{"MS Sans Serif\0    "}};	//lfFaceN

	fontRegular.CreateFontIndirect(&myfont);
	myfont.lfWeight=FW_BOLD;
	fontBold.CreateFontIndirect(&myfont);

	strcpy(myfont.lfFaceName,"Arial");
	myfont.lfWidth=12;
	myfont.lfHeight=-16;
	BigFont.CreateFontIndirect(&myfont);

	myPara.mode=2; //use excalibur in 200 kHz sample mode

}

void  WINAPI FillGradient (CDC *m_dc, CRect rect,COLORREF colorStart, COLORREF colorFinish, BOOL bHorz)
{
	int		nShift = 5,nShift2 = 6;
    int		nSteps = 1 << nShift;
	int		nSteps2,zx;
	int		x,z,i,val=0;
	BYTE	bR,bG,bB,pR,pG,pB;
	COLORREF pickCol=0;

	nSteps2 = 44;	//like glass button
	zx=nSteps2-18;
	rect.top++;
    CRect r2;

    for (i = 0; i< nSteps2; i++)
		{
        bR = (BYTE) ((GetRValue(colorStart) * (nSteps2 - i) +  GetRValue(colorFinish) * i) /nSteps2);
        bG = (BYTE) ((GetGValue(colorStart) * (nSteps2 - i) +  GetGValue(colorFinish) * i) /nSteps2);
        bB = (BYTE) ((GetBValue(colorStart) * (nSteps2 - i) +  GetBValue(colorFinish) * i) /nSteps2);

		CBrush br (RGB(bR, bG, bB));
		r2 = rect;
        r2.bottom = rect.bottom - ((i * rect.Height()) >> nShift);
        r2.top = rect.bottom - (((i + 1) * rect.Height()) >> nShift);
		if(r2.top<(rect.top+1)) break;
        if (r2.Height() > 0) m_dc->FillRect(r2, &br);
		}

	for (z=5,i = zx-2; i< nSteps2; i++)
		{
        bR = (BYTE) ((GetRValue(colorStart) * (nSteps2 - i) +  GetRValue(colorFinish) * i) /nSteps2);
        bG = (BYTE) ((GetGValue(colorStart) * (nSteps2 - i) +  GetGValue(colorFinish) * i) /nSteps2);
        bB = (BYTE) ((GetBValue(colorStart) * (nSteps2 - i) +  GetBValue(colorFinish) * i) /nSteps2);

		CBrush br (RGB(bR, bG, bB));
		x=i-zx+18;
        r2 = rect;
        r2.bottom = rect.bottom - ((x * rect.Height()) >> nShift);
		if(r2.top<rect.top) break;
        r2.top = rect.bottom - (((x + 1) * rect.Height()) >> nShift);
        if (r2.Height() > 0)  
			{
			if(z>-1 && r2.bottom!=val)
				{
				r2.left+=z; r2.right-=z;
				pickCol=m_dc->GetPixel(r2.left,r2.top);
				pR = (BYTE) ((bR + GetRValue(pickCol)) /2);
				pG = (BYTE) ((bG + GetGValue(pickCol)) /2);
				pB = (BYTE) ((bB + GetBValue(pickCol)) /2);
				m_dc->SetPixel(r2.left,r2.top,RGB(pR,pG,pB)); 
				r2.left++;

				pickCol=m_dc->GetPixel(r2.right-1,r2.top);
				pR = (BYTE) ((bR + GetRValue(pickCol)) /2);
				pG = (BYTE) ((bG + GetGValue(pickCol)) /2);
				pB = (BYTE) ((bB + GetBValue(pickCol)) /2);
				m_dc->SetPixel(r2.right-1,r2.top,RGB(pR,pG,pB));
				r2.right--;
				z--; val=r2.bottom;			
				}

			m_dc->FillRect(r2, &br);
			}
		}
}

void WINAPI DrawStyleRect(CDC* pDC, CRect& rect, COLORREF col) 
{
	pDC->Draw3dRect (rect,col, col);
	pDC->SetPixel(rect.left+1,rect.top+1,col);
	pDC->SetPixel(rect.right-2,rect.top+1,col);
	pDC->SetPixel(rect.left+1,rect.bottom-2,col);
	pDC->SetPixel(rect.right-2,rect.bottom-2,col);

	pDC->SetPixel(rect.left,rect.top,COL_BACK);
	pDC->SetPixel(rect.right-1,rect.top,COL_BACK);
	pDC->SetPixel(rect.left,rect.bottom-1,COL_BACK);
	pDC->SetPixel(rect.right-1,rect.bottom-1,COL_BACK);
}

UINT WINAPI GetProfileInt(char *AppName, char *KeyName, int value)
{
	char profilename[256];
	sprintf(profilename,"%s\\ExtIO_G31DDC.ini",myDIR);
	return GetPrivateProfileInt(AppName,KeyName,value,profilename);
}

UINT WINAPI WriteProfileInt(char *AppName, char *KeyName, int value)
{
	char profilename[256],val[256];
	sprintf(profilename,"%s\\ExtIO_G31DDC.ini",myDIR);
	sprintf(val,"%d",value);
	return WritePrivateProfileString(AppName,KeyName,val,profilename);
}
