#if !defined(WRG_DLL)
#define WRG_DLL

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma pack(push)
#pragma pack(1)

#include <windows.h>

///////////////////////////////////////////////////////////////////////////////////////////////

class Excaliburl 
{
public:
			Excaliburl();
virtual		~Excaliburl();

	HINSTANCE				h_lib;
	int						m_type,m_winradio,m_chn,setFMW;
	WRG3_THREAD_PNTR		WG3_IFPntr;    //IFdata provided from the receiver codec
	WRG3_THREAD_PNTR		WG3_AFPntr;    //AFdata provided from the receiver codec
	RADIO_INFO2				radio_info;
	UINT					szSerNum;

	BOOL					Open();
	void					Close();
	void					ClearVariables();

	int						IFfrq;		//IF sample frequence
	int						IFnum;		//numbers of IF samples per pack
	int						RCfrq;		//codec reader / recoder sample frequence
	int						RCnum;		//codec reader / recoder samples per input sequence

	//all winradio G3 series
	int						(WINAPI *WG3_OpenRadioDevice)(int);
	BOOL					(WINAPI *WG3_CloseRadioDevice)(int);
	int						(WINAPI *WG3_GetRadioList)(RADIO_INFO2 *,size_t,size_t *);
	DWORD					(WINAPI *WG3_GetRawSignalStrength)(int);
	BOOL					(WINAPI *WG3_SetFrequency)(int, DWORD);
	BOOL					(WINAPI *WG3_SetAtten)(int, BOOL);	
	BOOL					(WINAPI *WG3_SetAGC)(int, int);
	BOOL					(WINAPI *WG3_SetPower)(int, BOOL);
	BOOL					(WINAPI *WG3_GetInfo)(int,RADIO_INFO2*);
	BOOL					(WINAPI *WG3_SetLEDFlashPattern)(int,BYTE);
	BOOL					(WINAPI *WG3_SetIFGain)(int hRadio, int iIFGain);
	BOOL					(WINAPI *WG3_IsDeviceConnected)(int hRadio);

	//all G3x3
	BOOL					(WINAPI *WG3_CodecStart)(int,WG3_CALLBACKFUNC,void*);
	BOOL					(WINAPI *WG3_CodecStop)(int);
	size_t					(WINAPI *WG3_CodecRead)(int,void*, size_t);



	BOOL					LoadDLL();
	BOOL					FreeDLL();
	int						OpenRadioDevice(int dev=0);
	void					CloseRadioDevice(void);
	int						GetRawSignalStrength();
	BOOL					SetFrequency(double frq);
	BOOL					SetAtten(BOOL att);	
	void					SetAGC(int agc);
	void					SetNB(int NB);

	void					SetPower(BOOL onoff);
	BOOL					CodecStart();
	BOOL					CodecStop();

	BOOL					SetMode(int mode);
	BOOL					SetIFFilterCenter(int center,int width);
	BOOL					SetIFBandWidth(int width);
	BOOL					SetIFShift(int shift);
	BOOL					SetRFGain(int gain);
	BOOL					SetVolume(int vol);
	BOOL					SetPreAmp(int ampl);
	int						GetSMeter();
	void					SetSqlValue(int val);
	void					SetSquelch(int sql);
	int						GetSquelch();
	unsigned int			GetInfo(char *buf);

///////// IQ-Decoder ////

};

#pragma pack(pop)
#endif // !defined(WRG_DLL)
