////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project ExtIO_G33DDC
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////
#include "stdafx.h"
#include "GlobalTools.h"


BOOL WINAPI InitHW(char *name, char *model, int& type)
{
	//type = 6;	//Excalibur has its own digitizing 
				//and sends via callback 32-bit data

	type=7; //for level converting, we use only float
			//so we can without loss, multiply or divide 

	strcpy(name,"Excalibur Pro");
  	strcpy(model,"WR-G33DDC");
	if(!myCtrl.GetSafeHwnd())
		{
		AFX_MANAGE_STATE(AfxGetStaticModuleState( )); 
		myCtrl.Create(IDD_EXTIO_DIALOG,NULL);
		if(myCtrl.hDevice<0) 
			{
			AfxMessageBox("Excalibur Pro not ready");
			return FALSE;
			}
		}

	return TRUE;
}

BOOL WINAPI OpenHW(void)
{
	return TRUE;
}

int WINAPI StartHW(long freq)
{
	myCtrl.CodecStart();
	myCtrl.SetFrequency(freq);
	return 1<<IQ_spow;
}

void WINAPI StopHW(void)
{
	myCtrl.CodecStop();
}

void WINAPI CloseHW(void)
{
	myCtrl.Show_GUI(SW_HIDE);
}

int WINAPI SetHWLO(long LOfreq)
{
	myCtrl.SetFrequency(LOfreq);
	return lastFrq;
}

long WINAPI GetHWLO(void)
{
	return lastFrq;
}

long WINAPI GetHWSR(void)
{
	return IQ_freq;
}

long WINAPI GetTune(void)
{
	return lastFrq;
}

void WINAPI GetFilters(int& loCut, int& hiCut, int& pitch)
{
}

char WINAPI GetMode(void)
{
	return NULL;
}

void WINAPI ModeChanged(char mode)
{
}

//this prevent the WARNING LNK4022 (cannot find unique match for symbol "GetStatus")
//too many GetStatus-Routines are defined in the system 
extern "C"
int __stdcall GetStatus(void)
{
return 0; // status not supported by this specific HW,
}


void WINAPI ShowGUI(void)
{
	myCtrl.Show_GUI(SW_SHOW);
}

void WINAPI HideGUI(void)
{
	myCtrl.Show_GUI(SW_HIDE);
}

void WINAPI IFLimitsChanged(long low, long high)
{
}

void WINAPI TuneChanged(long freq)
{
}

//void extIOCallback(int cnt, int status, float IQoffs, short IQdata[])
typedef void (*DLL_extIOCallback)(int, int, float, unsigned char *);
DLL_extIOCallback extIOCallback=NULL;

void WINAPI SetCallback(void (* Callback)(int, int, float, unsigned char *))
{
	extIOCallback=Callback;
}

void WINAPI RawDataReady(long samprate, int *Ldata, int *Rdata, int numsamples)
{
}

//------------------------------------------
// expansions of dll routines and funktions
//------------------------------------------

void WINAPI InitExtIOPara(void* userPara)
{
	memcpy(&myPara,userPara,sizeof(EXTIQ_PARA));
}

HWND WINAPI GetExPara(EXTIQ_PARA *para)
{
	memcpy(para,&myPara,sizeof(EXTIQ_PARA));
	return myCtrl.m_hWnd;
}

void WINAPI SetExPara(EXTIQ_PARA *userPara)
{
	EXTIQ_PARA old;
	memcpy(&old,&myPara,sizeof(EXTIQ_PARA));
	memcpy(&myPara,userPara,sizeof(EXTIQ_PARA));
	
	if(old.dBOffset!=userPara->dBOffset) myCtrl.Set_dBmOffset(userPara->dBOffset);
	if(old.ATT!=userPara->ATT) myCtrl.Set_ATT(myPara.ATT);
	if(old.DIT!=userPara->DIT) myCtrl.Set_DIT(myPara.DIT);
	if(old.NB!=userPara->NB) myCtrl.Set_NB(myPara.NB);
	if(old.PRE!=userPara->PRE) myCtrl.Set_PRE(myPara.PRE);
}

void WINAPI SetSamples(int mode)
{
	if(mode!=myPara.mode) myCtrl.Set_Sample(mode);
}

void WINAPI SetAtt(int onoff)
{
	myCtrl.Set_ATT(onoff);
}

void WINAPI SetDither(int onoff)
{
	myCtrl.Set_DIT(onoff);
}

void WINAPI SetNB(int onoff)
{
	myCtrl.Set_NB(onoff);
}

void WINAPI SetLevelOffset(int set)
{
	myCtrl.Set_dBmOffset(set);
}