// ExternDlg.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project ExtIO_G33DDC
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExternDlg dialog

CExternDlg::CExternDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExternDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExternDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	visibility=SWP_HIDEWINDOW;
}

CExternDlg::~CExternDlg()
{
	if (m_hWnd != NULL)
		{
		DestroyWindow();
		}
}

void CExternDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExternDlg)
	DDX_Control(pDX, IDC_OFFSET,		b_dbSpin);
	DDX_Control(pDX, IDC_ATT,			b_att);
	DDX_Control(pDX, IDC_MANUAL,		b_manual);
	DDX_Control(pDX, IDC_SAMPLE_MENU,	b_samples);
	DDX_Control(pDX, IDC_LOGO,			b_logo);
	DDX_Control(pDX, IDC_DIT,			b_dit);
	DDX_Control(pDX, IDC_NB,			b_nb);
	DDX_Control(pDX, IDC_PRE,			b_pre);
	DDX_Control(pDX, IDC_OFFSET_TXT,	t_offs);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExternDlg, CDialog)
	//{{AFX_MSG_MAP(CExternDlg)
	ON_BN_CLICKED(IDC_ATT,				OnAtt)
	ON_BN_CLICKED(IDC_SAMPLE_MENU,		OnSetSamples)
	ON_BN_CLICKED(IDC_MANUAL,			OnManual)
	ON_BN_CLICKED(IDC_LOGO,				OnManual)
	ON_BN_CLICKED(IDC_DIT,				OnDit)
	ON_BN_CLICKED(IDC_NB,				OnNb)
	ON_BN_CLICKED(IDC_PRE,				OnPre)
	ON_NOTIFY(UDN_DELTAPOS, IDC_OFFSET, OnDeltaposOffset)
	ON_WM_CLOSE()
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExternDlg message handlers
BOOL CExternDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	DWORD  dwGetVer = GetVersion();
	int WinVersion=LOBYTE(LOWORD(dwGetVer));

	if(WinVersion>5) 
		{
		 //window 7 have an light background
		m_hIcon = AfxGetApp()->LoadIcon(IDR_G33DDC_ICON); 
		}
	else
		{
		//XP have an dark background
		m_hIcon = AfxGetApp()->LoadIcon(IDR_G33DDC_ICON_XP);	
		}

	SetIcon(m_hIcon, FALSE);		// Set small icon

	b_logo.m_bButtonStyle=1;
	b_logo.SetImage(IDB_G33DDCLOGO);


	// if myPara.msgHWND != NULL, then this ExtIO.dll is controlled by an application other than Winrad or clone.
	// Then, the communication with the Mircrosoft Message System is implemented - not the Mircrosoft untypical callback manner

	if(!myPara.msgHWND)
		{
		myPara.mode=GetProfileInt("PARAMETER","SampleMode",2);
		myPara.mode&=7;
		if(!myPara.msgHWND && myPara.mode>4) myPara.mode=4;

		myPara.ATT=GetProfileInt("PARAMETER","Attenuator",0);
		myPara.ATT&=3;
		myPara.DIT=GetProfileInt("PARAMETER","Dittering",0);
		myPara.DIT&=1;
		myPara.NB=GetProfileInt("PARAMETER","NoisBlanker",0);
		myPara.NB&=1;
		myPara.PRE=GetProfileInt("PARAMETER","PreAmpl",0);
		myPara.PRE&=1;

		myPara.dBOffset=GetProfileInt("PARAMETER","dBOffset",-174);
		if(myPara.dBOffset<200 || myPara.dBOffset>200) myPara.dBOffset=-174;
		}
	//else the parameter are all ready set of InitExtIOPara

	b_manual.SetBold(1); 
	b_manual.SetColor(RGB(196,0,0),1);
	b_manual.SetStyle(1);

	b_samples.SetMenu(IDR_SAMPLE_MENU);

	OpenExtRx();
	SetButtonState();

	CRect re;
	GetWindowRect(re);
	re.top=GetProfileInt("POSITION","WindowTop",re.top);
	re.left=GetProfileInt("POSITION","WindowLeft",re.left);
	SetWindowPos(NULL,re.left,re.top,0,0,SWP_NOACTIVATE|SWP_NOSIZE|visibility);

	return TRUE; 	              
}

void CExternDlg::OnCancel() 
{
	ShowWindow(SW_HIDE);
	if(myPara.msgHWND && myPara.msgSHOW) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,SW_HIDE,(LPARAM)m_hWnd);
}
void CExternDlg::OnOK() {}
void CExternDlg::OnClose() 
{
	ShowWindow(SW_HIDE);
	if(myPara.msgHWND && myPara.msgSHOW) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,SW_HIDE,(LPARAM)m_hWnd);
}

void CExternDlg::OnManual()
{
	ShellExecute(NULL, NULL,"http://www.bonito.net/manuals/radiojet/opensource", NULL,NULL, SW_SHOWNORMAL);
}

void CExternDlg::SetButtonState() 
{
	b_att.SetCheck(myPara.ATT);
	b_dit.SetCheck(myPara.DIT);
	b_nb.SetCheck(myPara.NB);
	b_pre.SetCheck(myPara.PRE);

	char txt[256];
	switch(myPara.mode)
		{
		case  0: strcpy(txt,"50 kHz Sample"); break;
		case  1: strcpy(txt,"100 kHz Sample"); break;
		case  2: strcpy(txt,"200 kHz Sample"); break;
		case  3: strcpy(txt,"500 kHz Sample"); break;
		case  4: strcpy(txt,"1.0 MHz Sample"); break;
		}
	b_samples.CheckMenuItem(myPara.mode,txt);

	sprintf(txt,"%d dB",myPara.dBOffset);
	t_offs.SetWindowText(txt);
}

void CExternDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	myPara.SHOW=bShow; //set the status
	if(myPara.msgHWND && myPara.msgSHOW) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,bShow,(LPARAM)m_hWnd);
}

void CExternDlg::OnDestroy() 
{
	CloseExtRx();
	
	if(!myPara.msgHWND)
		{
		WriteProfileInt("PARAMETER","SampleMode",myPara.mode);
		WriteProfileInt("PARAMETER","Attenuator",myPara.ATT);
		WriteProfileInt("PARAMETER","Dittering",myPara.DIT);
		WriteProfileInt("PARAMETER","NoisBlanker",myPara.NB);
		WriteProfileInt("PARAMETER","PreAmpl",myPara.PRE);
		WriteProfileInt("PARAMETER","dBOffset",myPara.dBOffset);
		}
	
	CRect re;
	GetWindowRect(re);
	WriteProfileInt("POSITION","WindowTop",re.top);
	WriteProfileInt("POSITION","WindowLeft",re.left);

	CDialog::OnDestroy();
}

void CExternDlg::Set_Sample(int mode)
{
	SetSampleMode(mode);
	SetButtonState();
	if(myPara.msgHWND && myPara.msgSMPL) ::PostMessage(myPara.msgHWND,myPara.msgSMPL,myPara.mode,(LPARAM)m_hWnd);
}

void CExternDlg::OnSetSamples()
{
	Set_Sample((b_samples.m_nMenuResult-IDC_SAMPLE_50K));
}

void CExternDlg::Show_GUI(int show)
{
	if(show) visibility=SWP_SHOWWINDOW;
	else visibility=SWP_HIDEWINDOW;
	if(myCtrl.GetSafeHwnd())
		{
		if(show)
			{
			if(!IsWindowVisible()) ShowWindow(SW_SHOW);
			SetForegroundWindow();
			}
		else
			{
			ShowWindow(SW_HIDE);
			}
		}
}

void CExternDlg::Set_ATT(int set)
{
	_SetATT(set);
	if(myPara.msgHWND && myPara.msgATT) ::PostMessage(myPara.msgHWND,myPara.msgATT,myPara.ATT,(LPARAM)m_hWnd);
	b_att.SetCheck(myPara.ATT);
}
void CExternDlg::OnAtt() 
{
	if(myPara.ATT) myPara.ATT=0;
	else myPara.ATT=1;
	Set_ATT(myPara.ATT);
}

void CExternDlg::Set_DIT(int set)
{
	_SetDither(set);
	if(myPara.msgHWND && myPara.msgDIT) ::PostMessage(myPara.msgHWND,myPara.msgDIT,myPara.DIT,(LPARAM)m_hWnd);
	b_dit.SetCheck(myPara.DIT);
}
void CExternDlg::OnDit() 
{
	if(myPara.DIT) myPara.DIT=0;
	else myPara.DIT=1;
	Set_DIT(myPara.DIT);
}

void CExternDlg::Set_NB(int set)
{
	_SetNB(set);
	if(myPara.msgHWND && myPara.msgNB) ::PostMessage(myPara.msgHWND,myPara.msgNB,myPara.NB,(LPARAM)m_hWnd);
	b_nb.SetCheck(myPara.NB);
}
void CExternDlg::OnNb() 
{
	if(myPara.NB) myPara.NB=0;
	else myPara.NB=1;
	Set_NB(myPara.NB);
}

void CExternDlg::Set_PRE(int set)
{
	_SetPRE(set);
	if(myPara.msgHWND && myPara.msgPRE) ::PostMessage(myPara.msgHWND,myPara.msgPRE,myPara.PRE,(LPARAM)m_hWnd);
	b_pre.SetCheck(myPara.PRE);
}
void CExternDlg::OnPre() 
{
	if(myPara.PRE) myPara.PRE=0;
	else myPara.PRE=1;
	Set_PRE(myPara.PRE);
}

void CExternDlg::Set_dBmOffset(int set)
{
	char txt[256];

	if(set<-200) set=-200;
	if(set>200) set=200;

	myPara.dBOffset=set;
	sprintf(txt,"%d dB",myPara.dBOffset);
	t_offs.SetWindowText(txt);
	if(myPara.msgHWND && myPara.msgOFFS) ::PostMessage(myPara.msgHWND,myPara.msgOFFS,myPara.dBOffset,(LPARAM)m_hWnd);

	if(!myPara.msgHWND)	
		{
		dBcorr=(float)pow(10,(double)(myPara.dBOffset)*.05);  //.05 = log20;
		}
	else dBcorr=1.f;
}

void CExternDlg::OnDeltaposOffset(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	Set_dBmOffset(myPara.dBOffset+=pNMUpDown->iDelta);
	*pResult = 0;
}
