#ifndef GLOBALTOOLS
#define GLOBALTOOLS

#include "resource.h"
#include  <io.h>
#include <direct.h>
#include "math.h"

#define USHORT unsigned short
#define UBYTE unsigned char

#include "G33DDCDLL.h"
#include "ExtIO_G33DDC.h"
#include "ExternDlg.h"

#pragma pack(1)

typedef struct
{
	HWND	msgHWND;	//the window handle for callback messages
	UINT	msgARRIVAL;	//the callback messages: the receiver has been inserted and becomes available
	UINT	msgREMOVED;	//the callback messages: the receiver has been removed and is no more available
	UINT	msgSHOW;	//the GUI calls this message if it is hidden or shown
	UINT	msgATT;		//the callback messages: the ATT has changet 
	UINT	msgAGC;		//the callback messages: the AGC has changet 
	UINT	msgPRE;		//the callback messages: the PreAmplifiere changet
	UINT	msgDIT;		//the callback messages: the Dithering has changed 
	UINT	msgNB;		//the callback messages: the NoisBlanker has changed
	UINT	msgFIL;		//the callback messages: the the FilterSelect has changed
	UINT	msgSMPL;	//the callback messages: the SampleRate has changed
	UINT	msgINFO;	//the callback messages: the InfoField has changed
	UINT	msgOFFS;	//the callback messages: the dBOffset has changed
	UINT	msgCORR;	//the callback messages: the FreqCorrecture has changed
	UINT	msgSCAL;	//the callback messages: the ScaleCorrecture has changed
	
	//the state of the last settings 
	BYTE	SHOW;		//0=hide 1=show
	BYTE	ATT;		//0-3 off=0, on=1-3
	BYTE	AGC;		//0-3 off=0, on=1-3			
	BYTE	PRE;		//off=0, on=1
	BYTE	DIT;		//off=0, on=1
	BYTE	NB;			//off=0, on=1
	BYTE	filter;		//filter bank switch seltion
	BYTE	mode;		//sample mode (max is 0-7)	
	short	dBOffset;	//the level offset in dB
	short	FreqCorrecture;		//the chip own individual frequency offset
	short   ScaleCorrecture;	//the chip own individual frq scaling distance (difference from Low-Frq to Hi-Frq in Hz)
	BYTE	InfoField[512];     //free for your own data structure or other individual use

}EXTIQ_PARA;

#pragma pack()


extern int			lastFrq;
extern int			IQ_freq,IQ_spow,DDCType;
extern CExternDlg	myCtrl;
extern EXTIQ_PARA	myPara;
extern UBYTE		WRT_BIT,PRE_BIT,ATT_BIT,NTIDRB32;


extern char			myDIR[256];
extern HCURSOR		m_Hand;
extern CFont		BigFont,fontBold,fontRegular;
extern COLORREF		COL_BACK,myLIGHT,myVLIGHT,myDARK,myVDARK,COL_BTXT;


COLORREF	WINAPI	AddBasisColor(COLORREF col, double luminace);
void		WINAPI	InitMyColors();
void		WINAPI	FillGradient (CDC *m_dc, CRect rect,COLORREF colorStart, COLORREF colorFinish, BOOL bHorz = TRUE);
void		WINAPI	DrawStyleRect(CDC* pDC, CRect& rect, COLORREF col);
UINT		WINAPI	GetProfileInt(char *AppName, char *KeyName, int value);
UINT		WINAPI	WriteProfileInt(char *AppName, char *KeyName, int value);
int			WINAPI	SetFiFiFreq(int freq);

#endif