// ExternDlg.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project ExtIO_SDRIQ
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExternDlg dialog

CExternDlg::CExternDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExternDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExternDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	visibility=SWP_HIDEWINDOW;
}

CExternDlg::~CExternDlg()
{
	if (m_hWnd != NULL)
		{
		DestroyWindow();
		}
}

void CExternDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExternDlg)
	DDX_Control(pDX, IDC_ATT,			b_att);
	DDX_Control(pDX, IDC_MANUAL,		b_manual);
	DDX_Control(pDX, IDC_SAMPLE_MENU,	b_samples);
	DDX_Control(pDX, IDC_LOGO,			b_logo);
	DDX_Control(pDX, IDC_HF_TXT,		t_HF);
	DDX_Control(pDX, IDC_IF_TXT,		t_IF);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExternDlg, CDialog)
	//{{AFX_MSG_MAP(CExternDlg)
	ON_WM_TIMER()
	ON_MESSAGE( MSG_STATUSCHNG,			OnStatusChange)
	ON_BN_CLICKED(IDC_ATT,				OnAtt)
	ON_BN_CLICKED(IDC_SAMPLE_MENU,		OnSetSamples)
	ON_BN_CLICKED(IDC_MANUAL,			OnManual)
	ON_BN_CLICKED(IDC_LOGO,				OnManual)
	ON_NOTIFY(UDN_DELTAPOS, IDC_IF_GAIN, OnSetIFGain)
	ON_NOTIFY(UDN_DELTAPOS, IDC_HF_GAIN, OnSetHFGain)
	ON_WM_CLOSE()
	ON_WM_SHOWWINDOW()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExternDlg message handlers
BOOL CExternDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	DWORD  dwGetVer = GetVersion();
	int WinVersion=LOBYTE(LOWORD(dwGetVer));

	if(WinVersion>5) 
		{
		 //window 7 have an light background
		m_hIcon = AfxGetApp()->LoadIcon(IDR_SDRIQ_ICON); 
		}
	else
		{
		//XP have an dark background
		m_hIcon = AfxGetApp()->LoadIcon(IDR_SDRIQ_ICON_XP);	
		}

	SetIcon(m_hIcon, FALSE);		// Set small icon

	b_logo.m_bButtonStyle=1;
	b_logo.SetImage(IDB_SDRIQ_LOGO);


	// if myPara.msgHWND != NULL, then this ExtIO.dll is controlled by an application other than Winrad or clone.
	// Then, the communication with the Mircrosoft Message System is implemented - not the Mircrosoft untypical callback manner

	if(!myPara.msgHWND)
		{
		myPara.mode=GetProfileInt("PARAMETER","SampleMode",2);
		myPara.mode&=7;
		myPara.ATT=GetProfileInt("PARAMETER","Attenuator",0);
		myPara.ATT&=3;
		myPara.dBOffset=GetProfileInt("PARAMETER","dBOffset",10);
		if(myPara.dBOffset<200 || myPara.dBOffset>200) myPara.dBOffset=10;
		}
	//else the parameter are all ready set of InitExtIOPara

	b_manual.SetBold(1); 
	b_manual.SetColor(RGB(196,0,0),1);
	b_manual.SetStyle(1);


	m_MSGhWnd=m_hWnd;
	OpenExtRx();


	if(m_SDRtype==SDRTYPE_IQ) b_samples.SetMenu(IDR_SAMPLE_MENU);
	else b_samples.SetMenu(IDR_SAMPLE_MENU1);


	SetButtonState();

	CRect re;
	GetWindowRect(re);
	re.top=GetProfileInt("POSITION","WindowTop",re.top);
	re.left=GetProfileInt("POSITION","WindowLeft",re.left);
	SetWindowPos(NULL,re.left,re.top,0,0,SWP_NOACTIVATE|SWP_NOSIZE|visibility);

	SetTimer(RESTART_ACTION_TIMER,2000,0);
	return TRUE; 	              
}

LRESULT CExternDlg::OnStatusChange(UINT status, LONG p2)
{
	switch(status)
		{
		case STATUS_NOTCONNECTED:	//Set USB-Device OFF 
									//myMainWnd->PostMessage(WM_USBRADIO_CHANGED,myCtrl->m_chn,2); 
									break;
		case STATUS_IDLECONNECTED:
			break;
		case STATUS_RUNNING:
			break;
		case STATUS_ERROR:
			break;
		}

	//m_LastStatus=status;
	return 0;
}

void CExternDlg::OnCancel() 
{
	ShowWindow(SW_HIDE);
	if(myPara.msgHWND && myPara.msgSHOW) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,SW_HIDE,(LPARAM)m_hWnd);
}
void CExternDlg::OnOK() {}
void CExternDlg::OnClose() 
{
	ShowWindow(SW_HIDE);
	if(myPara.msgHWND && myPara.msgSHOW) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,SW_HIDE,(LPARAM)m_hWnd);
}

void CExternDlg::OnManual()
{
	ShellExecute(NULL, NULL,"http://www.bonito.net/manuals/radiojet/opensource", NULL,NULL, SW_SHOWNORMAL);
}

void CExternDlg::SetButtonState() 
{
	b_att.SetCheck(myPara.ATT);

	char txt[256];
	switch(myPara.mode)
		{
		case  0: strcpy(txt,"55.555 kHz Sample"); break;
		case  1: strcpy(txt,"111.111 kHz Sample"); break;
		case  2: strcpy(txt,"196.078 kHz Sample"); break;
		case  3: strcpy(txt,"574.713 kHz Sample"); break;	//exist only in SDR-14
		case  4: strcpy(txt,"1282.051 kHz Sample"); break;	//exist only in SDR-14
		}
	b_samples.CheckMenuItem(myPara.mode,txt);
	Set_HFGainText(myPara.HFGain);
	Set_IFGainText(myPara.IFGain);
}

void CExternDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	myPara.SHOW=bShow; //set the status
	if(myPara.msgHWND && myPara.msgSHOW) ::PostMessage(myPara.msgHWND,myPara.msgSHOW,bShow,(LPARAM)m_hWnd);
}

void CExternDlg::OnDestroy() 
{
	CloseExtRx();
	
	if(!myPara.msgHWND)
		{
		WriteProfileInt("PARAMETER","SampleMode",myPara.mode);
		WriteProfileInt("PARAMETER","Attenuator",myPara.ATT);
		WriteProfileInt("PARAMETER","dBOffset",myPara.dBOffset);
		}
	
	CRect re;
	GetWindowRect(re);
	WriteProfileInt("POSITION","WindowTop",re.top);
	WriteProfileInt("POSITION","WindowLeft",re.left);

	CDialog::OnDestroy();
}

void CExternDlg::Set_Sample(int mode)
{
	SetSampleMode(mode);
	SetButtonState();
	if(myPara.msgHWND && myPara.msgSMPL) ::PostMessage(myPara.msgHWND,myPara.msgSMPL,myPara.mode,(LPARAM)m_hWnd);
}

void CExternDlg::OnSetSamples()
{
	Set_Sample((b_samples.m_nMenuResult-IDC_SAMPLE_50K));
}

void CExternDlg::Show_GUI(int show)
{
	if(show) visibility=SWP_SHOWWINDOW;
	else visibility=SWP_HIDEWINDOW;
	if(myCtrl.GetSafeHwnd())
		{
		if(show)
			{
			if(!IsWindowVisible()) ShowWindow(SW_SHOW);
			SetForegroundWindow();
			}
		else
			{
			ShowWindow(SW_HIDE);
			}
		}
}

void CExternDlg::Set_ATT(int set)
{
	SetATT(set);
	myPara.ATT=set;
	if(myPara.msgHWND && myPara.msgATT) ::PostMessage(myPara.msgHWND,myPara.msgATT,myPara.ATT,(LPARAM)m_hWnd);
	b_att.SetCheck(myPara.ATT);
}
void CExternDlg::OnAtt() 
{
	if(myPara.ATT) myPara.ATT=0;
	else myPara.ATT=1;
	Set_ATT(myPara.ATT);
}

void CExternDlg::Set_HFGainText(int set)
{
	char txt[256];
	if(set) sprintf(txt,"-%d dB",set);
	else  strcpy(txt,"0 dB");
	t_HF.SetWindowText(txt);
}

void CExternDlg::Set_IFGainText(int set)
{
	char txt[256];
	if(set) sprintf(txt,"+%d dB",set);
	else  strcpy(txt,"0 dB");
	t_IF.SetWindowText(txt);
}

void CExternDlg::Set_HFGain(int set)
{
	if(set<0) set=0;
	if(set>30) set=30;

	Set_HFGainText(set);
	if(set!=(int)myPara.HFGain)
		{
		myPara.HFGain=set;
		if(myPara.msgHWND && myPara.msgHF) ::PostMessage(myPara.msgHWND,myPara.msgHF,set,(LPARAM)m_hWnd);
		_Set_HFGain(set);
		}
}

void CExternDlg::OnSetHFGain(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	Set_HFGain(myPara.HFGain+(pNMUpDown->iDelta*10));
	*pResult = 0;
}

void CExternDlg::Set_IFGain(int set)
{
	if(set<0) set=0;
	if(set>24) set=24;

	Set_IFGainText(set);
	if(set!=(int)myPara.IFGain)
		{
		myPara.IFGain=set;
		if(myPara.msgHWND && myPara.msgIF) ::PostMessage(myPara.msgHWND,myPara.msgIF,set,(LPARAM)m_hWnd);
		_Set_IFGain(set);
		}
}

void CExternDlg::OnSetIFGain(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	Set_IFGain(myPara.IFGain-(pNMUpDown->iDelta*6));
	*pResult = 0;
}

void CExternDlg::OnTimer(UINT nIDEvent) 
{
	//hi SDR-IQ is sleeping
	myCtrl.CodecStop();
	myCtrl.CodecStart();
	KillTimer(RESTART_ACTION_TIMER);
}


