// FrqButton.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"
#include "FrqButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// FrqButton dialog
IMPLEMENT_DYNCREATE(FrqButton, CButton)

BEGIN_MESSAGE_MAP(FrqButton, CButton)
	//{{AFX_MSG_MAP(FrqButton)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_SETCURSOR()
	ON_WM_MOUSEWHEEL()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

FrqButton::FrqButton()
{
	FrqValue = 0;
	m_bgr = GetSysColor(COLOR_BTNFACE);
	m_txtcol = GetSysColor(COLOR_BTNTEXT);
	bkbr.CreateSolidBrush(m_bgr);
	init =0;
}

FrqButton::~FrqButton()
{
}


void FrqButton::Init() 
{
	if(!init)
		{
		myImageList.Create(IDB_FIGURES, 36, 1, RGB(255,255,255));
		}
	
	GetClientRect(my_size);

	Mid=my_size.Height()>>1;
	digit = 36; 
	int	ofs=(my_size.Width()-(digit*8))/2;
	r_7Seg=my_size;
	r_7Seg.left+=(my_size.Width()-(digit*8))/2;
	r_7Seg.right=r_7Seg.left+digit*8;
	r_7Seg.top+=18;
	r_7Seg.bottom+=18;
	init=1;
}

int FrqButton::Set(int frq)
{
	FrqValue=frq;
	RedrawWindow();
	return frq;
}

void FrqButton::DrawItem(LPDRAWITEMSTRUCT di) 
{
	CDC*		pDC=CDC::FromHandle(di->hDC);
	HDC			hdc=0;
	CDC			dc;
	CBitmap		bitmap;
	CBitmap*	pOldBitmap;
	int			i,xs,ys,xo,yo,fig=0;
	char		txt[32];

	if(!init) Init();

	try
		{
		xs = my_size.Width(); ys = my_size.Height();
		if (dc.CreateCompatibleDC(pDC))
			{
			if (bitmap.CreateCompatibleBitmap(pDC,xs, ys))
				{
				pOldBitmap = dc.SelectObject(&bitmap);
				}
			}

		hdc=dc.m_hDC;
		::FillRect(hdc,my_size,bkbr);
		yo =4;
		xo =my_size.right-36-4; 
		if(FrqValue>99999999) sprintf(txt,"%.2f",(double)FrqValue/1000.);
		else sprintf(txt,"%.3f",(double)FrqValue/1000.);
		for(i=(int)strlen(txt)-1; i>=0; i--)
			{
			if(txt[i] != '.') 
				{
				fig=(int)(txt[i]&0x0F);
				myImageList.Draw(&dc,fig,CPoint(xo,yo), ILD_TRANSPARENT);
				xo-=36;
				}
			else
				{
				if(FrqValue>99999999) myImageList.Draw(&dc,10,CPoint(my_size.right-82,yo+1), ILD_TRANSPARENT);
				else myImageList.Draw(&dc,10,CPoint(my_size.right-118,yo+1), ILD_TRANSPARENT);
				}
			}

		pDC->BitBlt(my_size.left,my_size.top,my_size.Width(),my_size.Height(),&dc, 0, 0, SRCCOPY);
		dc.SelectObject(pOldBitmap);
		}
	catch(...) {}

	ValidateRect(&my_size);
}


BOOL FrqButton::OnEraseBkgnd(CDC* /*pDC*/) 
{
	return TRUE;
}

void FrqButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if(point.y<Mid) SetFrq(point,1); 
	else SetFrq(point,0); 
	::SetCursor(m_FingerDown);
	CButton::OnLButtonDown(nFlags, point);
}

void FrqButton::OnRButtonDown(UINT nFlags, CPoint point) 
{
	SetFrq(point,0); 
	::SetCursor(m_FingerRight);
	CButton::OnRButtonDown(nFlags, point);
}

void FrqButton::SetFrq(CPoint point, int flag, int shift) 
{
	int val,step,f,d=8;
	::SetCursor (m_FingerDown);
	d=point.x/digit;

	val=FrqValue;
	switch(d)
		{
		case	0:	step=10000000; break;
		case	1:	step=1000000; break;
		case	2:	step=100000; break;
		case	3:	step=10000; break;
		case	4:	step=1000; break;
		case	5:	step=100; break;
		case	6:	step=10; break;
		default:
		case	7:	step=1; break;
		}
	if(FrqValue>99999999) step*=10;
	if(flag) f=val+step;
	else f=val-step;
	if(f>0) myMainFrm->SetFrq(f);
}

BOOL FrqButton::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	ScreenToClient (&pt);
	if(r_7Seg.PtInRect(pt))
		{
		pt.x-=r_7Seg.left;
		pt.y-=r_7Seg.top;
		int shift=0;
		if (nFlags & (MK_SHIFT|MK_CONTROL)) shift=1; 
		if(zDelta<0) SetFrq(pt,0,shift); 
		else SetFrq(pt,1,shift); 
		}
	return TRUE;
}

BOOL FrqButton::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	GetClientRect (my_size);

	CPoint ptCursor;
	::GetCursorPos (&ptCursor);
	ScreenToClient (&ptCursor);

	if (my_size.PtInRect (ptCursor))
		{
		::SetCursor(m_Hand);
		return TRUE;
		}

	return CButton::OnSetCursor(pWnd, nHitTest, message);
}
	
