// IFScopeControl.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"
#include "GetColorDlg.h"
#include "IFScopeControl.h"
#include "MyClasses/TimeUTC.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// IFScopeControl dialog


IFScopeControl::IFScopeControl(CWnd* pParent /*=NULL*/)
	: CDialog(IFScopeControl::IDD, pParent)
{
	//{{AFX_DATA_INIT(IFScopeControl)
	//}}AFX_DATA_INIT
	twoLines=CalibrationOff=0;
	CalibrationButton=10;
	amplChannel=CurveLo=ATTonoff=CurveStyle=lastFrq=-1;
	IFGainLevel=16;
	IFGainOff=1;
	m_ATT=m_CHN=0;
}


void IFScopeControl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(IFScopeControl)
	DDX_Control(pDX, IDC_AMPL_POTI,			p_Ampl);
	DDX_Control(pDX, IDC_WIDTH_POTI,		p_Width);
	DDX_Control(pDX, IDC_TOP_LEVEL,			pTopLevel);
	DDX_Control(pDX, IDC_TOP_AMPL,			pTopAmpl);
	DDX_Control(pDX, IDC_SCALE_POTI,		p_DecScale);
	DDX_Control(pDX, IDC_LEVEL_POTI,		p_DecLevel);
	DDX_Control(pDX, IDC_DELAY_POTI,		p_Delay);
	DDX_Control(pDX, IDC_REPEAT_POTI,		p_Repeat);
	DDX_Control(pDX, IDC_IF_CONTROL,		m_View);

	DDX_Control(pDX, IDC_IF_TOP_OFF,		b_topOFF);
	DDX_Control(pDX, IDC_IFSTYLE_TOP_LIN,	b_topLIN);
	DDX_Control(pDX, IDC_IFSTYLE_TOP_TSV,	b_topTSV);
	DDX_Control(pDX, IDC_IFSTYLE_LIN,		b_LIN);
	DDX_Control(pDX, IDC_IFSTYLE_TSV,		b_TSV);
	DDX_Control(pDX, IDC_PANORAMA_VIEW,		b_ExternView);
	DDX_Control(pDX, IDC_EXPAND,			b_EXP);
	DDX_Control(pDX, IDC_CHANGE_COL,		b_COL);

	DDX_Control(pDX, IDC_IFMSTYLE_TWO,		b_2Lines);
	DDX_Control(pDX, IDC_UNDO_ALLCOR,		b_resetStart);
	DDX_Control(pDX, IDC_RESET_ALLCOR,		b_resetDefault);

	DDX_Control(pDX, IDC_RADIO_CORR,		poti_cor);
	DDX_Control(pDX, IDC_RADIO_SCALE,		poti_scl);
	DDX_Control(pDX, IDC_AUDIO_SMPL,		poti_smpl);
	DDX_Control(pDX, IDC_RADIO_DXFAC,		poti_dxfac);

	DDX_Control(pDX, IDC_RADIO_COROFF,		b_FCOnOff);
	DDX_Control(pDX, IDC_RADIO_SCLOFF,		b_SCOnOff);
	DDX_Control(pDX, IDC_AUDIO_SMPLOFF,		b_ACOnOff);
	DDX_Control(pDX, IDC_RADIO_DXFACOFF,	b_DXOnOff);

	DDX_Control(pDX, IDC_RADIO_TXTSCL,		s_ScaleCorrecture);
	DDX_Control(pDX, IDC_RADIO_TXTCOR,		s_FreqCorrecture);
	DDX_Control(pDX, IDC_AUDIO_SMPLTXT,		s_AudioCorrecture);
	DDX_Control(pDX, IDC_RADIO_TXTDXFAC,	s_DXFactor);

	DDX_Text(pDX, IDC_RADIO_VID,			m_VID);
	DDX_Text(pDX, IDC_RADIO_PID,			m_PID);
	DDX_Text(pDX, IDC_RADIO_SERNR,			m_SRN);
	DDX_Text(pDX, IDC_MANUFACTURE,			m_MAN);
	DDX_Text(pDX, IDC_RADIO_GKEY,			m_GKY);
	DDX_Text(pDX, IDC_PRODUCT,				m_PRO);
	DDX_Text(pDX, IDC_RADIO_PKEY,			m_PROKey);
	DDX_Text(pDX, IDC_RADIO_DKEY,			m_DATKey);
	DDX_Text(pDX, IDC_PRO_DATE,				m_PRODate);
	DDX_Text(pDX, IDC_REG_DATE,				m_REGDate);
	DDX_Text(pDX, IDC_STARTUP_TXT,			m_StartUp);

	DDX_Control(pDX, IDC_GB1,				gb1);
	DDX_Control(pDX, IDC_GB2,				gb2);
	DDX_Control(pDX, IDC_GB3,				gb3);
	DDX_Control(pDX, IDC_GB4,				gb4);
	DDX_Control(pDX, IDC_GB5,				gb5);
	DDX_Control(pDX, IDC_GB12,				gb12);
	DDX_Control(pDX, IDC_SHOW_EXT_DLG,		b_ExtDLG);
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_DESIGN_1,			b_design[0]);
	DDX_Control(pDX, IDC_DESIGN_2,			b_design[1]);
	DDX_Control(pDX, IDC_DESIGN_3,			b_design[2]);

	DDX_Control(pDX, IDC_CALIB_0,			b_dB[0]);
	DDX_Control(pDX, IDC_CALIB_1,			b_dB[1]);
	DDX_Control(pDX, IDC_CALIB_2,			b_dB[2]);
	DDX_Control(pDX, IDC_CALIB_3,			b_dB[3]);
	DDX_Control(pDX, IDC_CALIB_4,			b_dB[4]);
	DDX_Control(pDX, IDC_CALIB_5,			b_dB[5]);
	DDX_Control(pDX, IDC_CALIB_6,			b_dB[6]);
	DDX_Control(pDX, IDC_CALIB_7,			b_dB[7]);
	DDX_Control(pDX, IDC_CALIB_8,			b_dB[8]);
	DDX_Control(pDX, IDC_CALIB_9,			b_dB[9]);
	DDX_Control(pDX, IDC_CALIB_10,			b_dB[10]);
	DDX_Control(pDX, IDC_CALIB_11,			b_dB[11]);
	DDX_Control(pDX, IDC_CALIB_12,			b_dB[12]);
	DDX_Control(pDX, IDC_CALIB_13,			b_dB[13]);
	DDX_Control(pDX, IDC_CALIB_14,			b_dB[14]);
	DDX_Control(pDX, IDC_CALIB_15,			b_dB[15]);
}


BEGIN_MESSAGE_MAP(IFScopeControl, CDialog)
	//{{AFX_MSG_MAP(IFScopeControl)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_IF_TOP_OFF,		OnIfTopOff)
	ON_BN_CLICKED(IDC_IFSTYLE_LIN,		OnIfstyleLin)
	ON_BN_CLICKED(IDC_IFSTYLE_TOP_LIN,	OnIfstyleTopLin)
	ON_BN_CLICKED(IDC_IFSTYLE_TOP_TSV,	OnIfstyleTopTsv)
	ON_BN_CLICKED(IDC_IFSTYLE_TSV,		OnIfstyleTsv)
	ON_BN_CLICKED(IDC_EXPAND,			OnExpandWindow)
	ON_BN_CLICKED(IDC_DESIGN_1,			OnDesign1)
	ON_BN_CLICKED(IDC_DESIGN_2,			OnDesign2)
	ON_BN_CLICKED(IDC_DESIGN_3,			OnDesign3)
	ON_BN_CLICKED(IDC_RESET_ALLCOR,		OnResetAllValues)
	ON_BN_CLICKED(IDC_UNDO_ALLCOR,		OnUndoAllValues)
	ON_BN_CLICKED(IDC_IFMSTYLE_TWO,		OnSetTwoLines)
	ON_BN_CLICKED(IDC_RADIO_SCLOFF,		OnSCOnOff)
	ON_BN_CLICKED(IDC_RADIO_COROFF,		OnFCOnOff)
	ON_BN_CLICKED(IDC_AUDIO_SMPLOFF,	OnACOnOff)
	ON_BN_CLICKED(IDC_RADIO_DXFACOFF,	OnDXOnOff)
	ON_BN_CLICKED(IDC_CHANGE_COL,		OnChangeColor)
	ON_BN_CLICKED(IDC_PANORAMA_VIEW,	OnViewPamorama)
	ON_BN_CLICKED(IDC_SHOW_EXT_DLG,		OnShowExtDialog)
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_CALIB_0,IDC_CALIB_15,OnSetdB)
	ON_MESSAGE(WM_POTICHANGE,			OnPotiChange)
	ON_MESSAGE(WM_RBCLICK,				OnRButtonClick)


END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IFScopeControl message handlers

BOOL IFScopeControl::OnInitDialog() 
{
	CDialog::OnInitDialog();


	//adjust the TestLineButtons in line
	CRect re,ra;
	b_dB[0].GetWindowRect(re);	ScreenToClient(re);
	b_dB[15].GetWindowRect(ra); ScreenToClient(ra); re.right=ra.right;
	SetVariButtonLine(re,b_dB,16);

	p_Delay.Init("Delay",100,2,NULL,SET_TOP);
	p_Ampl.Init("Bright",255,13,NULL,SET_LEFT);
	p_Width.Init("Width",24000,1000,NULL,SET_RIGHT); //spectrum band width in 24 steps
	p_Width.setValues=1; //view all times the value
	p_DecScale.Init("Scale",200,10,NULL,SET_LEFT);
	p_DecLevel.Init("Level",200,5,NULL,SET_TOP);
	p_Repeat.Init("Repeat",26,1,NULL,SET_TOP);

	poti_scl.Init("",2160,10,NULL,SET_TOP); 	
	poti_cor.Init("",2160,10,NULL,SET_TOP);		
	poti_smpl.Init("",2160,10,NULL,SET_TOP);	
	poti_dxfac.Init("",74,1,NULL,SET_TOP);	
	pTopLevel.Init("Level",540,10,NULL,SET_LEFT);
	pTopAmpl.Init("Ampl",540,10,NULL,SET_LEFT);

	myIFStyle.m_ampl=AfxGetApp()->GetProfileInt("SCOPE","Ampl",0);
	myIFPara.width=AfxGetApp()->GetProfileInt("SCOPE","Width",IF_SAMPLE_FRQ>>1);
	myIFPara.pos=AfxGetApp()->GetProfileInt("SCOPE","Position",0);
	myIFStyle.m_style=AfxGetApp()->GetProfileInt("SCOPE","Style",IF_STYLE_DEC);

	myIFStyle.topAmpl=AfxGetApp()->GetProfileInt("SCOPE","TopAmpl",0);
	myIFStyle.topLevel=AfxGetApp()->GetProfileInt("SCOPE","TopLevel",0);
	myIFStyle.topStyle=AfxGetApp()->GetProfileInt("SCOPE","TopStyle",IF_STYLE_TOP_TIV);
	myIFStyle.m_smoothing=AfxGetApp()->GetProfileInt("SCOPE","Delay",50);
	myIFStyle.topOFF=AfxGetApp()->GetProfileInt("SCOPE","TopOFF",0);
	myIFStyle.topYPos=AfxGetApp()->GetProfileInt("SCOPE","TopYPos",0);
	myIFStyle.m_amplCut=AfxGetApp()->GetProfileInt("SCOPE","AmplCut",0);
	myIFStyle.m_DecLevel=AfxGetApp()->GetProfileInt("SCOPE","DecLeve",100);
	myIFStyle.m_DecScale=AfxGetApp()->GetProfileInt("SCOPE","DecScale",0);
	myIFStyle.m_repeatation=AfxGetApp()->GetProfileInt("SCOPE","repeat",13);


	CalibFrq1=AfxGetApp()->GetProfileInt("RADIO","CalibFrq1",177000);	//the first best station in lower frequency area
	CalibFrq2=AfxGetApp()->GetProfileInt("RADIO","CalibFrq2",27000000);	//my test station in upper frequency area (from my meassure station) 

	
	//for my self I use an own knopface for the callibration area 	
/* 	poti_scl.SetFaceColor(RGB(185,182,182)); //brown knob desing
	poti_cor.SetFaceColor(RGB(185,182,182)); //brown knob desing
	poti_smpl.SetFaceColor(RGB(185,182,182)); //brown knob desing
	poti_dxfac.SetFaceColor(RGB(185,182,182)); //brown knob desing
*/

	p_Delay.Set(myIFStyle.m_smoothing);
	SetDecScale(myIFStyle.m_DecScale);
	SetDecLevel(myIFStyle.m_DecLevel);
	SetRepeat(myIFStyle.m_repeatation); 
	p_Ampl.Set(myIFStyle.m_ampl);
	p_Width.Set(myIFPara.width);
	b_topOFF.SetCheck(myIFStyle.topOFF);

	SetTopAmpl(myIFStyle.topAmpl);
	SetTopLevel(myIFStyle.topLevel);

	//set saturation color of COL_KNOBFACE[selectedDesign]
	b_design[0].SetColor(desCol[0],1); 
	b_design[1].SetColor(desCol[1],1); 
	b_design[2].SetColor(desCol[2],1); 

	b_design[0].SetStyle(TAB_BOTTON);
	b_design[1].SetStyle(TAB_BOTTON);
	b_design[2].SetStyle(TAB_BOTTON);

	b_COL.SetImage(IDB_PALETTE);

	//now init the View 
	m_View.Init();	
	//set the font of the all the info text lines
	GetDlgItem(IDC_RADIO_VID)->SetFont(&fixFont);
	GetDlgItem(IDC_RADIO_PID)->SetFont(&fixFont);
	GetDlgItem(IDC_RADIO_SERNR)->SetFont(&fixFont);
	GetDlgItem(IDC_MANUFACTURE)->SetFont(&BigFont);
	GetDlgItem(IDC_RADIO_GKEY)->SetFont(&fixFont);
	GetDlgItem(IDC_PRODUCT)->SetFont(&BigFont);
	GetDlgItem(IDC_RADIO_PKEY)->SetFont(&fixFont);
	GetDlgItem(IDC_RADIO_DKEY)->SetFont(&fixFont);
	GetDlgItem(IDC_PRO_DATE)->SetFont(&fixFont);
	GetDlgItem(IDC_REG_DATE)->SetFont(&fixFont);
	GetDlgItem(IDC_STARTUP_TXT)->SetFont(&fixFont);

	SetCalibrationMark(-1);	//switch any calibration parameter off
	SetCalibrationOnOff();
	DrawEEpromValues(1);
	SetDesingState();
	SetAllButtons();
	ViewInfo();
	SetCalibrationLine(m_View.DrawDoubleLine);
	myPanorama.Create(IDD_PANORAMA_CTRL,this);
	
	SetExtIQ();	
	

	CWnd*		pTemp= GetTopWindow();
	WINPOSION	wp;
	int			set;
  	while (pTemp)
		{
		set=0;
		switch(pTemp->GetDlgCtrlID())
			{
			case	IDC_IF_CONTROL:
			case	IDC_GB1:
			case	IDC_IF_TOP_OFF:
			case	IDC_IFSTYLE_TOP_LIN:
			case	IDC_IFSTYLE_TOP_TSV:
			case	IDC_TOP_LEVEL:
			case	IDC_TOP_AMPL: set=1;
			}
		if(!set)
			{
			pTemp->GetWindowRect(&wp.rect);
			ScreenToClient(&wp.rect);
			wp.win=pTemp;
			myWinList.Add(wp);
			}
		pTemp = pTemp->GetNextWindow();
        }

	m_View.GetWindowRect(myViewRect);
	ScreenToClient(myViewRect);

	return TRUE;               
}

void IFScopeControl::SetExtIQ()
{
	//if myEEpromInfo.RegistryDate==0 or or myExtRxPara.IQ_noAccess==1 then...
	//without a original RadioJet Directory, we are missing the ExtIQ-Directory too, that make big problems
	SetExtIODialog(myExtRxPara.IQ_showGUI);
	if(!myExtRxPara.IQ_noAccess)
		{
		SetExternView(myPanorama.IsWindowVisible()); 
		}
	else
		{
		b_ExternView.EnableWindow(FALSE);
		b_ExternView.SetImage(IDB_PANORAMA2);
		b_ExtDLG.EnableWindow(FALSE);
		}

	b_ExternView.RedrawWindow();
	b_ExtDLG.RedrawWindow();
}



HBRUSH IFScopeControl::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH bkbr =CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	if(nCtlColor==CTLCOLOR_STATIC) 	
		{
		switch(pWnd->GetDlgCtrlID())
			{
			case IDC_RADIO_VID:
			case IDC_RADIO_PID:
			case IDC_RADIO_SERNR:
			case IDC_MANUFACTURE:
			case IDC_RADIO_GKEY:
			case IDC_PRODUCT:
			case IDC_RADIO_PKEY:
			case IDC_RADIO_DKEY:
			case IDC_PRO_DATE:
			case IDC_REG_DATE:
			case IDC_STARTUP_TXT:	pDC->SetTextColor(myDesingTextColor); break;
			}
		}
	return bkbr;
}

void IFScopeControl::SetDesingState()
{
	for(int i=0; i<3; i++)
		{
		if(i==selectedDesign) b_design[i].SetCheck(1);
		else  b_design[i].SetCheck(0);
		}
	b_2Lines.SetCheck(twoLines);
}

void IFScopeControl::SetAllButtons(int set)
{
	SetDesingState();
	SetStyleState();
	b_dB[15].SetCheck(!CalibrationOff);
	SetCalibrationButtons();
	DrawEEpromValues(set);
}

LRESULT IFScopeControl::OnPotiChange(WPARAM wParam, LPARAM lParam)
{
	int x=(int)lParam;
	int pos=lParam;

	if((HWND)wParam==p_Ampl.m_hWnd)
		{
		SetAmpl(lParam);
		}
	else if((HWND)wParam==p_Width.m_hWnd)
		{
		SetWidth(lParam);
		}
	else if((HWND)wParam==p_Delay.m_hWnd)
		{
		SetDelay(pos);
		}
	else if((HWND)wParam==p_Repeat.m_hWnd) 
		{
		SetRepeat(pos); 
		}
	else if((HWND)wParam==poti_smpl.m_hWnd)
		{
		SetAudioCorrecture((short)lParam);
		SetAC();
		}
	else if((HWND)wParam==poti_cor.m_hWnd)
		{
		SetFreqCorrecture((short)lParam);
		SetFC();
		}
	else if((HWND)wParam==poti_scl.m_hWnd)
		{
		SetScaleCorrecture((short)lParam);
		SetSC();
		}
	else if((HWND)wParam==poti_dxfac.m_hWnd)
		{
		SetDxFactor((short)lParam);
		SetDX();
		}
	else if((HWND)wParam==pTopLevel.m_hWnd)
		{
		SetTopLevel(lParam);
		}
	else if((HWND)wParam==pTopAmpl.m_hWnd)
		{
		SetTopAmpl(lParam);
		}
	else if((HWND)wParam==p_DecScale.m_hWnd) 
		{
		SetDecScale(lParam);
		}
	else if((HWND)wParam==p_DecLevel.m_hWnd) 
		{
		SetDecLevel(lParam);
		}

	return NULL;
}
void IFScopeControl::SetTopLevel(int level)
{
	m_View.SetTLevel(level);
	pTopLevel.Set(level);
}

void IFScopeControl::SetTopAmpl(int ampl)
{
	m_View.SetTAmpl(ampl);
	pTopAmpl.Set(ampl);
}

void IFScopeControl::SetDelay(int delay) 
{
	myIFStyle.m_smoothing=delay;
	p_Delay.Set(delay);
	m_View.SetDelay(delay);
}
void IFScopeControl::SetRepeat(int repeat) 
{
	myIFStyle.m_repeatation=(BYTE)repeat;
	myPanoramaStyle.m_repeatation=(BYTE)repeat;
	p_Repeat.Set(repeat);
	myMainFrm->SetRepeatation(repeat);
}

void IFScopeControl::SetDecLevel(int level) 
{
	myIFStyle.m_DecLevel=level;
	p_DecLevel.Set(level);
	m_View.SetDecLevel(level);
}

void IFScopeControl::SetDecScale(int scale) 
{
	myIFStyle.m_DecScale=scale;
	p_DecScale.Set(scale);
	m_View.SetDecScale(scale);
}


void IFScopeControl::SetWidth(int pos)
{
	if(pos <1000) pos=1000;
	int mid=((myIFPara.m_hi+myIFPara.m_lo)/2)-(pos/2);
	if(mid<0) mid=0;
	myIFPara.pos=mid;
	myIFPara.width=pos;
	SetFilterParameter();
}

void IFScopeControl::SetPosition(int pos)
{
	myIFPara.pos=pos;
	SetFilterParameter();
}

void IFScopeControl::PotiNormalisation()
{
	int lo,hi,max=IF_SAMPLE_FRQ>>1;;

	if(myIFPara.width >max) myIFPara.width	=max;
	if(myIFPara.pos  >max) myIFPara.pos	=max;
	if(myIFPara.width <1000) myIFPara.width	=1000;
	if(myIFPara.pos	<0) myIFPara.pos=0;

	lo=myIFPara.pos;
	hi=lo+myIFPara.width;
	if(hi>max)
		{
		lo=max-myIFPara.width;
		hi=lo+myIFPara.width;
		}
	
	myIFPara.width=hi-lo;
	myIFPara.pos=lo;

	int pos=(int)((float)myIFPara.width/20.f+.5f)*20;

	p_Width.Set(pos);
	p_Ampl.Set(myIFStyle.m_ampl);

	myIFPara.m_lo=int(lo);
	myIFPara.m_hi=int(hi);
}

void IFScopeControl::SetAmpl(int ampl) 
{	
	myIFStyle.m_ampl=ampl;
	p_Ampl.Set(ampl);
	m_View.SetAmpl(myIFStyle.m_ampl);
	m_View.RefreschWindow(2);
}

void IFScopeControl::SetFilterParameter() 
{
	PotiNormalisation();
	m_View.OnFilterChanged();
	m_View.RefreschWindow(2);
	myPanorama.m_View.OnFilterChanged();
	myPanorama.m_View.RefreschWindow(2);
}

void IFScopeControl::OnIfTopOff() 
{
	if(myIFStyle.topOFF) myIFStyle.topOFF=0;
	else myIFStyle.topOFF=1;
	b_topOFF.SetCheck(myIFStyle.topOFF);
	m_View.ReSizeSpectrum(3);
}

void IFScopeControl::OnIfstyleTopLin() 
{
	if(myIFStyle.topStyle==IF_STYLE_TOP_DEC) myIFStyle.topStyle=IF_STYLE_TOP_TIV;
	else myIFStyle.topStyle=IF_STYLE_TOP_DEC;
	SetStyleState();
}

void IFScopeControl::OnIfstyleTopTsv() 
{
	if(myIFStyle.topStyle==IF_STYLE_TOP_TIV) myIFStyle.topStyle=IF_STYLE_TOP_DEC;
	else myIFStyle.topStyle=IF_STYLE_TOP_TIV;
	SetStyleState();
}

void IFScopeControl::OnIfstyleLin() 
{
	if(myIFStyle.m_style==IF_STYLE_DEC) myIFStyle.m_style=IF_STYLE_TIV;
	else myIFStyle.m_style=IF_STYLE_DEC;
	SetStyleState();
}

void IFScopeControl::OnIfstyleTsv() 
{
	if(myIFStyle.m_style==IF_STYLE_TIV) myIFStyle.m_style=IF_STYLE_DEC;
	else myIFStyle.m_style=IF_STYLE_TIV;
	SetStyleState();
}

void IFScopeControl::SetStyleState() 
{
	//set the state of all the style buttons
	b_topOFF.SetCheck(myIFStyle.topOFF);
	b_LIN.SetCheck(myIFStyle.m_style==IF_STYLE_DEC);
	b_TSV.SetCheck(myIFStyle.m_style!=IF_STYLE_DEC);
	b_topLIN.SetCheck(myIFStyle.topStyle==IF_STYLE_TOP_DEC);
	b_topTSV.SetCheck(myIFStyle.topStyle!=IF_STYLE_TOP_DEC);

	if(myIFStyle.m_style==IF_STYLE_DEC)
		{
		p_Ampl.EnableWindow(FALSE);	 //Ampitude on Lines is posible, but only for stupid people -> do not know the dBm scale is calibrated
		p_Delay.EnableWindow(TRUE);  //delay on Lines is now posible
		}
	else
		{
		p_Ampl.EnableWindow(TRUE);	 //on time spectrum is this like brighness
		p_Delay.EnableWindow(FALSE); //delay on time spectrum, does not look good
		}
}

void IFScopeControl::OnExpandWindow() 
{
	if(myMainFrm->m_MM==2) myMainFrm->Adjust(1);
	else myMainFrm->Adjust(2);
}

void IFScopeControl::Adjust(CRect &rect,int set) 
{
	CRect re;
	if(!NetBookFormat) 
		{
		SetWindowPos(NULL,rect.left,rect.top,rect.Width(),rect.Height(),SWP_SHOWWINDOW|MOVEALL);
		return;
		}

	//works only on Netbook Format <--- 1024 x 600


	int	Offset=0,show=SW_SHOW,i;
	if(set==2) 
		{
		Offset=NetBookFormat;
		show=SW_HIDE;
		}
		
	SetWindowPos(NULL,rect.left,rect.top,rect.Width(),rect.Height(),SWP_SHOWWINDOW|MOVEALL);

	gb1.ShowWindow(show);
	b_topOFF.ShowWindow(show);
	b_topLIN.ShowWindow(show);
	b_topTSV.ShowWindow(show);
	pTopLevel.ShowWindow(show);
	pTopAmpl.ShowWindow(show);

  	for(i=0; i<myWinList.GetSize(); i++)
		{
		re=myWinList[i].rect;
		myWinList[i].win->SetWindowPos(NULL,re.left,re.top-Offset,re.Width(),re.Height(),MOVEALL); 
        }
	b_EXP.GetWindowRect(re);
	ScreenToClient(re);
	myViewRect.bottom=re.bottom-1;

	m_View.SetWindowPos(NULL,myViewRect.left,myViewRect.top,myViewRect.Width(),myViewRect.Height(),NO_MOVE);
}

void IFScopeControl::ViewInfo()
{
	if((myEEpromInfo.WorkFlags&0x001))
		{
		m_MAN="NTi / Bonito";
		m_VID.Format("%04X",0x0D8C);
		m_PID.Format("%04X",0x0132);
		m_StartUp="56.32 MHz";

		if(DiRaWaveFlag) 
			{
			m_PRO="DiRaWave 0032U - 1";
			m_SRN="NTiDRW32U1";
			myMainFrm->SetWindowText(mTitle3);
			}
		else
			{
			m_PRO="RadioJet 1102S - 1";
			m_SRN="BORJ1102S1";
			myMainFrm->SetWindowText(mTitle2);
			}

		CTimeUTC rtim(myEEpromInfo.RegistryDate);
		CTimeUTC ptim(myEEpromInfo.CreationDate);
		if(myEEpromInfo.CreationDate) m_PRODate=ptim.Format("%d.%m.%Y");
		else m_PRODate="--.--.----";
	
		if((myEEpromInfo.RegistryDate))
			{
			m_VID.Format("%04X",myEEpromInfo.VID);
			m_PID.Format("%04X",myEEpromInfo.PID);

			m_REGDate=rtim.Format("%d.%m.%Y");
			m_GKY.Format("%s:%04X-%04X",myEEpromInfo.DeviceKey,(UINT)myEEpromInfo.WorkFlags>>16,(UINT)myEEpromInfo.WorkFlags&0x0000FFFF);
			m_PROKey.Format("%s:%04X-%04X",myEEpromInfo.PROKey,(UINT)myEEpromInfo.PPre>>16,(UINT)myEEpromInfo.PPre&0x0000FFFF);
			m_DATKey.Format("%s:%04X-%04X",myEEpromInfo.DATKey,(UINT)myEEpromInfo.DPre>>16,(UINT)myEEpromInfo.DPre&0x0000FFFF);
			}
		else
			{
			m_REGDate="--.--.----";
			m_GKY="UNDEFINED = MINIMAL NTi FACTORY VERSION";
			m_PROKey="--- UNDEFINED = SYSTEM IN LOW LEVEL STATE ---";
			m_DATKey="--- UNDEFINED = NO PnP FIRMWARE INSTALLED ---";
			}
		}
	else 
		{
		m_MAN.Empty();
		m_PID.Empty();
		m_VID.Empty();
		m_PRO="no Device connected";
		m_SRN.Empty();
		m_PRODate.Empty();
		m_REGDate.Empty();
		m_GKY.Empty();
		m_PROKey.Empty();
		m_DATKey.Empty();
		}

	UpdateData(FALSE);
}		


void IFScopeControl::SetDesign(int col) 
{
	for(int i=0; i<3; i++)
		{
		if(i==col) b_design[i].SetCheck(1);
		else  b_design[i].SetCheck(0);
		}
	InitGraficUtilitys(col);
	myMainFrm->RedrawWindow();
}

void IFScopeControl::OnDesign1() 
{
	SetDesign(0);
}

void IFScopeControl::OnDesign2() 
{
	SetDesign(1);
}

void IFScopeControl::OnDesign3() 
{
	SetDesign(2);
}

void IFScopeControl::OnSetTwoLines() 
{
	if(twoLines) twoLines=0;
	else twoLines=1;
	m_View.DrawDoubleLine=twoLines;
	b_2Lines.SetCheck(twoLines);
	SetDoubleLines();
}


////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// Calibration Routines //////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

#define EEpromReady (myEEpromInfo.WorkFlags&0x0001)


void IFScopeControl::SetDoubleLines() 
{
	if(!JetParaDXOnOff || twoLines) m_View.DrawDoubleLine=1;
	else m_View.DrawDoubleLine=0;
	SetCalibrationLine(m_View.DrawDoubleLine);
}

void IFScopeControl::ReadEEpromData() 
{
	memset(&myEEpromInfo,0,sizeof(RJ10_EEROM_INFO));
	GetEEpromInfo(&myEEpromInfo);
	//prepare the variant version of NTi
	if(myEEpromInfo.SerialNrString[0]=='N') DiRaWaveFlag=1;
	else DiRaWaveFlag=0;

}

void IFScopeControl::SetFC() 
{
	char buf[256];
	if(EEpromReady && !JetParaFCOnOff) 
		{
		s_FreqCorrecture.EnableWindow(TRUE);
		sprintf(buf,"%d Hz",-1080+JetParaFreqCorrecture);
		poti_cor.Set(JetParaFreqCorrecture);
		}
	else
		{
		s_FreqCorrecture.EnableWindow(FALSE);
		if(EEpromReady) sprintf(buf,"%d Hz",myEEpromInfo.FreqCorrecture);
		else strcpy(buf,"-.- Hz");
		poti_cor.Set(1080);
		}
	SetRadioFrqCorr(JetParaFreqCorrecture,JetParaFCOnOff);
	s_FreqCorrecture.SetWindowText(buf);
	b_FCOnOff.SetCheck(!JetParaFCOnOff);
	poti_cor.EnableWindow(!JetParaFCOnOff);
}

void IFScopeControl::SetSC() 
{
	char buf[256];
	if(EEpromReady && !JetParaSCOnOff) 
		{
		poti_scl.Set(JetParaScaleCorrecture);
		s_ScaleCorrecture.EnableWindow(TRUE);
		sprintf(buf,"%d Hz",-1080+JetParaScaleCorrecture);
		}
	else
		{
		s_ScaleCorrecture.EnableWindow(FALSE);
		if(EEpromReady) sprintf(buf,"%d Hz",myEEpromInfo.ScaleCorrecture);
		else strcpy(buf,"-.- Hz");
		poti_scl.Set(1080);
		}
	SetRadioFrqScale(JetParaScaleCorrecture,JetParaSCOnOff);
	s_ScaleCorrecture.SetWindowText(buf);
	b_SCOnOff.SetCheck(!JetParaSCOnOff);
	poti_scl.EnableWindow(!JetParaSCOnOff);
}

void IFScopeControl::SetAC() 
{
	char buf[256];
	if(EEpromReady && !JetParaACOnOff) 
		{
		poti_smpl.Set(JetParaAudioCorrecture);
		sprintf(buf,"%d Hz",-1080+JetParaAudioCorrecture);
		s_AudioCorrecture.EnableWindow(TRUE);
		}
	else
		{
		s_AudioCorrecture.EnableWindow(FALSE);
		if(EEpromReady) sprintf(buf,"%d Hz",myEEpromInfo.AudioCorrecture);
		else strcpy(buf,"-.- Hz");
		poti_smpl.Set(1080);
		}
	s_AudioCorrecture.EnableWindow(!JetParaACOnOff);
	SetAudioSampleCorr(JetParaAudioCorrecture,JetParaACOnOff);
	s_AudioCorrecture.SetWindowText(buf);
	b_ACOnOff.SetCheck(!JetParaACOnOff);
	poti_smpl.EnableWindow(!JetParaACOnOff);

	if(!JetParaACOnOff) myPanoramaView.SetBlueMark(-1080+JetParaAudioCorrecture);
	else myPanoramaView.SetBlueMark(-99999);
}

void IFScopeControl::SetDX() 
{
	char	buf[256];
	if(EEpromReady && !JetParaDXOnOff)
		{
		s_DXFactor.EnableWindow(TRUE);
		sprintf(buf,"%d dB",JetParaDxFactor);
		poti_dxfac.Set(JetParaDxFactor);
		}
	else
		{
		s_DXFactor.EnableWindow(FALSE);
		if(EEpromReady) sprintf(buf,"%d dB",myEEpromInfo.DxFactor);
		else strcpy(buf,"-.- dB");
		poti_dxfac.Set(37);
		}
	SetDXFactor(JetParaDxFactor,JetParaDXOnOff);
	s_DXFactor.SetWindowText(buf);
	b_DXOnOff.SetCheck(!JetParaDXOnOff);
	
	SetDoubleLines();
	poti_dxfac.EnableWindow(!JetParaDXOnOff);
}

void IFScopeControl::OnFCOnOff()
{
	BringBack();
	if(JetParaFCOnOff) 
		{
		SetFCOnOff(0);
		if(EEpromReady && JetParaFreqCorrecture==1080) SetFreqCorrecture(1080+myEEpromInfo.FC);
		BringTop(0);
		myMainFrm->SetFrq(CalibFrq1);
		}
	else 
		{
		SetFCOnOff(1);
		BringBack();
		}
	SetFC();
}

void IFScopeControl::OnSCOnOff()
{
	BringBack();
	if(JetParaSCOnOff) 
		{
		SetSCOnOff(0);
		if(EEpromReady && JetParaScaleCorrecture==1080) SetScaleCorrecture(1080+myEEpromInfo.SC);
		BringTop(0);
		myMainFrm->SetFrq(CalibFrq2);
		}
	else 
		{
		SetSCOnOff(1);
		BringBack();
		}
	SetSC();
}

void IFScopeControl::BringBack()
{
	if(CurveLo!=-1)
		{
		myIFPara.m_hi=CurveHi;
		myIFPara.m_lo=CurveLo;
		myIFPara.pos=CurvePos;
		myIFPara.width=CurveWidth;
		myIFStyle.m_style=CurveStyle;

		myMainFrm->IFGainLevel=IFGainLevel;
		myMainFrm->IFGainOff=IFGainOff;
		myMainFrm->SetGain();
		myMainFrm->SetATT(m_ATT); 
		myMainFrm->SetCHN(m_CHN); 

		SetWidth(CurveWidth);	
		CurveLo=-1;

		/*
		if(!JetParaDXOnOff) 
			{
			SetDXOnOff(1);
			SetDX();
			}*/
		if(lastFrq!=-1) 
			{
			myMainFrm->SetFrq(lastFrq);
			lastFrq=-1;
			}
		b_LIN.SetCheck(myIFStyle.m_style==IF_STYLE_DEC);
		b_TSV.SetCheck(myIFStyle.m_style!=IF_STYLE_DEC);
		}
}

void IFScopeControl::BringTop(int TSpec)
{
	BringBack(); 

	lastFrq=myMainFrm->m_frq;
	CurveHi=myIFPara.m_hi;
	CurveLo=myIFPara.m_lo;
	CurvePos=myIFPara.pos;
	CurveWidth=myIFPara.width;
	CurveStyle=myIFStyle.m_style;

	IFGainLevel=myMainFrm->IFGainLevel;
	IFGainOff=myMainFrm->IFGainOff;
	m_ATT=myMainFrm->m_ATT;
	m_CHN=myMainFrm->m_CHN;

	myMainFrm->IFGainOff=1;
	myMainFrm->IFGainLevel=myMainFrm->SaveIFGainLevel=16;
	myMainFrm->SetIFGain(16,1);
	myMainFrm->SetGain();
	myMainFrm->SetATT(0); 
	myMainFrm->SetCHN(0); 

	if(TSpec) myIFStyle.m_style=IF_STYLE_TIV;
	else myIFStyle.m_style=IF_STYLE_DEC;

	myIFPara.m_hi=14000; myIFPara.m_lo=10000;
	SetWidth(4000);
	b_LIN.SetCheck(myIFStyle.m_style==IF_STYLE_DEC);
	b_TSV.SetCheck(myIFStyle.m_style!=IF_STYLE_DEC);
}

void IFScopeControl::OnACOnOff()
{
	if(JetParaACOnOff) 
		{
		SetACOnOff(0);
		if(EEpromReady && JetParaAudioCorrecture==1080) SetAudioCorrecture(1080+myEEpromInfo.AC);
		}
	else 
		{
		SetACOnOff(1);
		}
	SetAC();
}

void IFScopeControl::OnDXOnOff()
{
	if(JetParaDXOnOff) 
		{
		if(EEpromReady && JetParaDxFactor==25) SetDxFactor(myEEpromInfo.DxFactor);
		BringTop(0);
		myMainFrm->SetFrq(CalibFrq1);
		SetDXOnOff(0);
		}
	else 
		{
		SetDXOnOff(1);
		BringBack();
		}
	SetDX();
}

void IFScopeControl::DrawEEpromValues(int save) 
{
	CString str;

	if(save)
		{
		ReadEEpromData();
		myFreqCorrecture=JetParaFreqCorrecture;
		myFC=myEEpromInfo.FC;
		myFCOnOff=JetParaFCOnOff;

		myScaleCorrecture=JetParaScaleCorrecture;
		mySC=myEEpromInfo.SC;
		mySCOnOff=JetParaSCOnOff;

		myAudioCorrecture=JetParaAudioCorrecture;
		myAC=myEEpromInfo.AC;
		myACOnOff=JetParaACOnOff;

		myDXFactor=JetParaDxFactor;
		myDX=myEEpromInfo.DX;
		myDXOnOff=JetParaDXOnOff;
		}

	b_SCOnOff.EnableWindow(EEpromReady);
	b_FCOnOff.EnableWindow(EEpromReady);
	b_ACOnOff.EnableWindow(EEpromReady);
	b_DXOnOff.EnableWindow(EEpromReady);

	SetSC();
	SetFC();
	SetAC();
	SetDX();
	if(save) ViewInfo();
}

BOOL  IFScopeControl::WriteValue(int type,int value) 
{
	if(AfxMessageBox("are your shure ? to burne this to EEprom ?",MB_YESNO)==IDYES)		
		{
		HandleEEpromValue(type,value);
		return TRUE;
		}
	return FALSE;
}


void IFScopeControl::OnSetdB(UINT id)
{
	if(id==IDC_CALIB_15) SetCalibrationOnOff();
	else 
		{
		CalibrationButton=id-IDC_CALIB_0;
		if(CalibrationOff) CalibrationOff=0;
		if(CalibrationButton==7) SetCalibrationMark(73);	
		else SetCalibrationMark(CalibrationButton*10);	
		SetCalibrationButtons();
		}
	b_dB[15].SetCheck(!CalibrationOff);
	m_View.ReSizeSpectrum(1);
}

void IFScopeControl::SetCalibrationButtons()
{
	for(int i=0; i<15; i++)
		{
		if(CalibrationOff) 
			{
			b_dB[i].SetCheck(0);
			b_dB[i].EnableWindow(0);
			}
		else
			{
			b_dB[i].EnableWindow(1);
			if(i==CalibrationButton) b_dB[i].SetCheck(1);
			else b_dB[i].SetCheck(0);
			}
		}
}

void IFScopeControl::SetCalibrationOnOff()
{
	if(CalibrationOff) 
		{
		BringTop(0);
		CalibrationOff=0;  //switch on
		SetCalibrationButtons();
		if(CalibrationButton==7) SetCalibrationMark(73);  // set exact s9	
		else SetCalibrationMark(CalibrationButton*10);		
		}
	else 
		{
		BringBack();
		CalibrationOff=1; //switch off
		SetCalibrationButtons();
		SetCalibrationMark(-1);	
		}
	b_dB[15].SetCheck(!CalibrationOff);
}


void IFScopeControl::OnResetAllValues() 
{

	if(AfxMessageBox("are your shure ? to reset to default factory calibration ?",MB_YESNO)==IDYES)		
		{
		//reset to default values
		HandleRadioValue(RADIO_WT_FC_DVALUE,0);
		HandleRadioValue(RADIO_WT_SC_DVALUE,0);
		HandleRadioValue(RADIO_WT_AC_DVALUE,0);
		HandleRadioValue(RADIO_WT_DX_DVALUE,0);
		ReadEEpromData();
		SetFCOnOff(1);
		SetSCOnOff(1);
		SetACOnOff(1);
		SetDXOnOff(1);
		SetAllButtons();
		}
}

void IFScopeControl::OnUndoAllValues() 
{
	if(AfxMessageBox("are your shure ? to reset all calibration values to the program start conditions ?",MB_YESNO)==IDYES)		
		{
		SetFreqCorrecture(myFreqCorrecture);
		SetScaleCorrecture(myScaleCorrecture);
		SetAudioCorrecture(myAudioCorrecture);
		SetDxFactor(myDXFactor);

		ReadEEpromData();
		SetFCOnOff(1);
		SetSCOnOff(1);
		SetACOnOff(1);
		SetDXOnOff(1);
		SetAllButtons();
		}
}

void IFScopeControl::OnChangeColor() 
{
	b_COL.SetCheck(1);
	GetColorDlg dlg(this);
	if(dlg.DoModal()==IDOK) 
		{
		b_design[0].SetColor(desCol[0],1); 
		b_design[1].SetColor(desCol[1],1); 
		b_design[2].SetColor(desCol[2],1); 
		}
	b_COL.SetCheck(0);
}

void IFScopeControl::ViewPamorama(int show) 
{
	//if myEEpromInfo.RegistryDate==0 or or myExtRxPara.IQ_noAccess==1 then...
	//without a original RadioJet Directory, we are missing the ExtIQ-Directory too, that make big problems
	if(show && !myExtRxPara.IQ_noAccess) myPanorama.ShowWindow(SW_SHOW);
	else myPanorama.ShowWindow(SW_HIDE);
	b_ExternView.SetCheck(myPanorama.IsWindowVisible());
	SetExternView(myPanorama.IsWindowVisible());
}

void IFScopeControl::OnViewPamorama() 
{
	ViewPamorama(!myPanorama.IsWindowVisible());
	AfxGetApp()->WriteProfileInt("PANORAMA","onoff",myPanorama.IsWindowVisible());
}

LRESULT IFScopeControl::OnRButtonClick(WPARAM wParam, LPARAM lParam) 
{
	if(wParam==IDC_PANORAMA_VIEW)
		{//reset the panorama window (maybe the window was outside of the screen)
		CRect myRect;
		myMainFrm->GetWindowRect(myRect);
		myRect.top=myRect.bottom-180; if(myRect.top<0) {myRect.top=0; myRect.bottom=180;}
		myPanorama.SetWindowPos(NULL,myRect.left,myRect.top,myRect.Width(),myRect.Height(),SWP_SHOWWINDOW|MOVEALL);
		b_ExternView.SetCheck(1);
		}

	return NULL;
}


void IFScopeControl::SetExtIODialog(int set) 
{
	//if myEEpromInfo.RegistryDate==0 or or myExtRxPara.IQ_noAccess==1 then...
	//without a original RadioJet Directory, we are missing the ExtIQ-Directory too, that make big problems
	if(b_ExtDLG.GetSafeHwnd())
		{
		if(!myExtRxPara.IQ_open || myExtRxPara.IQ_noAccess)
			{
			b_ExtDLG.SetCheck(0);
			myPanorama.b_ExtDLG.SetCheck(0);
			b_ExtDLG.SetImage(IDB_DLGBAR2);
			b_ExtDLG.EnableWindow(FALSE);
			}
		else
			{
			b_ExtDLG.EnableWindow(TRUE);
			b_ExtDLG.SetCheck(set);
			myPanorama.b_ExtDLG.SetCheck(set);
			if(set) 
				{
				b_ExtDLG.SetImage(IDB_DLGBAR1);
				myPanorama.b_ExtDLG.SetImage(IDB_DLGBAR1);
				}
			else
				{
				b_ExtDLG.SetImage(IDB_DLGBAR);
				myPanorama.b_ExtDLG.SetImage(IDB_DLGBAR);
				}
			}
		b_ExtDLG.RedrawWindow();
		}
}

void IFScopeControl::SetExternView(int set) 
{
	if(b_ExternView.GetSafeHwnd())
		{
		if(myExtRxPara.IQ_noAccess) b_ExternView.SetImage(IDB_PANORAMA2);
		else
			{
			b_ExternView.SetCheck(set);
			if(set) 
				{
				b_ExternView.SetImage(IDB_PANORAMA1);
				}
			else
				{
				b_ExternView.SetImage(IDB_PANORAMA);
				}
			}
		b_ExternView.RedrawWindow();
		}
}

void IFScopeControl::OnShowExtDialog() 
{
	if(!myPanoramaCtrl.IsWindowVisible()) myPanoramaCtrl.ShowWindow(SW_SHOW);
	myPanoramaCtrl.OnShowExtDialog();
}
