#if !defined(AFX_IFSCOPECONTROL_H__46CC71E4_4EDA_4600_8F34_A0E8DF0E1968__INCLUDED_)
#define AFX_IFSCOPECONTROL_H__46CC71E4_4EDA_4600_8F34_A0E8DF0E1968__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IFScopeControl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// IFScopeControl dialog

#include "MyClasses/MyIFView.h"
#include "MyClasses/MyPoti.h"
#include "MyClasses/MyButton.h"
#include "MyPanoramaCtrl.h"

class IFScopeControl : public CDialog
{
// Construction
public:
	IFScopeControl(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(IFScopeControl)
	enum { IDD = IDD_IF_SCOPE_CTRL };
	MyPoti		p_Ampl;
	MyPoti		p_Width;
	MyPoti		pTopLevel;
	MyPoti		pTopAmpl;

	MyIFView	m_View;

	MyButton	b_topOFF;
	MyButton	b_topLIN;
	MyButton	b_topTSV;
	MyButton	b_LIN;
	MyButton	b_TSV;
	MyButton	b_ExternView;
	MyButton	b_EXP;
	MyButton	b_COL;

	MyPoti		poti_cor;
	MyPoti		poti_scl;
	MyPoti		poti_smpl;
	MyPoti		poti_dxfac;

	MyPoti		p_DecScale;
	MyPoti		p_DecLevel;
	MyPoti		p_Delay;
	MyPoti		p_Repeat;


	CString		m_VID;
	CString		m_PID;
	CString		m_SRN;
	CString		m_MAN;
	CString		m_GKY;
	CString		m_PRO;
	CString		m_PROKey;
	CString		m_DATKey;
	CString		m_PRODate;
	CString		m_REGDate;
	CString		m_StartUp;

	CStatic		s_FreqCorrecture;
	CStatic		s_ScaleCorrecture;
	CStatic		s_AudioCorrecture;
	CStatic		s_DXFactor;

	MyButton	b_SCOnOff;
	MyButton	b_FCOnOff;
	MyButton	b_ACOnOff;
	MyButton	b_DXOnOff;

	MyButton	b_resetStart;
	MyButton	b_resetDefault;
	MyButton	b_2Lines;
	MyButton	b_ExtDLG;
	CStatic		gb1;
	CStatic		gb2;
	CStatic		gb3;
	CStatic		gb4;
	CStatic		gb5;
	CStatic		gb12;

	//}}AFX_DATA
	MyButton	b_dB[16];
	MyButton	b_design[3];
	RJ10_EEROM_INFO myEEpromInfo;
	MyPanoramaCtrl myPanorama;

	int			m_scale,twoLines,CalibrationOff,CalibrationButton,CalibFrq1,CalibFrq2,m_ATT,m_CHN,IFGainOff,IFGainLevel;
	int			CurveStyle,CurveHi,CurveLo,CurveWidth,CurvePos,amplChannel,ATTonoff,lastFrq;

	void		SetDelay(int delay);
	void		SetDecLevel(int level);
	void		SetDecScale(int scale);
	void		SetRepeat(int repeat);
	void		SetAmpl(int ampl);
	void		SetWidth(int pos);
	void		SetPosition(int pos);
	void		PotiNormalisation();
	void		SetFilterParameter(); 
	void		SetAllButtons(int set=0);
	void		SetDoubleLines();
	void		SetStyleState();
	void		SetDesingState();
	void		SetDesign(int col);
	void		SetTopLevel(int level);
	void		SetTopAmpl(int ampl);
	void		ViewInfo();
	void		SetExtIQ();

	int			myFreqCorrecture,myFC,myFCOnOff;
	int			myScaleCorrecture,mySC,mySCOnOff;
	int			myAudioCorrecture,myAC,myACOnOff;
	int			myDXFactor,myDX,myDXOnOff;


	void		ReadEEpromData();
	void		SetFC();
	void		SetSC();
	void		SetAC();
	void		SetDX(); 
	void		BringBack();
	void		BringTop(int TSpec);
	void		OnFCOnOff();
	void		OnSCOnOff();
	void		OnACOnOff();
	void		OnDXOnOff();
	void		DrawEEpromValues(int save=0);
	BOOL		WriteValue(int type,int value);
	void		SetCalibrationButtons();
	void		SetCalibrationOnOff();
	void		SetExtIODialog(int set);
	void		SetExternView(int set);
	void		ViewPamorama(int show);
	BOOL		GetColor(int reqID);

typedef struct	{
				CWnd*	win;
				RECT	rect;
				}WINPOSION;
typedef CArray<WINPOSION,WINPOSION&> WinList;

	WinList		myWinList;
	CRect		myViewRect;
	void		Adjust(CRect &rect,int set);



// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(IFScopeControl)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	//dummys
	virtual void OnCancel(){}
	virtual void OnOK(){}

	friend class CRJ10MiniDlg;
	// Generated message map functions
	//{{AFX_MSG(IFScopeControl)
	virtual BOOL OnInitDialog();
	virtual HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnIfTopOff();
	afx_msg void OnIfstyleLin();
	afx_msg void OnIfstyleTopLin();
	afx_msg void OnIfstyleTopTsv();
	afx_msg void OnIfstyleTsv();
	afx_msg void OnExpandWindow();
	afx_msg void OnDesign1();
	afx_msg void OnDesign2();
	afx_msg void OnDesign3();
	afx_msg void OnScaleOnOff();
	afx_msg void OnCorrOnOff();
	afx_msg void OnSmplOnOff();
	afx_msg void OnResetAllValues();
	afx_msg void OnUndoAllValues();
	afx_msg void OnSetTwoLines();
	afx_msg void OnChangeColor();
	afx_msg void OnViewPamorama();
	afx_msg void OnShowExtDialog();
	//}}AFX_MSG
	afx_msg void OnSetdB(UINT id);
	afx_msg LRESULT OnPotiChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRButtonClick(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IFSCOPECONTROL_H__46CC71E4_4EDA_4600_8F34_A0E8DF0E1968__INCLUDED_)
