// ExtIQControl.cpp : implementation file
//

#include "stdafx.h"
#include "../GlobalTools.h"
#include "ExtIQControl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ExtIQControl dialog


ExtIQControl::ExtIQControl(CWnd* pParent /*=NULL*/)
	: CDialog(ExtIQControl::IDD, pParent)
{
	//{{AFX_DATA_INIT(ExtIQControl)

	//}}AFX_DATA_INIT
	InDeviceSelect=0;
	i_start=i_stop=i_step=0;
	HFgainMax=30; HFgainStep=10;
	IFgainMax=24; IFgainStep=1;
}

void ExtIQControl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ExtIQControl)
	DDX_Control(pDX, IDC_PA_ONOFF,			b_OFF);
	DDX_Control(pDX, IDC_EXT_RADIO_SOUNDCARD,SoundCardSelction);
	DDX_Control(pDX, IDC_EXT_RADIO_CORR,	calib_cor);
	DDX_Control(pDX, IDC_EXT_RADIO_SCALE,	calib_scl);
	DDX_Control(pDX, IDC_EXT_RADIO_DBFAC,	calib_dBfac);
	DDX_Control(pDX, IDC_EXT_RADIO_HFGAIN,	HFGain);
	DDX_Control(pDX, IDC_EXT_RADIO_IFGAIN,	IFGain);
	DDX_Control(pDX, IDC_EXT_RADIO_TXTCOR,	s_FreqCorrecture);
	DDX_Control(pDX, IDC_EXT_RADIO_TXTSCL,	s_ScaleCorrecture);
	DDX_Control(pDX, IDC_EXT_RADIO_TXTDBFAC,s_dBFactor);
	DDX_Control(pDX, IDC_SAMPLE_RATE_MENU,	b_samples);

	DDX_Control(pDX, IDC_PA_ATT,			b_att);
	DDX_Control(pDX, IDC_PA_PRE,			b_pre);
	DDX_Control(pDX, IDC_PA_DIT,			b_dit);
	DDX_Control(pDX, IDC_PA_AGC,			b_agc);
	DDX_Control(pDX, IDC_PA_NB,				b_nb);

	DDX_Control(pDX, IDC_PA_TUNEROFFSET,	b_TunerOffset);
	DDX_Control(pDX, IDC_PA_AGC_TUNER,		b_TunerAGC);
	DDX_Control(pDX, IDC_PA_AGC_RTL,		b_RTLAGC);

	DDX_Control(pDX, IDC_ACTIVATE_RANGE,	b_activate_limiter);
	DDX_Control(pDX, IDC_SCANN_SPIN,		b_spin);
	
	DDX_Control(pDX, IDC_SCANN_RANGE,		t_range);
	DDX_Control(pDX, IDC_SCANN_START_TXT,	t_start);
	DDX_Control(pDX, IDC_SCANN_STOP_TXT,	t_stop);
	DDX_Control(pDX, IDC_SCANN_STEP_TXT,	t_step);
	DDX_Control(pDX, IDC_SCANN_START_FRQ,	e_start);
	DDX_Control(pDX, IDC_SCANN_STOP_FRQ,	e_stop);
	DDX_Control(pDX, IDC_SCANN_STEP_FRQ,	e_step);
	DDX_Text(pDX, IDC_SCANN_START_FRQ,		i_start);
	DDX_Text(pDX, IDC_SCANN_STOP_FRQ,		i_stop);
	DDX_Text(pDX, IDC_SCANN_STEP_FRQ,		i_step);

	DDX_Control(pDX, IDC_IQ_RECEIVER,		b_ReceiverSelect);
	DDX_Control(pDX, IDC_IQ_RECEIVER_CTRL,	b_show);

	DDX_Control(pDX, IDC_PA_STYLE_TOP_DEC,	b_topDEC);
	DDX_Control(pDX, IDC_PA_STYLE_TOP_TSV,	b_topTSV);
	DDX_Control(pDX, IDC_PA_STYLE_TOP_LEVEL,p_topLevel);
	DDX_Control(pDX, IDC_PA_STYLE_TOP_AMPL,	p_topAmpl);

	DDX_Control(pDX, IDC_PA_REPEAT_POTI,	p_Repeat);
	DDX_Control(pDX, IDC_PA_DELAY_POTI,		p_Delay);

	DDX_Control(pDX, IDC_DEC_OFFS_SMALL,	b_small);
	DDX_Control(pDX, IDC_DEC_OFFS_LARGE,	b_large);

	DDX_Control(pDX, IDC_PA_STYLE_DEC_SCALE,p_DecScale);
	DDX_Control(pDX, IDC_PA_STYLE_DEC_LEVEL,p_DecLevel);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_SCANN_KHZ1,		t_khz[0]);
	DDX_Control(pDX, IDC_SCANN_KHZ2,		t_khz[1]);
	DDX_Control(pDX, IDC_SCANN_KHZ3,		t_khz[2]);
	DDX_Control(pDX, IDC_PA_LOAD,			m_ctrl[0]);
	DDX_Control(pDX, IDC_PA_SAVE,			m_ctrl[1]);
	DDX_Control(pDX, IDC_PA_ASYNCHRON,		m_ctrl[2]);

}

BEGIN_MESSAGE_MAP(ExtIQControl, CDialog)
	//{{AFX_MSG_MAP(ExtIQControl)
	ON_BN_CLICKED(IDC_PA_STYLE_TOP_DEC,		OnSetTopDEC)
	ON_BN_CLICKED(IDC_PA_STYLE_TOP_TSV,		OnSetTopTSV)
	ON_BN_CLICKED(IDC_DEC_OFFS_SMALL,		OnSetSmall)
	ON_BN_CLICKED(IDC_DEC_OFFS_LARGE,		OnSetLarge)										
	ON_CBN_SELCHANGE(IDC_EXT_RADIO_SOUNDCARD,OnSelchangeCombo)
	ON_BN_CLICKED(IDC_PA_ONOFF,				OnExterRXoff)
	ON_BN_CLICKED(IDC_IQ_RECEIVER,			OnSetReceiver)
	ON_BN_CLICKED(IDC_IQ_RECEIVER_CTRL,		OnShowRxControl)
	ON_BN_CLICKED(IDC_SAMPLE_RATE_MENU,		OnSetSamples)
	ON_BN_CLICKED(IDC_PA_ATT,				OnSetATT)										
	ON_BN_CLICKED(IDC_PA_PRE,				OnSetPRE)
	ON_BN_CLICKED(IDC_PA_AGC,				OnSetAGC)
	ON_BN_CLICKED(IDC_PA_DIT,				OnSetDIT)
	ON_BN_CLICKED(IDC_PA_NB,				OnSetNB)
	ON_BN_CLICKED(IDC_PA_TUNEROFFSET,		OnSetTunerOffset)
	ON_BN_CLICKED(IDC_PA_AGC_TUNER,			OnSetTunerAGC)
	ON_BN_CLICKED(IDC_PA_AGC_RTL,			OnSetRTLAGC)
	ON_BN_CLICKED(IDC_PA_LOAD,				OnLoadConfig)
	ON_BN_CLICKED(IDC_PA_SAVE,				OnSaveConfig)
	ON_BN_CLICKED(IDC_PA_ASYNCHRON,			OnSetAsynchron)
	ON_BN_CLICKED(IDC_ACTIVATE_RANGE,		OnActivateRangeControl)
	ON_EN_CHANGE(IDC_SCANN_START_FRQ,		OnChangeScannStartFrq)
	ON_EN_CHANGE(IDC_SCANN_STOP_FRQ,		OnChangeScannStopFrq)
	ON_EN_CHANGE(IDC_SCANN_STEP_FRQ,		OnChangeScannStepFrq)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SCANN_SPIN, OnDeltaposScannSpin)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_POTICHANGE,				OnPotiChange)
	ON_MESSAGE(WM_RBCLICK,					OnSaveScaleLevel)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ExtIQControl message handlers

BOOL ExtIQControl::OnInitDialog() 
{
	CDialog::OnInitDialog();

	calib_scl.Init("",64000,100,NULL,SET_TOP);  // frq-sacling for +/- 32 kHz	in 10 Hz steps  (mouse & ctrl =1 Hz Step)
	calib_cor.Init("",64000,100,NULL,SET_TOP);	// frq-offset  for +/- 32 kHz		in 10 Hz steps  (mouse & ctrl =1 Hz Step)
	calib_dBfac.Init("",270,5,NULL,SET_TOP);	// spectrum scale dbm bottom level correction +/-135 dB  in 5 dBm steps
	HFGain.Init("HF-Gain",30,10,NULL,SET_LEFT);
	IFGain.Init("IF-Gain",24,6,NULL,SET_LEFT);

	p_topAmpl.Init("Ampl.",540,10,NULL,SET_LEFT);
	p_topLevel.Init("Level",540,10,NULL,SET_LEFT);
	p_Repeat.Init("Repeat",26,1,NULL,SET_TOP);
	p_Delay.Init("Delay",100,2,NULL,SET_TOP);
	p_DecScale.Init("Scale",200,10,NULL,SET_LEFT);
	p_DecLevel.Init("Level",200,5,NULL,SET_TOP);

	p_topAmpl.Set(myPanoramaStyle.topAmpl);
	p_topLevel.Set(myPanoramaStyle.topLevel);
	p_Delay.Set(myPanoramaStyle.m_smoothing);
	p_Repeat.Set(myIFStyle.m_repeatation);
	p_DecScale.Set(myPanoramaStyle.m_DecScale);
	p_DecLevel.Set(myPanoramaStyle.m_DecLevel);

	memcpy(&myExtRxPara,&RJ10ExtRxPara,sizeof(EXT_IQRX)); //get the work parameters for the extern IQ moduls

	SetXtalFrqCorr(myExtRxPara.XtalFrqCorr,0);
	SetXtalFrqScaling(myExtRxPara.XtalScalingCorr,0);
	SetDBOfset(myExtRxPara.dBLevelOffset,0);
	SetHFGain(myExtRxPara.HFGain,0); 
	SetIFGain(myExtRxPara.IFGain,0); 

	b_topDEC.SetCheck(myPanoramaStyle.topStyle!=(short)IF_STYLE_TOP_TIV);
	b_topTSV.SetCheck(myPanoramaStyle.topStyle==(short)IF_STYLE_TOP_TIV);

	receivers.DestroyMenu();
	receivers.CreatePopupMenu();

	//the next genaration of the RadioJet will have a extern Panorama Receiver
	int i=1;
	if(internPanorama) i=0;
	for(; i<MAX_IQ_RADIOS; i++)
		{
		receivers.AppendMenu(MF_STRING,IDR_EXTIQ_128+i,radios[i]);
		}
	b_ReceiverSelect.SetMenu(receivers.m_hMenu);

	SetReceiverType();
	SetDeviceList();
	SetButtons();
	SetGainPara();
	return TRUE; 
}

void ExtIQControl::OnCancel() 
{
	myPanoramaCtrl.SetExtIODialog(0);
	CDialog::OnCancel();
}

void ExtIQControl::OnClose() 
{
	myPanoramaCtrl.SetExtIODialog(0);
	CDialog::OnClose();
}

LRESULT ExtIQControl::OnPotiChange(WPARAM wParam, LPARAM lParam)
{
	if((HWND)wParam==p_topAmpl.m_hWnd) 
		{
		SetTopAmpl(lParam);
		}
	else if((HWND)wParam==p_topLevel.m_hWnd) 
		{
		SetTopLevel(lParam);
		}
	else if((HWND)wParam==p_Delay.m_hWnd) 
		{
		SetDelay(lParam); 
		}
	else if((HWND)wParam==p_Repeat.m_hWnd) 
		{
		SetRepeat(lParam); 
		}
	else if((HWND)wParam==p_DecScale.m_hWnd) 
		{
		SetDecScale(lParam);
		}
	else if((HWND)wParam==p_DecLevel.m_hWnd) 
		{
		SetDecLevel(lParam);
		}
	else if((HWND)wParam==calib_cor.m_hWnd)
		{
		SetXtalFrqCorr(-32000+(int)lParam);
		}
	else if((HWND)wParam==calib_scl.m_hWnd)
		{
		SetXtalFrqScaling(-32000+(int)lParam);
		}
	else if((HWND)wParam==calib_dBfac.m_hWnd)
		{
		SetDBOfset(-135+(int)lParam);
		}
	else if((HWND)wParam==HFGain.m_hWnd)
		{
		SetHFGain((int)lParam);
		}
	else if((HWND)wParam==IFGain.m_hWnd)
		{
		SetIFGain((int)lParam);
		}

	return NULL;
}

void ExtIQControl::SetDecLevel(int level) 
{
	p_DecLevel.Set(level);
	myPanoramaView.SetDecLevel(level);
}

void ExtIQControl::SetDecScale(int scale) 
{
	p_DecScale.Set(scale);
	myPanoramaView.SetDecScale(scale);
}

void ExtIQControl::SetTopLevel(int level)
{
	p_topLevel.Set(level);
	myPanoramaView.SetTLevel(level);
}

void ExtIQControl::SetTopAmpl(int ampl)
{
	p_topAmpl.Set(ampl);
	myPanoramaView.SetTAmpl(ampl);
}

void ExtIQControl::SetDelay(int delay) 
{
	p_Delay.Set(delay);
	myPanoramaView.SetDelay(delay);
}

void ExtIQControl::SetRepeat(int repeat) 
{
	myPanoramaStyle.m_repeatation=(BYTE)repeat;
	p_Repeat.Set(repeat);
	myMainFrm->SetRepeatation(repeat);
}

void ExtIQControl::SetSamples(int mode, int set) 
{
	myExtRxPara.IQ_mode=mode;
	if(set) 
		{
		SetExtIQData(&myExtRxPara);
		}

	SetButtons();
	if(set) 
		{
		myPanoramaCtrl.InitParameter(myExtRxPara.IQ_type);
		}
}

LRESULT ExtIQControl::OnExtIQRTLChange(WPARAM wParam, LPARAM lParam)
{
	SetButtons();
	SetHFGainValue();
	SetIFGainValue();
	return NULL;
}

void ExtIQControl::SetGainPara() 
{
	int HF_markpoint,IF_markpoint;
	if(myExtRxPara.IQ_type==ExtIO_TYPE_RTL2832 || myExtRxPara.IQ_type==ExtIO_TYPE_PANO)
		{
		HFgainMax=28; HFgainStep=1;
		IFgainMax=63; IFgainStep=1;
		HF_markpoint=SET_TOP;
		IF_markpoint=MARK_L14;
		}
	else 
		{
		HFgainMax=30; HFgainStep=10;
		IFgainMax=24; IFgainStep=1;
		HF_markpoint=SET_LEFT;
		IF_markpoint=SET_LEFT;
		}

	HFGain.myInfo.m_srange=HFgainMax;
	HFGain.m_largestep=HFgainStep;
	HFGain.myInfo.m_markpoint=HF_markpoint;
	SetHFGainValue();

	IFGain.myInfo.m_srange=IFgainMax;
	IFGain.m_largestep=IFgainStep;
	IFGain.myInfo.m_markpoint=IF_markpoint;
	SetIFGainValue();
}
void ExtIQControl::SetHFGainValue() 
{
	if(!myExtRxPara.HFGain) 
		{
		strcpy(HFGain.myInfo.ExtraText,"0 dB");
		}
	else
		{
		if(HFgainMax==30) 
			{
			sprintf(HFGain.myInfo.ExtraText,"+%d dB",myExtRxPara.HFGain);
			}	
		else 
			{
			int gains[] = { 0, 9, 14, 27, 37, 77, 87, 125, 144, 157,166, 197, 207, 229, 254, 280, 297, 328, 338, 384, 402, 426, 452, 481, 504, 529, 572, 600, 640 };
			//double gain=(double)gains[myExtRxPara.HFGain]/10.;
			//gain=(double)myExtRxPara.RTLPara.GainValues[myExtRxPara.HFGain]/10.;
			sprintf(HFGain.myInfo.ExtraText,"%.1f dB",(double)gains[myExtRxPara.HFGain]/10.);
			}
		}
	HFGain.Set(myExtRxPara.HFGain);
}

void ExtIQControl::SetHFGain(int gain, int set) 
{
	if(gain<0 || gain>=HFgainMax) gain=HFgainMax;
	myExtRxPara.HFGain=gain;
	if(set) SetExtIQData(&myExtRxPara);
	SetHFGainValue();
}

LRESULT ExtIQControl::OnExtIQHFGNChange(WPARAM wParam, LPARAM lParam)
{
	SetHFGain(wParam,1); 
	return NULL;
}

void ExtIQControl::SetIFGainValue() 
{
	if(!myExtRxPara.IFGain) 
		{
		strcpy(IFGain.myInfo.ExtraText,"0 dB");
		}
	else
		{
		sprintf(IFGain.myInfo.ExtraText,"%+d dB",-16+myExtRxPara.IFGain);
		}
	IFGain.Set(myExtRxPara.IFGain);
}

void ExtIQControl::SetIFGain(int gain, int set) 
{
	if(gain<0 || gain>IFgainMax) gain=0;
	myExtRxPara.IFGain=gain;
	SetIFGainValue();
	if(set) SetExtIQData(&myExtRxPara);
}

LRESULT ExtIQControl::OnExtIQIFGNChange(WPARAM wParam, LPARAM lParam)
{
	SetIFGain(wParam,1); 
	return NULL;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////// Calibration Routines //////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////

void ExtIQControl::SetXtalFrqCorr(int corr, int set) 
{
	char buf[256];
	if(corr<-32000 || corr>32000) corr=0;
	myExtRxPara.XtalFrqCorr=corr;
	sprintf(buf,"%d Hz",(int)myExtRxPara.XtalFrqCorr);
	s_FreqCorrecture.SetWindowText(buf);
	calib_cor.Set(32000+myExtRxPara.XtalFrqCorr);
	if(set) SetExtIQData(&myExtRxPara);
}

void ExtIQControl::SetXtalFrqScaling(int corr, int set) 
{
	char buf[256];
	if(corr<-32000 || corr>32000) corr=0;
	myExtRxPara.XtalScalingCorr=corr;
	sprintf(buf,"%d Hz",(int)myExtRxPara.XtalScalingCorr);
	s_ScaleCorrecture.SetWindowText(buf);
	calib_scl.Set(32000+myExtRxPara.XtalScalingCorr);
	if(set) SetExtIQData(&myExtRxPara);
}

void ExtIQControl::SetDBOfset(int corr, int set) 
{
	char	buf[256];
	if(corr<-135) corr=-135;
	if(corr>135) corr=135;
	myExtRxPara.dBLevelOffset=(short)corr;
	sprintf(buf,"%d dBm",(int)myExtRxPara.dBLevelOffset);
	s_dBFactor.SetWindowText(buf);
	calib_dBfac.Set(135+myExtRxPara.dBLevelOffset);
	if(set) SetExtIQData(&myExtRxPara);
}

void ExtIQControl::OnSetTopDEC() 
{
	myPanoramaStyle.topStyle=(short)IF_STYLE_TOP_DEC;
	myPanoramaView.RefreschWindow(2);
	b_topDEC.SetCheck(myPanoramaStyle.topStyle!=IF_STYLE_TOP_TIV);
	b_topTSV.SetCheck(myPanoramaStyle.topStyle==IF_STYLE_TOP_TIV);
}

void ExtIQControl::OnSetTopTSV() 
{
	myPanoramaStyle.topStyle=(short)IF_STYLE_TOP_TIV;
	myPanoramaView.RefreschWindow(2);
	b_topDEC.SetCheck(myPanoramaStyle.topStyle!=IF_STYLE_TOP_TIV);
	b_topTSV.SetCheck(myPanoramaStyle.topStyle==IF_STYLE_TOP_TIV);
}

void ExtIQControl::OnSetLarge() 
{
	SetDecScale(GetMyProfileInt("PANORAMA","DecScaleLarge",50)); 
	SetDecLevel(GetMyProfileInt("PANORAMA","DecLevelLarge",80)) ;
}

void ExtIQControl::OnSetSmall()
{
	SetDecScale(GetMyProfileInt("PANORAMA","DecScaleSmall",20)); 
	SetDecLevel(GetMyProfileInt("PANORAMA","DecLevelSmall",85)) ;
}

LRESULT ExtIQControl::OnSaveScaleLevel(WPARAM wParam, LPARAM lParam)
{
	if(wParam==IDC_DEC_OFFS_LARGE)
		{
		AfxGetApp()->WriteProfileInt("PANORAMA","DecScaleLarge",myPanoramaStyle.m_DecScale);
		AfxGetApp()->WriteProfileInt("PANORAMA","DecLevelLarge",myPanoramaStyle.m_DecLevel);
		}

	if(wParam==IDC_DEC_OFFS_SMALL)
		{
		AfxGetApp()->WriteProfileInt("PANORAMA","DecScaleSmall",myPanoramaStyle.m_DecScale);
		AfxGetApp()->WriteProfileInt("PANORAMA","DecLevelSmall",myPanoramaStyle.m_DecLevel);
		}
	return NULL;
}

void ExtIQControl::SetDeviceList(int set)
{
	InDeviceList &mDeviceList=GetInputDeviceList();
	myInDeviceList.RemoveAll();

	myInDeviceList.SetSize(mDeviceList.GetSize());
	memcpy(myInDeviceList.GetData(),mDeviceList.GetData(),sizeof(IN_DEVICE_INFO)*mDeviceList.GetSize());

	SoundCardSelction.ResetContent();
	InDeviceSelect=-1;
	for(int i=0; i<myInDeviceList.GetSize(); i++)
		{
		SoundCardSelction.AddString(myInDeviceList[i].name);
		if(strstr(myInDeviceList[i].name,myExtRxPara.IQ_SNDname)) InDeviceSelect=i;
		}
	if(InDeviceSelect!=-1) 
		{
		SoundCardSelction.SetCurSel(InDeviceSelect);
		myExtRxPara.IQ_reset=1;
		if(set) SetSamples(myExtRxPara.IQ_mode);
		}
	else 
		{
		if(set) myPanoramaView.ClearView();
		}
}

void ExtIQControl::OnSelchangeCombo() 
{
	UpdateData(TRUE);
	InDeviceSelect=SoundCardSelction.GetCurSel();
	if(InDeviceSelect>=0 && InDeviceSelect<myInDeviceList.GetSize())
		{
		strcpy(myExtRxPara.IQ_SNDname,myInDeviceList[InDeviceSelect].name);
		myExtRxPara.IQ_SNDinType=myInDeviceList[InDeviceSelect].type&1;
		myExtRxPara.IQ_reset=1;
		SetSamples(myExtRxPara.IQ_mode);
		}
}

void ExtIQControl::SetButtons()
{
	if(myExtRxPara.IQ_onoff) 
		{
		b_OFF.SetImage(IDB_ONOFF2);
		}
	else
		{
		b_OFF.SetImage(IDB_ONOFF);
		}
	b_OFF.SetCheck(myExtRxPara.IQ_onoff);
	b_show.SetCheck(myExtRxPara.IQ_showGUI);
	m_ctrl[2].SetCheck(myExtIQScanner.scann_asynchron);

	if(!myExtIQScanner.range_start[0] && !myExtIQScanner.range_stop[0]) 
		{
		myExtIQScanner.range_stop[0]=32000000;
		myExtIQScanner.range_start[0]=40000;
		myExtIQScanner.range_count=0;
		myExtIQScanner.mouse_stepwidth=myPanoramaView.MausSteps/1000;
		}

	m_ctrl[2].SetCheck(myExtIQScanner.scann_asynchron);
	SetRangEdit();
	EnableOptions();
}

void ExtIQControl::OnExterRXoff()
{
	if(myExtRxPara.IQ_onoff) myExtRxPara.IQ_onoff=0;
	else myExtRxPara.IQ_onoff=1;
	SetExtIQData(&myExtRxPara);
	SetButtons();
	SetReceiverType();
	myPanoramaView.ClearView();
}

void ExtIQControl::SetReceiverType()
{
	char txt[256];
	int pos=-1;

	if(!myExtRxPara.IQ_onoff) sprintf(txt,"ExtIQ-Selector is OFF"); 
	else switch(myExtRxPara.IQ_type)
		{
		default:	pos=-1; sprintf(txt,"ExtIQ-Selector"); break;
		case ExtIO_TYPE_PANO:	pos=0;	break;  //  RadioJet intern Panoram Receiver
		case ExtIO_TYPE_FIFI:	pos=1;	break;	//  FiFi-SDR   
		case ExtIO_TYPE_PAPP:	pos=2;	break;	//	Pappradio   
		case ExtIO_TYPE_FDM1:	pos=3;	break;	//	ELAD FDM-S  
		case ExtIO_TYPE_IQ14:	pos=4;	break;	//	SDR-IQ/SDR-14
		case ExtIO_TYPE_PMSDR:	pos=5;	break;	//	PM-SDR
		case ExtIO_TYPE_PERSEUS:pos=6;	break;	//	Perseus
		case ExtIO_TYPE_G31DCD: pos=7;  break;	//	Excalibur
		case ExtIO_TYPE_G33DCD: pos=8;  break;	//	Excalibur Pro
		}

	if(pos!=-1) strcpy(txt,radios[pos]); 

	b_ReceiverSelect.SetState(pos);
	b_ReceiverSelect.SetWindowText(txt);
	b_ReceiverSelect.RedrawWindow();
	if(pos>=0 &&::IsMenu(receivers.m_hMenu))
		{
		receivers.SetDefaultItem(pos+IDR_EXTIQ_128,FALSE);
		}
}

void ExtIQControl::OnSetReceiver()
{
	StopFlag=1;
	myPanoramaView.SetOff(DONT_DRAW); //do not draw
	int onoff=myExtRxPara.IQ_onoff;
	myExtRxPara.IQ_onoff=0; //switch receiver off
	SetExtIQData(&myExtRxPara);


	int type=0;
	switch(b_ReceiverSelect.m_nMenuResult)
		{
		default:
		case IDR_EXTIQ_128:	type=ExtIO_TYPE_PANO;	break;	//  FiFi-SDR  
		case IDR_EXTIQ_129:	type=ExtIO_TYPE_FIFI;	break;	//  FiFi-SDR  
		case IDR_EXTIQ_130:	type=ExtIO_TYPE_PAPP;	break;	//	Pappradio 
		case IDR_EXTIQ_131:	type=ExtIO_TYPE_FDM1;	break;	//	ELAD FDM-S
		case IDR_EXTIQ_132:	type=ExtIO_TYPE_IQ14;	break;	//	SDR-IQ/SDR-14
		case IDR_EXTIQ_133:	type=ExtIO_TYPE_PMSDR;	break;	//	PM-SDR
		case IDR_EXTIQ_134:	type=ExtIO_TYPE_PERSEUS;break;	//	Perseus
		case IDR_EXTIQ_135:	type=ExtIO_TYPE_G31DCD; break;	//	Excalibur
		case IDR_EXTIQ_136:	type=ExtIO_TYPE_G33DCD; break;	//	Excalibur Pro
		}

	myPanoramaCtrl.InitParameter(type);
	myExtRxPara.IQ_reset=1;
	if(onoff) myExtRxPara.IQ_onoff=1;
	else myExtRxPara.IQ_onoff=0;
	SetExtIQData(&myExtRxPara);
	SetState();
	myPanoramaView.SetOff(RESTORE_DRAW); //restore draw-off-state 
	StopFlag=0;
	SetGainPara();
}

void ExtIQControl::EnableOptions()
{
	if(myExtRxPara.IQ_type==ExtIO_TYPE_PANO)
		{
		b_TunerOffset.ShowWindow(SW_SHOW);
		b_TunerAGC.ShowWindow(SW_SHOW);
		b_RTLAGC.ShowWindow(SW_SHOW);
		b_att.ShowWindow(SW_HIDE);
		b_pre.ShowWindow(SW_HIDE);
		b_agc.ShowWindow(SW_HIDE);
		b_dit.ShowWindow(SW_HIDE);
		b_nb.ShowWindow(SW_HIDE);
		}
	else
		{
		b_TunerOffset.ShowWindow(SW_HIDE);
		b_TunerAGC.ShowWindow(SW_HIDE);
		b_RTLAGC.ShowWindow(SW_HIDE);
		b_att.ShowWindow(SW_SHOW);
		b_pre.ShowWindow(SW_SHOW);
		b_agc.ShowWindow(SW_SHOW);
		b_dit.ShowWindow(SW_SHOW);
		b_nb.ShowWindow(SW_SHOW);
		}


	if(!myExtRxPara.IQ_open)
		{
		b_TunerOffset.SetCheck(0);
		b_TunerAGC.SetCheck(0);
		b_RTLAGC.SetCheck(0);
		b_att.SetCheck(0);
		b_pre.SetCheck(0);
		b_agc.SetCheck(0);
		b_dit.SetCheck(0);
		b_nb.SetCheck(0);
		b_show.SetCheck(0);
		m_ctrl[2].SetCheck(0);
		b_activate_limiter.SetCheck(0);

		m_ctrl[2].EnableWindow(FALSE);
		m_ctrl[0].EnableWindow(FALSE);
		m_ctrl[1].EnableWindow(FALSE);
		SoundCardSelction.EnableWindow(FALSE);
		b_att.EnableWindow(FALSE);
		b_pre.EnableWindow(FALSE);
		b_dit.EnableWindow(FALSE);
		b_agc.EnableWindow(FALSE);
		b_nb.EnableWindow(FALSE);
		b_activate_limiter.EnableWindow(FALSE);
		b_show.EnableWindow(FALSE);
		calib_cor.EnableWindow(FALSE);
		calib_scl.EnableWindow(FALSE);
		calib_dBfac.EnableWindow(FALSE);
		HFGain.EnableWindow(FALSE);
		IFGain.EnableWindow(FALSE);
		b_spin.EnableWindow(FALSE);
		e_start.EnableWindow(FALSE);
		e_stop.EnableWindow(FALSE);
		e_step.EnableWindow(FALSE);
		}
	else
		{
		b_activate_limiter.EnableWindow(TRUE);
		e_start.EnableWindow(TRUE);
		e_stop.EnableWindow(TRUE);
		e_step.EnableWindow(TRUE);
		b_show.EnableWindow(TRUE);
		b_spin.EnableWindow(TRUE);
		m_ctrl[2].EnableWindow(TRUE);
		m_ctrl[0].EnableWindow(TRUE);
		m_ctrl[1].EnableWindow(TRUE);
		calib_cor.EnableWindow(TRUE);
		calib_scl.EnableWindow(TRUE);
		calib_dBfac.EnableWindow(TRUE);
		m_ctrl[2].SetCheck(myExtIQScanner.scann_asynchron);
		SoundCardSelction.EnableWindow(myExtRxPara.IQ_soundcard);
		b_activate_limiter.SetCheck(myExtIQScanner.range_active);
		b_att.EnableWindow(myExtRxPara.IQ_att);
		b_pre.EnableWindow(myExtRxPara.IQ_pre);
		b_agc.EnableWindow(myExtRxPara.IQ_agc);
		b_dit.EnableWindow(myExtRxPara.IQ_dit);
		b_nb.EnableWindow(myExtRxPara.IQ_nb);
		b_TunerOffset.SetCheck(myExtRxPara.RTLPara.TuningOffset);
		b_TunerAGC.SetCheck(myExtRxPara.RTLPara.AGC_Tuner);
		b_RTLAGC.SetCheck(myExtRxPara.RTLPara.AGC_RTL);
		HFGain.EnableWindow(myExtRxPara.IQ_HFGain);
		IFGain.EnableWindow(myExtRxPara.IQ_IFGain);
		if(myExtRxPara.IQ_att) b_att.SetCheck(myExtRxPara.m_att);
		else b_att.SetCheck(0);
		if(myExtRxPara.IQ_pre) b_pre.SetCheck(myExtRxPara.m_pre);
		else b_pre.SetCheck(0);
		if(myExtRxPara.IQ_agc) b_agc.SetCheck(myExtRxPara.m_agc);
		else b_agc.SetCheck(0);
		if(myExtRxPara.IQ_dit) b_dit.SetCheck(myExtRxPara.m_dit);
		else b_dit.SetCheck(0);
		if(myExtRxPara.IQ_dit) b_nb.SetCheck(myExtRxPara.m_nb);
		else b_nb.SetCheck(0);
		}
}

void ExtIQControl::OnShowRxControl()
{
	if(myExtRxPara.IQ_showGUI) myExtRxPara.IQ_showGUI=0;
	else myExtRxPara.IQ_showGUI=1;
	myExtRxPara.IQ_showGUIex=1;
	SetExtIQData(&myExtRxPara);
	b_show.SetCheck(myExtRxPara.IQ_showGUI);
}

void ExtIQControl::SetState()
{
	SetReceiverType();
	SetRepeat(myIFStyle.m_repeatation); 
	CreateSampleMenu();
	SetButtons();
	SetXtalFrqCorr(myExtRxPara.XtalFrqCorr,0);
	SetXtalFrqScaling(myExtRxPara.XtalScalingCorr,0);
	SetDBOfset(myExtRxPara.dBLevelOffset,0);
	myPanoramaView.RefreschWindow(2);
}

void ExtIQControl::SetSampleSelect(int sel)
{
	char buf[256];

	myExtRxPara.IQ_mode=sel&7;
	if(myExtRxPara.IQ_mode>7) myExtRxPara.IQ_mode=7;
loopErr:
	if(!myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq) 
		{
		if(myExtRxPara.IQ_mode) 
			{
			myExtRxPara.IQ_mode-=1;
			goto loopErr;
			}
		}
	if(myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_multiplex)  sprintf(buf,"Multipex %.3f kHz Spectrum Width",(double)myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq/1000.);
	else 
		{
		if(myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq>999999) sprintf(buf,"%.3f MHz Sample && Spectrum Width",(double)myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq/1000000.);
		else sprintf(buf,"%.3f kHz Sample && Spectrum Width",(double)myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq/1000.);
		}
	b_samples.SetWindowText(buf);
	b_samples.RedrawWindow();

	if(!myExtRxPara.IQ_noSampleSelect) 
		{
		b_samples.SetState(myExtRxPara.IQ_mode);
		if(::IsMenu(samples.m_hMenu))
			{
			samples.SetDefaultItem(myExtRxPara.IQ_mode+IDR_EXTIQ_SAMPLE_FRQ_0,FALSE);
			}
		}
}

void ExtIQControl::CreateSampleMenu()
{
	char buf[256];

	if(myExtRxPara.IQ_noSampleSelect) //do not built a SampleMenu - ExtIO-DLL Call SetSample not exist
		{
		b_samples.SetMenu((HMENU)NULL);
		sprintf(buf,"%.3f kHz Sample && Spectrum Width",(double)myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq/1000.);
		b_samples.SetWindowText(buf);
		b_samples.RedrawWindow();
		}
	else 
		{
		samples.DestroyMenu();
		samples.CreatePopupMenu();
		int	seperator=0;
	
		for(int i=0; i<8; i++)
			{
			if(!myExtRxPara.RTLPara.SampleSets[i].IQ_freq) break;
			if(myExtRxPara.RTLPara.SampleSets[i].IQ_multiplex) continue;
				/*{ in this version we do not assemble multiplexd scann data
				if(!seperator) 
					{
					seperator=1;
					samples.AppendMenu(MF_SEPARATOR,MF_SEPARATOR);
					}
				sprintf(buf,"Multipex %.3f kHz Spectrum Width",(double)myExtRxPara.RTLPara.SampleSets[i].IQ_freq/1000.);
				}*/
			else 	 
				{
				if(myExtRxPara.RTLPara.SampleSets[i].IQ_freq>999999) sprintf(buf,"%.3f MHz Sample && Spectrum Width",(double)myExtRxPara.RTLPara.SampleSets[i].IQ_freq/1000000.);
				else sprintf(buf,"%.3f kHz Sample && Spectrum Width",(double)myExtRxPara.RTLPara.SampleSets[i].IQ_freq/1000.);
				} 
				
			samples.AppendMenu(MF_STRING,IDR_EXTIQ_SAMPLE_FRQ_0+i,buf);
			}
		b_samples.SetMenu(samples.m_hMenu);
		}
	SetSampleSelect(myExtRxPara.IQ_mode);
}

void ExtIQControl::OnSetSamples()
{
	StopFlag=1;
	while(IQinpuThreadWorkFlag) Sleep(0);
	SetSampleSelect(b_samples.m_nMenuResult-IDR_EXTIQ_SAMPLE_FRQ_0);
	myPanoramaCtrl.InitParameter(myExtRxPara.IQ_type);
	myExtRxPara.IQ_reset=1;
	SetExtIQData(&myExtRxPara);
	SetState();
	StopFlag=0;
}

LRESULT ExtIQControl::OnExtIQSHOWChange(WPARAM wParam, LPARAM lParam)
{
	if(wParam==SW_HIDE) 
		{
		myExtRxPara.IQ_showGUI=0;
		}
	else 
		{
		myExtRxPara.IQ_showGUI=1;
		}
	myExtRxPara.IQ_showGUIex=0;
	b_show.SetCheck(myExtRxPara.IQ_showGUI);
	return NULL;
}

void ExtIQControl::OnSetAGC()
{
	if(myExtRxPara.m_agc) myExtRxPara.m_agc=0;
	else myExtRxPara.m_agc=1;
	SetExtIQData(&myExtRxPara);
}

LRESULT ExtIQControl::OnExtIQAGCChange(WPARAM wParam, LPARAM lParam)
{
	b_agc.SetCheck(wParam);
	if(wParam) myExtRxPara.m_agc=1;
	else myExtRxPara.m_agc=0;
	return NULL;
}

void ExtIQControl::OnSetDIT()
{
	if(myExtRxPara.m_dit) myExtRxPara.m_dit=0;
	else myExtRxPara.m_dit=1;
	SetExtIQData(&myExtRxPara);
}
LRESULT ExtIQControl::OnExtIQDITChange(WPARAM wParam, LPARAM lParam)
{
	b_dit.SetCheck(wParam);
	if(wParam) myExtRxPara.m_dit=1;
	else myExtRxPara.m_dit=0;
	return NULL;
}

void ExtIQControl::OnSetTunerOffset()
{
	if(myExtRxPara.RTLPara.TuningOffset) myExtRxPara.RTLPara.TuningOffset=0;
	else myExtRxPara.RTLPara.TuningOffset=1;
myExtRxPara.IQ_reset=0;
	SetExtIQData(&myExtRxPara);
	b_TunerOffset.SetCheck(myExtRxPara.RTLPara.TuningOffset);
}

void ExtIQControl::OnSetTunerAGC()
{
	if(myExtRxPara.RTLPara.AGC_Tuner) myExtRxPara.RTLPara.AGC_Tuner=0;
	else myExtRxPara.RTLPara.AGC_Tuner=1;
myExtRxPara.IQ_reset=0;
	SetExtIQData(&myExtRxPara);	
	b_TunerAGC.SetCheck(myExtRxPara.RTLPara.AGC_Tuner);
	if(myExtRxPara.IQ_type==ExtIO_TYPE_PANO)
		{
		if(myExtRxPara.RTLPara.AGC_Tuner) 
			{
			HFGain.EnableWindow(FALSE);
			}
		else 
			{
			HFGain.EnableWindow(TRUE);
			}
		}
}

void ExtIQControl::OnSetRTLAGC()
{
	if(myExtRxPara.RTLPara.AGC_RTL) myExtRxPara.RTLPara.AGC_RTL=0;
	else myExtRxPara.RTLPara.AGC_RTL=1;
myExtRxPara.IQ_reset=0;
	SetExtIQData(&myExtRxPara);
	b_RTLAGC.SetCheck(myExtRxPara.RTLPara.AGC_RTL);
}


void ExtIQControl::OnSetNB()
{
	if(myExtRxPara.m_nb) myExtRxPara.m_nb=0;
	else myExtRxPara.m_nb=1;
	SetExtIQData(&myExtRxPara);
}

LRESULT ExtIQControl::OnExtIQNBChange(WPARAM wParam, LPARAM lParam)
{
	b_att.SetCheck(wParam);
	if(wParam) myExtRxPara.m_nb=1;
	else myExtRxPara.m_nb=0;
	return NULL;
}

void ExtIQControl::OnSetATT()
{
	if(myExtRxPara.m_att) myExtRxPara.m_att=0;
	else myExtRxPara.m_att=1;
	SetExtIQData(&myExtRxPara);
}

LRESULT ExtIQControl::OnExtIQATTChange(WPARAM wParam, LPARAM lParam)
{
	b_att.SetCheck(wParam);
	if(wParam) myExtRxPara.m_att=1;
	else myExtRxPara.m_att=0;
	return NULL;
}

void ExtIQControl::OnSetPRE()
{
	if(myExtRxPara.m_pre) myExtRxPara.m_pre=0;
	else myExtRxPara.m_pre=1;
	SetExtIQData(&myExtRxPara);
}

LRESULT ExtIQControl::OnExtIQPREChange(WPARAM wParam, LPARAM lParam)
{
	b_pre.SetCheck(wParam);
	if(wParam) myExtRxPara.m_pre=1;
	else myExtRxPara.m_pre=0;
	return NULL;
}

LRESULT ExtIQControl::OnExtIQSampleChange(WPARAM wParam, LPARAM lParam)
{
	int i;

	if(lParam==-2)
		{
		for(i=0; i<8; i++)
			{
			if(myExtRxPara.RTLPara.SampleSets[i].IQ_freq==(UINT)wParam)
				{
				wParam=i;
				goto set;
				}
			}
		return NULL;
		}

	if(lParam==-1)
		{
		myExtRxPara.RTLPara.SampleSets[7].IQ_freq=wParam;
		int x_spow=0, num=myExtRxPara.RTLPara.SampleSets[7].IQ_freq/24; 
		for(i=0; i<24; i++)
			{
			num>>=1;
			if(num) x_spow++;
			else break;
			}
		myExtRxPara.RTLPara.SampleSets[7].IQ_spow=x_spow-6;
		wParam=7;
		}

set:
	SetSampleSelect(wParam);
	myPanoramaCtrl.InitParameter(myExtRxPara.IQ_type);
	return NULL;
}

void ExtIQControl::OnActivateRangeControl()
{
	if(myExtIQScanner.range_active) myExtIQScanner.range_active=0;
	else myExtIQScanner.range_active=1;
	b_activate_limiter.SetCheck(myExtIQScanner.range_active);
}

void ExtIQControl::SetRangEdit()
{
	i_start=myExtIQScanner.range_start[myExtIQScanner.range_count]/1000;
	i_stop=myExtIQScanner.range_stop[myExtIQScanner.range_count]/1000;
	i_step=myExtIQScanner.mouse_stepwidth;
	UpdateData(FALSE);
	
	CString str;
	str.Format("%d.Range",myExtIQScanner.range_count+1);
	t_range.SetWindowText(str);
	t_range.RedrawWindow();
}

void ExtIQControl::OnDeltaposScannSpin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
	if(pNMUpDown->iDelta<0)
		{
		if(myExtIQScanner.range_count<15) myExtIQScanner.range_count++;
		}
	else
		{
		if(myExtIQScanner.range_count) myExtIQScanner.range_count--;
		}
	SetRangEdit();
	*pResult = 0;
}

void ExtIQControl::OnChangeScannStartFrq() 
{
	UpdateData(TRUE);
	myExtIQScanner.range_start[myExtIQScanner.range_count]=i_start*1000;
//	UpdateData(FALSE);
}

void ExtIQControl::OnChangeScannStopFrq() 
{
	UpdateData(TRUE);
	myExtIQScanner.range_stop[myExtIQScanner.range_count]=i_stop*1000;
//	UpdateData(FALSE);	
}

void ExtIQControl::OnChangeScannStepFrq() 
{
	UpdateData(TRUE);
	myExtIQScanner.mouse_stepwidth=i_step;
//	UpdateData(FALSE);
}

void ExtIQControl::LoadConfig(CString &file) 
{
	FILE *fi;
	fi=fopen(file,"r");
	if(fi)
		{
		for(int i=0; i<16; i++) fscanf(fi,"%d,%d\n",&myExtIQScanner.range_start[i],&myExtIQScanner.range_stop[i]);
		fscanf(fi,"%d\n",&i); myExtIQScanner.mouse_stepwidth=i;
		fscanf(fi,"%d\n",&i); myExtIQScanner.range_active=i;
		fscanf(fi,"%d\n",&i); myExtIQScanner.range_count=i;
		fscanf(fi,"%d\n",&i); myExtIQScanner.scann_asynchron=i;
		fclose(fi);
		SetButtons();
		}
}

void ExtIQControl::OnLoadConfig() 
{
	CString	file;
	char	buf[512];
	sprintf(buf,"%s\\Data",myDIR);
	CFileDialog fdlg(TRUE, "*.pan","*.pan",OFN_FILEMUSTEXIST|OFN_SHAREAWARE|OFN_NOVALIDATE,"ExtIO-Config (*.pan)|*.pan");
	fdlg.m_ofn.lpstrTitle = "Load a new ExtIO Control Configuration";
	fdlg.m_ofn.lpstrInitialDir =buf;
	if(fdlg.DoModal()==IDOK)
		{
		file=fdlg.GetPathName();
		file.MakeUpper();
		file.Replace(".PAN","");
		file+=".PAN";
		LoadConfig(file);
		}
}

void ExtIQControl::SaveConfig(CString &file) 
{
	FILE *fi;
	file.MakeUpper();
	fi=fopen(file,"w");
	if(fi)
		{
		for(int i=0; i<16; i++) fprintf(fi,"%d,%d\n",myExtIQScanner.range_start[i],myExtIQScanner.range_stop[i]);
		fprintf(fi,"%d\n",myExtIQScanner.mouse_stepwidth);
		fprintf(fi,"%d\n",myExtIQScanner.range_active);
		fprintf(fi,"%d\n",myExtIQScanner.range_count);
		fprintf(fi,"%d\n",myExtIQScanner.scann_asynchron);
		fclose(fi);
		}
}

void ExtIQControl::OnSaveConfig() 
{
	CString	file;
	char	buf[512];
	sprintf(buf,"%s\\Data",myDIR);
	CFileDialog fdlg(FALSE, "*.pan","*.pan",OFN_NOCHANGEDIR|OFN_OVERWRITEPROMPT|OFN_SHAREAWARE|OFN_NOVALIDATE,"ExtIO-Config (*.pan)|*.pan");
	fdlg.m_ofn.lpstrTitle = "SaveAs a new ExtIO Control Configuration";
	fdlg.m_ofn.lpstrInitialDir =buf;
	if(fdlg.DoModal()==IDOK)
		{
		file=fdlg.GetPathName();
		file.MakeUpper();
		file.Replace(".PAN","");
		file+=".PAN";
		SaveConfig(file);
		}
}

void ExtIQControl::SetAsynchron(int set) 
{
	if(set)
		{
		myExtIQScanner.scann_asynchron=1;
		myExtIQScanner.AsynchronWindow=myPanoramaView.m_hWnd;
		myPanoramaView.OnDrawFrequency(myMainFrm->m_frq,myMainFrm->m_frq);
		}
	else
		{	
		myExtIQScanner.scann_asynchron=0;
		myExtIQScanner.AsynchronWindow=NULL;
		myPanoramaView.OnDrawFrequency(myMainFrm->m_frq,myMainFrm->m_frq);
		}
	m_ctrl[2].SetCheck(myExtIQScanner.scann_asynchron);
}

void ExtIQControl::OnSetAsynchron() 
{
	if(myExtIQScanner.scann_asynchron) SetAsynchron(0);
	else SetAsynchron(1);
}