#if !defined(EXT_IQ_CONTRO)
#define EXT_IQ_CONTRO

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ExtIQControl.h : header file
//

#include "MyPoti.h"
#include "MyButton.h"

/////////////////////////////////////////////////////////////////////////////
// ExtIQControl dialog
class ExtIQControl : public CDialog
{
// Construction
public:
	ExtIQControl(CWnd* pParent = NULL);   // standard constructor
// Dialog Data
	//{{AFX_DATA(ExtIQControl)
	enum { IDD = IDD_EXTIO_DIALOG };

	MyButton	b_OFF;
	MyPoti		calib_cor;
	MyPoti		calib_scl;
	MyPoti		calib_dBfac;
	MyPoti		HFGain;
	MyPoti		IFGain;
	CStatic		s_FreqCorrecture;
	CStatic		s_ScaleCorrecture;
	CStatic		s_dBFactor;
	MyButton	b_att;
	MyButton	b_pre;
	MyButton	b_dit;
	MyButton	b_agc;
	MyButton	b_nb;
	MyButton	b_TunerOffset;
	MyButton	b_TunerAGC;
	MyButton	b_RTLAGC;
	MyButton	b_activate_limiter;
	MyButton	b_ReceiverSelect;
	MyButton	b_show;
	CComboBox	SoundCardSelction;
	MyButton	b_samples;
	CSpinButtonCtrl	b_spin;
	CStatic		t_range;
	CStatic		t_start;
	CStatic		t_stop;
	CStatic		t_step;
	CEdit		e_start;
	CEdit		e_stop;
	CEdit		e_step;
	int			i_start;
	int			i_stop;
	int			i_step;

	MyPoti		p_topLevel;
	MyPoti		p_topAmpl;
	MyButton	b_topDEC;
	MyButton	b_topTSV;

	MyPoti		p_Delay;
	MyPoti		p_Repeat;

	MyButton	b_small;
	MyButton	b_large;

	MyPoti		p_DecScale;
	MyPoti		p_DecLevel;
	//}}AFX_DATA

	friend class IFStyle;
	
	int			InDeviceSelect,HFgainMax,HFgainStep,IFgainMax,IFgainStep;
	COLORREF	OFFCol;
	CMenu		samples,receivers;
	CStatic		t_khz[3];
	MyButton	m_ctrl[3];

	void		SetTopLevel(int level);
	void		SetTopAmpl(int ampl);
	void		SetDecLevel(int level);
	void		SetDecScale(int scale);
	void		SetDeviceList(int set=0);
	void		SetDelay(int delay);
	void		SetRepeat(int repeat);

	void		SetXtalFrqCorr(int corr,int set=1);
	void		SetXtalFrqScaling(int corr, int set=1);
	void		SetDBOfset(int corr,int set=1);
	void		SetGainPara();
	void		SetGainValue();
	void		SetIFGain(int gain,int set=1); 
	void		SetIFGainValue();
	void		SetHFGain(int gain,int set=1); 
	void		SetHFGainValue();
	void		SetSamples(int mode, int set=1); 
	void		SetButtons();
	void		SetReceiverType();
	void		EnableOptions();
	void		SetState();
	void		CreateSampleMenu();
	void		SetSampleSelect(int sel);
	void		SetRangEdit();
	void		SetAsynchron(int set);
	void		LoadConfig(CString &file);
	void		SaveConfig(CString &file);

	LRESULT		OnExtIQSHOWChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQATTChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQPREChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQAGCChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQDITChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQNBChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQIFGNChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQHFGNChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQSampleChange(WPARAM wParam, LPARAM lParam);
	LRESULT		OnExtIQRTLChange(WPARAM wParam, LPARAM lParam);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ExtIQControl)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ExtIQControl)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeCombo();
	afx_msg void OnExterRXoff();
	afx_msg void OnSetReceiver();
	afx_msg void OnShowRxControl();
	afx_msg void OnSetSamples();
	virtual void OnCancel();
	afx_msg void OnClose();
	afx_msg void OnSetATT();
	afx_msg void OnSetPRE();
	afx_msg void OnSetAGC();
	afx_msg void OnSetDIT();
	afx_msg void OnSetNB();
	afx_msg void OnSetRTLAGC();
	afx_msg void OnSetTunerAGC();
	afx_msg void OnSetTunerOffset();
	afx_msg void OnLoadConfig();
	afx_msg void OnSaveConfig();
	afx_msg void OnSetAsynchron();
	afx_msg void OnActivateRangeControl();
	afx_msg void OnChangeScannStartFrq();
	afx_msg void OnChangeScannStopFrq();
	afx_msg void OnChangeScannStepFrq();
	afx_msg void OnSetTopDEC();
	afx_msg void OnSetTopTSV();
	afx_msg void OnSetSmall();
	afx_msg void OnSetLarge();
	afx_msg void OnDeltaposScannSpin(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	afx_msg LRESULT OnPotiChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSaveScaleLevel(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(EXT_IQ_CONTRO)
