// MyDrmText.cpp : implementation file
//

#include "stdafx.h"
#include "../GlobalTools.h"
#include "MyDrmText.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyDrmText
IMPLEMENT_DYNCREATE(MyDrmText, CButton)

MyDrmText::MyDrmText()
{
	dir=DT_CENTER;
	sunken=set=transparent=m_state=m_bold=m_warning=0;
	m_ellipysis=DT_END_ELLIPSIS;
	m_DRMState=NULL;
}

MyDrmText::~MyDrmText()
{
}


BEGIN_MESSAGE_MAP(MyDrmText, CButton)
	//{{AFX_MSG_MAP(MyDrmText)
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyDrmText message handlers

//****************************************************************************
void MyDrmText::PreSubclassWindow() 
{
	InitStatic();
	CButton::PreSubclassWindow();

}
//****************************************************************************
BOOL MyDrmText::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style &= 0xFFFFFFF0;
	cs.style |= SS_OWNERDRAW;
	BOOL A= CButton::PreCreateWindow(cs);
	InitStatic();
	return A;
}

BOOL MyDrmText::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	dwStyle &= 0xFFFFFFF0;
	dwStyle |= SS_OWNERDRAW;
	BOOL A= CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
	InitStatic();
	return A;
}

int MyDrmText::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= SS_OWNERDRAW;
	lpCreateStruct->style &= 0xFFFFFFF0;
	if (CButton::OnCreate(lpCreateStruct) == -1) return -1;
	InitStatic();
	
	return 0;
}

void MyDrmText::Init(RX_SIGNAL_STATE *DRMState) 
{
	m_DRMState=DRMState;
	TimerID=0xFF000000|GetDlgCtrlID();
}

void MyDrmText::InitStatic() 
{
	DWORD dwExStyle=GetExStyle();
	DWORD dwStyle=GetStyle();
	if(dwStyle&SS_SUNKEN) sunken=1;
	if(dwStyle&SS_CENTER) dir=DT_CENTER;
	else if(dwStyle&SS_RIGHT) dir=DT_RIGHT;
	else dir=DT_LEFT;

	if(dwExStyle&(WS_EX_CLIENTEDGE|WS_EX_STATICEDGE))
		{
		ModifyStyleEx (WS_EX_CLIENTEDGE|WS_EX_STATICEDGE, NULL);
		sunken=1;
		}
	if(dwExStyle&WS_EX_TRANSPARENT) transparent=1;
	ModifyStyle (0x0000FFFF,SS_OWNERDRAW);
}

BOOL MyDrmText::OnEraseBkgnd(CDC* pDC) 
{
	return (TRUE);
}

void MyDrmText::SetState(int state, BOOL bRedraw)
{
	m_state=state;

	if (bRedraw && GetSafeHwnd() != NULL)
		{
		Invalidate();
		UpdateWindow();
		}
}

void MyDrmText::DrawItem(LPDRAWITEMSTRUCT di) {}
void MyDrmText::OnPaint() 
{
	//flicker subpression

	CPaintDC	pdc(this);
	CDC			dc;
	CRect		rect;
	CBitmap		bitmap;
	CBitmap*	pOldBitmap;

	GetClientRect(rect);
	if (dc.CreateCompatibleDC(&pdc))
		{
		if (bitmap.CreateCompatibleBitmap(&pdc,rect.Width(), rect.Height()))
			{
			pOldBitmap = dc.SelectObject(&bitmap);
			}
		}
	OnDraw(&dc,rect);
	pdc.BitBlt(rect.left,rect.top,rect.Width(),rect.Height(),&dc, 0, 0, SRCCOPY);
	dc.SelectObject(pOldBitmap);
}

void MyDrmText::OnDraw(CDC* pDC,CRect rect) 
{
	CPen		pen;
	COLORREF	col=COL_BTXT;
	CFont		*OldFont=NULL;
	CRect		rx,ry,re=rect;
	CString		txt;
	CBrush		brush(::GetSysColor(COLOR_BTNFACE));
	CBrush		green(RGB(58,254,11));
	CBrush		red(RGB(255,40,0));
	CBrush		yellow(RGB(255,255,0));
	CPen		LEDframe(PS_SOLID, 1, RGB(169,168,147));
	HPEN		pOldPen=NULL;
	HBRUSH		pOldBrush=NULL;

	pDC->FillRect(re,&brush);

	if(!m_DRMState) col=myDARK;
	pen.CreatePen(PS_SOLID, 1, col);

	/*if(FillStyle&DESIGN_GROUPBOX_LINE) LEDframe.CreatePen(PS_SOLID, 1, RGB(169,168,147));
	else LEDframe.CreatePen(PS_SOLID, 1, myDARK);*/

	pOldPen = (HPEN)::SelectObject(pDC->m_hDC,pen);
	pOldBrush=(HBRUSH)::SelectObject(pDC->m_hDC,&brush);
	col=AddBasisColor(COL_BTXT,.1);


	ry=rx=re; 
	int left=(re.Width()-MyLogo.Width())/2;
	int top=(re.Height()-MyLogo.Height())/2-1;

	if(!m_DRMState) goto setLogo;

	if(!m_state || !m_DRMState->ServiceLabel[0])	col=myDARK;

	OldFont= pDC->SelectObject(&fontBold);
	if(m_state)
		{
		int m=DT_VCENTER|DT_SINGLELINE|m_ellipysis;
		COLORREF oldCol=::SetTextColor(pDC->m_hDC,col);
		int BkModeOld= ::SetBkMode(pDC->m_hDC,TRANSPARENT);
		COLORREF	bkcol=::SetBkColor(pDC->m_hDC,::GetSysColor(COLOR_BTNFACE));

		txt=m_DRMState->ServiceLabel;
		if(m_DRMState->activeService && !txt.IsEmpty()) 
			{
			rx.bottom-=20;
			pDC->DrawText(txt, rx, m|DT_CENTER|DT_NOPREFIX); 
			rx.bottom=re.top+17; 
			pDC->SelectObject(&fontMinimal);	
		
			pDC->DrawText(myCodecTypes[m_DRMState->CodecTypeIdx&15], rx, DT_VCENTER|DT_SINGLELINE|DT_CENTER|DT_NOPREFIX); 
		
			if(m_DRMState->BitRateKbps) 
				{
				rx.left+=3;
				txt.Format("%.1f kb",m_DRMState->BitRateKbps);
				pDC->DrawText(txt, rx, DT_VCENTER|DT_SINGLELINE|DT_LEFT|DT_NOPREFIX); 
				}

			rx.right-=4;
			pDC->DrawText(myDataAudioTypes[m_DRMState->DataAudioTypeIdx&15], rx, DT_VCENTER|DT_SINGLELINE|DT_RIGHT|DT_NOPREFIX); 

			rx=re; rx.top=re.bottom-28;
			rx.bottom=rx.top+14;

			rx.left+=3;
			pDC->DrawText(myLanguage[m_DRMState->LanguageIdx].Name, rx, DT_VCENTER|DT_SINGLELINE|DT_LEFT|DT_NOPREFIX); 
			rx.right-=4;
			pDC->DrawText(myCountries[m_DRMState->CountryIdx].Name, rx, DT_VCENTER|DT_SINGLELINE|DT_RIGHT|DT_NOPREFIX); 

			rx=re; rx.top=re.bottom-17;
			rx.left+=3;
			txt.Format("%s",myProgramTypes[m_DRMState->ProgrammTypeIdx]);
			pDC->DrawText(txt, rx, DT_VCENTER|DT_SINGLELINE|DT_LEFT|DT_NOPREFIX); 
			if(m_DRMState->iServiceID)
				{
				rx.right-=4;
				txt.Format("ID:%06X",m_DRMState->iServiceID);
				pDC->DrawText(txt, rx, DT_VCENTER|DT_SINGLELINE|DT_RIGHT|DT_NOPREFIX); 
				}
			rx.top=34;
			if(m_warning) SetWarning(0,0);
			}
		else 
			{
			if(!m_warning) SetWarning(1,0);
			DRMLogo.BitBlt(pDC->m_hDC,left+1,top-1,DRMLogo.Width(),DRMLogo.Height(),0,0,SRCCOPY);
			ry.top=42;
			ry.bottom=56;
			if(m_warning&2) ::SetTextColor(pDC->m_hDC,COL_RED);
			if(m_DRMState->FACState==DRM_STATE_RX_OK && m_DRMState->SDCState==DRM_STATE_RX_OK && m_DRMState->MSCState==DRM_STATE_RX_OK) pDC->DrawText("DRM-Sync", ry, DT_VCENTER|DT_SINGLELINE|DT_CENTER); 
			else pDC->DrawText("DRM-Sync - no Audio", ry, DT_VCENTER|DT_SINGLELINE|DT_CENTER); 
			rx.top=34;
			}
	
		::SetBkColor(pDC->m_hDC,bkcol);
		::SetBkMode(pDC->m_hDC,BkModeOld);
		::SetTextColor(pDC->m_hDC,oldCol);

		::SelectObject(pDC->m_hDC,LEDframe);

		rx.left=(re.Width()/2)-37;
		rx.bottom=rx.top+7;
		rx.right=rx.left+20;
		Rectangle(pDC->m_hDC,rx.left,rx.top,rx.right,rx.bottom);
		rx.DeflateRect(1,1);
		switch(m_DRMState->FACState)
			{
			case DRM_STATE_NOT_PRESENT:	break;
			case DRM_STATE_CRC_ERROR:	FillRect(pDC->m_hDC,rx,red); break;
			case DRM_STATE_DATA_ERROR:	FillRect(pDC->m_hDC,rx,yellow); break;
			case DRM_STATE_RX_OK:		FillRect(pDC->m_hDC,rx,green); break;
			}
		rx.InflateRect(1,1);
		rx.left=rx.right+7; rx.right=rx.left+20;
		Rectangle(pDC->m_hDC,rx.left,rx.top,rx.right,rx.bottom);
		rx.DeflateRect(1,1);
		switch(m_DRMState->SDCState)
			{
			case DRM_STATE_NOT_PRESENT:	break;
			case DRM_STATE_CRC_ERROR:	FillRect(pDC->m_hDC,rx,red); break;
			case DRM_STATE_DATA_ERROR:	FillRect(pDC->m_hDC,rx,yellow); break;
			case DRM_STATE_RX_OK:		FillRect(pDC->m_hDC,rx,green); break;
			}

		rx.InflateRect(1,1);
		rx.left=rx.right+7; rx.right=rx.left+20;
		Rectangle(pDC->m_hDC,rx.left,rx.top,rx.right,rx.bottom);
		rx.DeflateRect(1,1);
		switch(m_DRMState->MSCState)
			{
			case DRM_STATE_NOT_PRESENT:	break;
			case DRM_STATE_CRC_ERROR:	FillRect(pDC->m_hDC,rx,red); break;
			case DRM_STATE_DATA_ERROR:	FillRect(pDC->m_hDC,rx,yellow); break;
			case DRM_STATE_RX_OK:		FillRect(pDC->m_hDC,rx,green); break;
			}
		}
	else
		{
setLogo:

		MyLogo.BitBlt(pDC->m_hDC,left,top,MyLogo.Width(),MyLogo.Height(),0,0,SRCCOPY);
		}

	if(pOldBrush) ::SelectObject(pDC->m_hDC,pOldBrush);
	if(pOldPen) ::SelectObject(pDC->m_hDC,pOldPen);
	if(OldFont) pDC->SelectObject(OldFont);
}


void MyDrmText::SetWarning(int warn,int blinks) 
{
	m_warning=warn;
	blinkStop=blinks;
	if(m_warning) SetTimer(TimerID,1500,0);
	else KillTimer(TimerID);
	RedrawWindow();
}

void MyDrmText::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == TimerID) 
		{
		if(blinkStop)
			{
			blinkStop--;
			if(!blinkStop)
				{
				KillTimer(TimerID);
				m_warning=1;
				RedrawWindow();
				return;
				}
			}

		if(!m_warning) KillTimer(TimerID);
		else
			{
			m_warning^=2;
			RedrawWindow();
			}
		}
}