// MyEdit.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "../GlobalTools.h"
#include "MyEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyEdit
IMPLEMENT_DYNCREATE(MyEdit, CEdit)

MyEdit::MyEdit()
{
	nomargin=0;
	onlyFigure=0;
	activateFocusColor=0;
}

MyEdit::~MyEdit()
{
}


BEGIN_MESSAGE_MAP(MyEdit, CEdit)
	//{{AFX_MSG_MAP(MyEdit)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_KILLFOCUS()
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyEdit message handlers

int MyEdit::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CEdit::OnCreate(lpCreateStruct) == -1)	return -1;
	
	SetMyStyle();
	SetMyRect();
	
	return 0;
}

void MyEdit::PreSubclassWindow() 
{
	SetMyStyle();
	CEdit::PreSubclassWindow();
	GetClientRect(m_rect);
	PostMessage(WM_SIZE,NULL,MAKELPARAM(m_rect.Width(),m_rect.Height()));
}

void  MyEdit::SetMyStyle() 
{
	if(GetStyle()&ES_NUMBER) onlyFigure=1;
	else onlyFigure=0;
	ModifyStyle (ES_NUMBER, ES_MULTILINE);

	DWORD style=GetStyle();

	if(style&ES_CENTER) m_style=DT_CENTER;
	else if(style&ES_RIGHT) m_style=DT_RIGHT;
	else m_style=DT_LEFT;
	m_style|=DT_VCENTER|DT_SINGLELINE;
}

void MyEdit::OnSize(UINT nType, int cx, int cy) 
{
	CEdit::OnSize(nType, cx, cy);
	SetMyRect();
}

void MyEdit::OnKillFocus(CWnd* pNewWnd) 
{
	CEdit::OnKillFocus(pNewWnd);
	if(activateFocusColor)
		{
		if(activateFocusColor==2) SetWindowText("");
		Invalidate();
		}
}

void MyEdit::OnSetFocus(CWnd* pOldWnd) 
{
	CEdit::OnSetFocus(pOldWnd);
	if(activateFocusColor)
		{
		Invalidate();
		}
}

void MyEdit::SetMyRect() 
{
	GetClientRect(m_rect);
	CRect re=m_rect;
	re.left+=5;
	re.right-=5;
	if(!nomargin) re.top+=((re.bottom-14)/2)+1;
	else re.top+=2;
	SetRect(re);
}

BOOL MyEdit::PreTranslateMessage(MSG* pMsg) 
{
	if(onlyFigure && pMsg->message == WM_CHAR)
		{
		return CheckFigures(pMsg->wParam,pMsg->lParam); 
		}
	return CEdit::PreTranslateMessage(pMsg);
}

BOOL MyEdit::CheckFigures(int cChar, int key) 
{
	if(onlyFigure)
		{
		CString str;
		switch(cChar)
			{
			case 0x0D:	::PostMessage(::GetParent(m_hWnd),WM_EDIT_CR,(WPARAM)m_hWnd,(LPARAM)m_hWnd);
						return TRUE;
			case 188:
			case 0x2C:	
			case 190:
			case 0x2E:	if(GetFocus()!=this) SetFocus();
						GetWindowText(str);
						if(str.Find(".",0)==-1)
							{
							SendMessage(WM_CHAR,0x2E,0);
							}
						return TRUE;
			case 0x08:
			case 0x30:
			case 0x31:
			case 0x32:
			case 0x33:
			case 0x34:
			case 0x35:
			case 0x36:
			case 0x37:
			case 0x38:
			case 0x39:	if(GetFocus()!=this) 
							{
							SetFocus();
							SendMessage(WM_CHAR,cChar,key);
							}
						
						//SendMessage(WM_CHAR,cChar,key);
						break;
			default:	return TRUE;
			}
		}
	return FALSE;
}

