#if !defined(MY_PANORAMA_VIEW)
#define MY_PANORAMA_VIEW

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyPanoramaView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyPanoramaView window
#include "MyDCBitmap.h"

#define DONT_DRAW		1
#define RESTORE_DRAW	-1
#define CLEAR_DRAW		0
#define BLUE_MARK_TIMER	167

class MyPanoramaView: public CButton
{
	DECLARE_DYNCREATE(MyPanoramaView)

// Construction
public:
	MyPanoramaView();

// Attributes
public:

	BOOL			m_bCaptured;
	double			oldFrq,lastFRQ;
	CPoint			c_last,c_down;
	BOOL			moveflag;
	int				lastDrawFrq,lastPOS,cmp_lo,cmp_hi,bluemark;
	int				INVALidate,dB0Offset,top_ySnap,DrawDoubleLine,cmp_sfrq,cmp_ssiz,cmp_start,cmp_end;
	void			RefreschWindow( int bErase = TRUE );
	
	CRect			m_fftre,m_winre,TxTrect,myScaleRect,myTopViewRect,myTopScale,myViewRect;
	CRgn			m_fftrgn;
	int				m_xs,m_ys,o_hi,o_lo,fnum,frange,isrange,x_zoom,noSmoothing,DraftMode;
	POINT			*pt,*db,*db2;

	double			my_Width,frqWidth,frqStep,frqLO,dBmV;
	float			my_Hight,m_level,m_ampl,m_bright,m_fscal,m_SmothA,m_SmothB;
	float			topLevel,topAmpl,topBright,m_amplCut,dbScale,dbLevel;
	char			myStatus[64];
	char			m_frqtxt[64];
	char			m_dBtxt[64];

	int				init,m_Off,m_frqdelay,top_ys,t_ys,MausSteps,ClickStep;
	int				m_sfrq,m_ssiz,m_spow,ImOk,m_scale,m_center,toptop,m_bst;

	int				m_frqlo,m_frqhi,m_st,m_lo,m_hi,m_OutCntr,m_delay;
	int				m_viewLO,m_viewHI,force,IFcentermark,centermark;
	int				*m_fftscal,*m_posscal,*m_cmpscal;
	MyDCBitmap		myTSpec,topTSpec,ScopeBack;

	IQ_DRAW_PARA	GetPara;
	BOOL			Init();
	BOOL			InitSpectrum(int sample_frq, int sample_num,IF_ANA_STYLE *style=NULL);
	BOOL			CheckSize();
	BOOL			ReSizeSpectrum(int set=0);
	void			SetOff(int off);
	void			ClearView();
	void			ClearTimeSpect();
	void			SetFftScale();
	void			SetCmpScale();
	int				CalcValueDouble(int m_val, int m_xs, int m_frange, int max);
	void			SetStyle(int style=0);
	void			SetTopStyle(int style=0);
	void			Exit();
	void			SetDoupleLine(int set, int sample_frq=0, int sample_num=0);
	void			OnFilterChanged();
	void			SetMyScale(int lo, int hi, int set=0);
	void			DrawTimeSpec(HDC dc);
	void			DrawLines(HDC hdc);
	void			DrawGridLines(HDC hdc);
	virtual void	UserDraw(HDC hdc);
	void			OutTextString(HDC hdc, int xpos, int ypos, char *txt,UINT nFlags=TA_LEFT);
	int				SetFrq(int frq);
	void			DrawTopLines(HDC hdc);
	void			DrawScale(HDC hdc, CRect &Scale,int lo, int hi, int st, int fill=1);
	void			DrawScaleLines(HDC hdc, CRect &Scale,int lo, int hi, int st);
	void			GetDrawData(int lineCounter);
	void			MakeTopDraw();
	float			GetDecibelPoint(int x);
	void			SetDelay(int delay);
	void			SetAmpl(int a);
	void			SetLevel(int l);
	void			SetTAmpl(int a);
	void			SetTLevel(int l);
	void			SetAmpCut(int a);
	void			SetDecLevel(int a);
	void			SetDecScale(int a);
	void			SetMouseSteps();
	void			SetBlueMark(int bluemark);


	// Operations
public:

// Overrides
public:


	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyPanoramaView)
	public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void PreSubclassWindow();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~MyPanoramaView();

protected:
//	afx_msg void OnContextMenu(CWnd*, CPoint point);
	//{{AFX_MSG(MyPanoramaView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
public:
	afx_msg LRESULT OnDrawFrequency(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(MY_PANORAMA_VIEW)
