////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "../GlobalTools.h"
#include "MySMeter.h"

#ifdef _SET_DEBUG_NEW
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
/*
		0=200 mV
S9+70dB -03dBm	160mV
S9+60dB -13dBm	50mV
S9+50dB -23dBm	16mV/50O	5W 
S9+40dB -33dBm	5mV/50O		500nW 
S9+30dB -43dBm	1,6mV/50O	50nW 
S9+20dB -53dBm	500V/50O	5nW 
S9+10dB -63dBm	160V/50O	500pW 
S9		-73dBm	50V/50O	50pW 
S8		-79dBm	25V/50O	12,5pW 
S7		-85dBm	12,5V/50O	3,16pW 
S6		-91dBm	6,3V/50O	794fW 
S5		-97dBm	3,16V/50O	200fW 
S4		-103dBm 1,59V/50O	50fW 
S3		-109dBm 0,79V/50O	12,6fW 
S2		-115dBm 0,4V/50O	3,16fW 
S1		-121dBm 0,2V/50O	794aW 
S0		-127dBm 0,1V
		-133dBm 50nV 
		-139dBm 25nV 
*/    



/////////////////////////////////////////////////////////////////////////////

// CCtrlButton
IMPLEMENT_DYNCREATE(MySMeter, CButton)
BEGIN_MESSAGE_MAP(MySMeter, CButton)
	//{{AFX_MSG_MAP(MySMeter)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


MySMeter::MySMeter()
{
	TextCol=COL_BTXT;
	BorderDarkCol = myVDARK;
	BorderLightCol = myLIGHT;
	BackCol= COL_BACK;
	SNR_Level=dB_Level=0;
	m_bPushed			= FALSE;
	m_bHighlighted		= FALSE;
	m_bCaptured			= FALSE;
	dBsm=SquelchLevel=SNRLevel=0;
	dBmV=.020*pow(10,-73.*.05);
}

MySMeter::~MySMeter(){}
void MySMeter::DrawItem(LPDRAWITEMSTRUCT lpDIS) {};

BOOL MySMeter::Init(int type)
{
	GetClientRect(&m_size);
	TextCol=COL_BTXT;
	BorderDarkCol = myVDARK;
	BorderLightCol = myVLIGHT;
	BackCol= COL_BACK;
	dBsm=type;

	bRect = m_size;
	bRect.bottom = bRect.bottom * 82/ 100;
	::InflateRect(&bRect,0,-__max(bRect.Height()/20,8));
	mRect=bRect; mRect.top-=8; mRect.bottom-=5;

	bRect.top=bRect.bottom-3; bRect.bottom=bRect.top+17;
	bRect.right=bRect.left+15;
	return TRUE;
}

BOOL MySMeter::OnEraseBkgnd(CDC* /*pDC*/) 
{
	return TRUE;
}

void MySMeter::OnPaint() 
{
	if(m_hWnd)
		{
		CPaintDC dc(this); // device context for painting
		Draw(&dc);
		}
}	
COLORREF WINAPI GetColorSpect(COLORREF col, int div)
{

	int r =GetRValue(col)+div;
	int g =GetGValue(col)+div;
	int b =GetBValue(col)+div;

	if(r<0) r=0;
	if(r>255) r=255;
	if(g<0) g=0;
	if(g>255) g=255;
	if(b<0) b=0;
	if(b>255) b=255;

	return RGB(r,g,b);
}

void MySMeter::Draw(CDC *pDC)
{
	CDC			dc;
	CBitmap		bitmap;
	CBitmap*	pOldBitmap;
	CPen		scalePen(PS_SOLID,1,COL_BTXT);
	HDC			hdc=0;
	RECT		re,bre,scl;
	HBRUSH		hb;
	HPEN		hp;
	HBITMAP		hbm=0;
	HFONT		hf;
	SIZE		si;
	COLORREF	col;
	int			k,i,v,x,y,xs,ys,r,b,g,w,j,z,xx,yy,level;
	double		value,p;
	char		txt[256];
	WORD		bpattern[] = {0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0,0};

	int vScale[16]={-147,-133,-127,-113,-107,-93,-87,-73,-67,-53,-47,-33,-27,-13,-7,0};
	char *cScale[16]={".01V",".05V",".1V",".5V","1V","5V","10V","50V",".1mV",".5mV","1mV","5mV","10mV","50mV","100mV","500mV"};


	try
		{
		xs = m_size.Width(); ys = m_size.Height();
		//draw in bitmap - subpress the flicker
		if (dc.CreateCompatibleDC(pDC))
			{
			if (bitmap.CreateCompatibleBitmap(pDC,xs, ys))
				{
				pOldBitmap = dc.SelectObject(&bitmap);
				}
			}

		hdc=dc.m_hDC;
		::SetRect(&re,0,0,xs,ys);
		if(!(hbm = ::CreateBitmap(8,8,1,1,bpattern))) throw 0;
		hb = ::CreateSolidBrush(BackCol); ::FillRect(hdc,&re,hb); ::DeleteObject(hb);
		hf = (HFONT)::SelectObject(hdc,minifont);
		::SetTextAlign(hdc,TA_TOP); ::SetBkMode(hdc,TRANSPARENT);
		bre = re; bre.bottom = bre.bottom * 82 / 100;
		::InflateRect(&bre,0,-__max(ys/20,8));
		bre.top-=8; bre.bottom-=5;

		y = re.bottom - ((re.bottom - bre.bottom) >> 1); x = 16;
		hp = (HPEN)::SelectObject(hdc,scalePen);
		::SetTextColor(hdc,COL_BTXT);

		if(dBsm==2) level=(int)((float)(bre.right-bre.left)/67.f*(float)SNRLevel); 
		else  level=(int)((float)(bre.right-bre.left)/160.f	*(float)SquelchLevel);
		

		if(dBsm==3)
			{
			p=(bre.right-bre.left)/160.;
			double xV,uV=.02,dBm_power,dBm_power_ratio,dBm_value;

			uV=.01;
			for(i=0; i<8; i++)
				{
				dBm_power = pow(uV,2)/1000000./50.;
				dBm_power_ratio = dBm_power/1000;	
				dBm_value  = 160+(10*(log(dBm_power_ratio)/(log(10))));
			
				if(uV<1) sprintf(txt,"%.1fV",uV);
				else if(uV<10) sprintf(txt,"%.0fV",uV);
				else if(uV<100) sprintf(txt,"%.0fV",uV);
				else if(uV<1000) sprintf(txt,"%.1fmV",uV/1000);
				else sprintf(txt,"%.0fmV",uV/1000);
				xx = bre.left+(int)((double)dBm_value*p+.5);
				if(xx>bre.right) break;
				::MoveToEx(hdc,xx,bre.bottom+ys*2/100,0);
				
				::GetTextExtentPoint32(hdc,txt,strlen(txt),&si);
				yy = bre.bottom+ys*14/100;
				::LineTo(hdc,xx,yy);
				if(xx>40) 
					{
					if(i>0)::TextOut(hdc,xx-(si.cx>>1)-1,y-(si.cy>>1),txt,strlen(txt));

					for(k=2; k<10; k+=2)
						{
						xV=uV*(double)k;
						dBm_power = pow(xV,2)/1000000./50.;
						dBm_power_ratio = dBm_power/1000;	
						dBm_value  = 160+(10*(log(dBm_power_ratio)/(log(10))));
						xx = bre.left+(int)((double)dBm_value*p+.5);
						::MoveToEx(hdc,xx,bre.bottom+ys*2/100,0);
						yy = bre.bottom+ys*8/100;
						::LineTo(hdc,xx,yy);
						}
					}
				uV*=10;
				}
			}
		else if(dBsm==2) //SNR
			{
			p=(bre.right-bre.left)/67.;
			for(i=1; i<67; i++)
				{
				xx = bre.left+(int)((double)i*p+.5);
				::MoveToEx(hdc,xx,bre.bottom+ys*2/100,0);
				if(!(i%5) && i!=65) 
					{
					sprintf(txt,"%d",i);
					::GetTextExtentPoint32(hdc,txt,strlen(txt),&si);
					yy = bre.bottom+ys*12/100;
					}
				else
					{
					txt[0]=0;
					if(i==65) yy = bre.bottom+ys*12/100;
					else yy = bre.bottom+ys*6/100;
					}
				if(txt[0] && i>5) ::TextOut(hdc,xx-(si.cx>>1)+1,y-(si.cy>>1),txt,strlen(txt));
				::LineTo(hdc,xx,yy);
				}
			}
		else
			{
			float s=127.f,ww=(float)(m_size.Width())/160.f;
			for(i=1; i<16; i++)
				{
				if(dBsm)
					{
					sprintf(txt,"%d",i*10-160);
					::GetTextExtentPoint32(hdc,txt,strlen(txt),&si);
					if(i>3 && i<15) ::TextOut(hdc,bre.left+i*(bre.right-bre.left)/x-(si.cx>>1),y-(si.cy>>1),txt,strlen(txt));
					v = bre.left+i*(bre.right-bre.left)/x;
					::MoveToEx(hdc,v,bre.bottom+ys*2/100,0);
					::LineTo(hdc,v,bre.bottom+ys*8/100);
					}
				else
					{
					z=i;
					if(z < 10) 
						{
						sprintf(txt,"%d",z); 
						s-=6;
						}
					else
						{
						sprintf(txt,"+%d",(z-9)*10);
						s-=10;
						}
					z=(int)(ww*(160.f-s));
					::GetTextExtentPoint32(hdc,txt,strlen(txt),&si);
					if(i<15)::TextOut(hdc,z-(si.cx>>1)-1,y-(si.cy>>1),txt,strlen(txt));
					::MoveToEx(hdc,z,bre.bottom+ys*2/100,0);
					::LineTo(hdc,z,bre.bottom+ys*8/100);
					}
				}
			}

		if(dBsm==2) strcpy(txt,"SNR");
		else if(dBsm==1) strcpy(txt,"dBm");
		else strcpy(txt,"SWR");
		
		xx=bre.right-20; yy=y-(si.cy>>1); //the last scale text hight
		if(dBsm!=3)::TextOut(hdc,xx,yy,txt,strlen(txt));
		if(dBsm==2) 
			{
			xx=bre.left+15;
			::SelectObject(hdc,minibigfont);
			sprintf(txt,"%ddB",SNR_Level);	
			::TextOut(hdc,xx,yy,txt,strlen(txt));
			}

		::SelectObject(hdc,hp);
		DrawScaleButton(CDC::FromHandle(hdc));
		::FillRect(hdc,&bre,CBrush(BackCol));
		if(level) 
			{
			CRect rx=bre; rx.right=rx.left+level;
			::FillRect(hdc,&rx,CBrush(AddBasisColor(COL_BACK,-.15)));
			}
	
		dc.Draw3dRect(&bre,BorderDarkCol,BorderLightCol);
		if(dBsm==2) value=SNR_Level*256/67;
		else value=dB_Level*256/160;

		//if(value)
			{
			bre.right-=2;
			y = (int)((double)(bre.right-bre.left) / 256. * value);
			if(y<0) y=0;
			if(y>bre.right) y=bre.right;

			if((bre.bottom-bre.top)<6) ::InflateRect(&bre,-1,-1); 
			else ::InflateRect(&bre,-2,-2); 
			re = bre; 
			scl.bottom=bre.bottom;
			scl.top=bre.top;
			scl.right = bre.left + y;
			w=bre.right-bre.left;
			j=w/2; w-=j;

			col=GetColorSpect(COL_BACK,75);
			CBrush sqlBrush(col);
			for(x=-j,i=bre.left; i<=(bre.left + y); i+=3,x+=3)
				{
				if(i>bre.right) break;
				scl.left=i;
				scl.right=i+2;
				z=i-bre.left;
				if(dBsm!=2 && x>0)
					{
					r= min(255,((GetRValue(myVDARK) * (w-x) + GetRValue(COL_SCOPEMARK) * x) / w));
					g= min(255,((GetGValue(myVDARK) * (w-x) + GetGValue(COL_SCOPEMARK) * x) / w));
					b= min(255,((GetBValue(myVDARK) * (w-x) + GetBValue(COL_SCOPEMARK) * x) / w));
					if(z<level) ::FillRect(hdc,&scl,sqlBrush);
					else ::FillRect(hdc,&scl,CBrush(RGB(r,g,b)));
					}
				else 
					{
					if(z<level) ::FillRect(hdc,&scl,sqlBrush);
					else	::FillRect(hdc,&scl,CBrush(myVDARK));
					r=GetRValue(myVDARK);
					g=GetGValue(myVDARK);
					b=GetBValue(myVDARK);
					}
				}

			if(dBsm!=2) 
				{
				xx=bre.left+13; //yy=the last scale text hight
				if(dBsm==3) 
					{
					double mVolt=pow(10,(dB_Level-160)*.05)/dBmV;
					if(mVolt>100.) 
						{
						mVolt/=1000.;
						if(mVolt<1.) sprintf(txt,"%.2fmV",mVolt);
						else sprintf(txt,"%.1fmV",mVolt);
						
						}
					else 
						{
						if(mVolt<1) sprintf(txt,"%.2fV",mVolt);
						else sprintf(txt,"%.1fV",mVolt);
						}
					}
				else 
					{
					xx=bre.left+12;
					sprintf(txt,"%ddB",dB_Level-160);
					}
			
				::SelectObject(hdc,minibigfont);
				::TextOut(hdc,xx,yy,txt,strlen(txt));
				}
			}
		::SelectObject(hdc,hf);
		pDC->BitBlt(m_size.left,m_size.top,m_size.Width(),m_size.Height(),&dc, 0, 0, SRCCOPY);
		dc.SelectObject(pOldBitmap);
		}
	catch(int err) {err;}
	if(hbm) ::DeleteObject(hbm);
	ValidateRect(&m_size);
}

void MySMeter::DrawScaleButton(CDC* pDC)
{
	COLORREF col1,col2,clrText=COL_BTXT,oldTXT;
	CRect rectClient=bRect;
	rectClient.DeflateRect(1,1); 
	
	oldTXT=pDC->SetTextColor(clrText);

	if ((m_bPushed && m_bHighlighted))
		{
		clrText=RGB(255,255,255);
		if(!m_bHighlighted) {col1=myDARK; col2=myVDARK;} 
		else {col2=myDARK; col1=myVDARK;} 
		}
	else
		{
		if (m_bHighlighted) {col1=myLIGHT; col2=myDARK;}
		else {col2=myLIGHT; col1=myDARK;}
		}
	FillGradient(pDC,rectClient,col1,col2,0); 

	CPen	pen(PS_SOLID,1,COL_BTXT);
	CBrush	brush(COL_BTXT);
	HPEN pOldPen = (HPEN)::SelectObject(pDC->m_hDC,pen);
	HBRUSH pOldBrush= (HBRUSH)::SelectObject(pDC->m_hDC,brush);

	CPoint c=rectClient.CenterPoint();
	c.y-=3; 
	c.x-=3;
	POINT pt[3];
	pt[0].x = c.x; 
	pt[0].y = c.y+4;

	pt[1].x = (c.x+3);
	pt[1].y = c.y+1;

	pt[2].x = c.x+6;
	pt[2].y = c.y+4;
	

	pDC->Polygon(pt, 3);
	::SelectObject(pDC->m_hDC,pOldBrush);
	::SelectObject(pDC->m_hDC,pOldPen);

	rectClient.InflateRect(1,1); 
	DrawStyleRect(pDC,rectClient,myVLIGHT);
}

void MySMeter::OnKillFocus(CWnd* pNewWnd) 
{
	CButton::OnKillFocus(pNewWnd);
	if (m_bCaptured)
		{
		ReleaseCapture ();
		m_bCaptured = FALSE;
		}

	m_bPushed = FALSE;
	m_bHighlighted = FALSE;
	Invalidate ();
	UpdateWindow ();
}

void MySMeter::OnMouseMove(UINT nFlags, CPoint point) 
{
	BOOL bRedraw = FALSE;
	BOOL isIn=FALSE;

	if (bRect.PtInRect (point))
		{
		if (!m_bHighlighted)
			{
			m_bHighlighted = TRUE;
			bRedraw = TRUE;
			}

		if ((nFlags & MK_LBUTTON) && !m_bPushed)
			{
			m_bPushed = TRUE;
			bRedraw = TRUE;
			}

		if (!m_bCaptured)
			{
			SetCapture ();
			m_bCaptured = TRUE;
			bRedraw = TRUE;
			}
		isIn=1;
		if(::GetCursor()!= m_Hand) ::SetCursor(m_Hand);
		}
	else
		{
		if (nFlags & MK_LBUTTON)
			{
			if (m_bPushed)
				{
				m_bPushed = FALSE;
				bRedraw = TRUE;
				}
			}
		else if (m_bHighlighted)
			{
			m_bHighlighted = FALSE;
			bRedraw = TRUE;
			}

		if (m_bCaptured && (!nFlags & MK_LBUTTON))
			{
			ReleaseCapture ();
			m_bCaptured = FALSE;

			bRedraw = TRUE;
			}
		}

	if (bRedraw)
		{
		Invalidate ();
		UpdateWindow ();
		}
	if(!isIn) CheckSetCursor();
	CButton::OnMouseMove(nFlags, point);
}

void MySMeter::CheckSetCursor() 
{
	CPoint ptCursor;
	::GetCursorPos (&ptCursor);
	ScreenToClient (&ptCursor);
	if (bRect.PtInRect (ptCursor))
		{
		if(::GetCursor()!= m_Hand) ::SetCursor(m_Hand);
		}

}

BOOL MySMeter::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	CheckSetCursor();
	return TRUE;
	
	return CButton::OnSetCursor(pWnd, nHitTest, message);
}

void MySMeter::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_bCaptured)
		{
		ReleaseCapture ();
		m_bCaptured = FALSE;
		}

	m_bPushed = FALSE;
	m_bHighlighted = FALSE;

	if(bRect.PtInRect (point)) 
		{
		dBsm++;
		if(dBsm>3) dBsm=0;
		GetParent()->SendMessage(WM_UDP_SMETER_DBSM,GetDlgCtrlID(),dBsm);
		}

	Invalidate ();
	UpdateWindow ();
	::SetCursor(m_FingerDown);
}

void MySMeter::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_bPushed = FALSE;
	m_bHighlighted = FALSE;
	if (m_bCaptured)
		{
		ReleaseCapture ();
		m_bCaptured = FALSE;
		}
	Invalidate ();
	UpdateWindow ();
	CheckSetCursor();
}


void MySMeter::SetSNRLevel(int val)
{
	if(val>67) val=67;
	SNRLevel=val;
	RedrawWindow();
}

void MySMeter::SetSquelchLevel(int val)
{
	if(val>256) val=256;
	SquelchLevel=val;
	RedrawWindow();
}

	/*
	1102S-SMeter 96,32=16Bit   15dB ATT and 20dB Buster ==

   2,25 Volt /  96,36 = 0,023 359 63455149501661129568    23,25mV
   2,25 Volt / 144,48 = 0,000 000 13411045074462890625	  0,134V	

	S9+60dB -13dBm	50mV/50O		50W 
	S9+50dB -23dBm	16mV/50O		5W 
	S9+40dB -33dBm	5mV/50O			500nW 
	S9+30dB -43dBm	1,6mV/50O		50nW 
	S9+20dB -53dBm	500V/50O		5nW 
	S9+10dB -63dBm	160V/50O		500pW 
	S9		-73dBm	50V/50O		50pW 
	S8		-79dBm	25V/50O		12,5pW 
	S7		-85dBm	12,5V/50O		3,16pW 
	S6		-91dBm	6,3V/50O		794fW 
	S5		-97dBm	3,16V/50O		200fW 
	S4		-103dBm 1,59V/50O		50fW 
	S3		-109dBm 0,79V/50O		12,6fW 
	S2		-115dBm 0,3975V/50O	3,16fW 
	S1		-121dBm 0,19875V/50O	794aW 
	S0		-127dBm 0,099375
	S-1		-133dBm 0,0496875
	S-2		-141dBm 0,02484375

	*/    


void MySMeter::SetSMeter(int SignalLevel,int snr)
{
	dB_Level=(int)SignalLevel;
	SNR_Level=snr;
	RedrawWindow();
}
