////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "TimeUTC.h"
//#include <afx.h>
#define _CountOf(array) (sizeof(array)/sizeof(array[0]))
//#define _CountOf(_Array) sizeof(*__CountOf_helper(_Array))


#ifdef AFX_AUX_SEG
#pragma code_seg(AFX_AUX_SEG)
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimeUTC - absolute time


int CTimeUTC::cDaysInMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

CTimeUTC::CTimeUTC() 
{
	m_time=0;
	SetMyTime(m_time);
}

CTimeUTC::CTimeUTC(time_t ti)
{
	SetMyTime(ti);
}

CTimeUTC::CTimeUTC(const CTimeUTC& timeSrc)
{
	SetMyTime(timeSrc.m_time); 
}

CTimeUTC::CTimeUTC(const CTime& timeSrc)
{
	SetMyTime((time_t)timeSrc.GetTime()); 
}

CTimeUTC::CTimeUTC(int nYear, int nMonth, int nDay, int nHour, int nMin, int nSec)
{
	MakeUTCTime(nYear,nMonth,nDay,nHour,nMin,nSec);
}

CTimeUTC::CTimeUTC(const SYSTEMTIME& sysTime)
{
	CTimeUTC timeT((int)sysTime.wYear, (int)sysTime.wMonth, (int)sysTime.wDay,
				(int)sysTime.wHour, (int)sysTime.wMinute, (int)sysTime.wSecond);
	*this = timeT;
}

CTimeUTC::CTimeUTC(const FILETIME& fileTime)
{
	SYSTEMTIME sysTime;
	if (!FileTimeToSystemTime(&fileTime, &sysTime))
		{
		SetMyTime();
		return;
		}

	CTimeUTC timeT((int)sysTime.wYear, (int)sysTime.wMonth, (int)sysTime.wDay,
				(int)sysTime.wHour, (int)sysTime.wMinute, (int)sysTime.wSecond);
	*this = timeT;
}

const CTimeUTC&  CTimeUTC::operator=(const CTimeUTC& timeSrc)
{
	SetMyTime(timeSrc.m_time); 
	return *this;
}
const CTimeUTC&  CTimeUTC::operator=(time_t t)
{
	SetMyTime(t); 
	return *this;
}

const time_t  CTimeUTC::operator+=(time_t t)
{
	SetMyTime(m_time+t); 
	return m_time;
}

const time_t  CTimeUTC::operator-=(time_t t)
{
	SetMyTime(m_time-t); 
	return m_time;
}

///////////////////////////////////////////
// get in UTC
///////////////////////////////////////////

time_t CTimeUTC::GetTime() {return 	m_time;}
int CTimeUTC::GetYear(){return m_year;}
int CTimeUTC::GetMonth(){return m_mon;}
int CTimeUTC::GetDay(){return m_day;}
int CTimeUTC::GetHour(){return m_hour;}
int CTimeUTC::GetMinute(){return m_min;}
int CTimeUTC::GetSecond(){return m_sec;}
int CTimeUTC::GetDayOfWeek() {return m_wday;}

///////////////////////////////////////////
// get as locale time
///////////////////////////////////////////

int CTimeUTC::GetLocalYear()
{
	tm *m=localtime(&m_time);
	return (int) m->tm_year+1900;
}

int CTimeUTC::GetLocalMonth()
{
	tm *m=localtime(&m_time);
	return (int)m->tm_mon+1;
}

int CTimeUTC::GetLocalDay()
{
	tm *m=localtime(&m_time);
	return (int) m->tm_mday;
}

int CTimeUTC::GetLocalHour()
{
	tm *m=localtime(&m_time);
	return (int) m->tm_hour;
}

int CTimeUTC::GetLocalMinute()
{
	tm *m=localtime(&m_time);
	return (int) m->tm_min;
}

int CTimeUTC::GetLocalSecond()
{
	tm *m=localtime(&m_time);
	return (int) m->tm_sec;
}

int CTimeUTC::GetLocalDayOfWeek()
{
	tm *m=localtime(&m_time);
	return (int) m->tm_wday;
}

time_t CTimeUTC::GetFullHours(int mask)
{
	if(mask<0 || mask>23) mask=1;
	CTimeUTC timeT(m_year,m_mon,m_day,(m_hour/mask)*mask,0,0);
	return timeT.m_time;
}

time_t CTimeUTC::MakeUTCTime(int wYear, int wMonth, int wDay,int wHour, int wMinute, int wSecond)
{
	time_t ti=0;
	int nDaysInMonth;
	BOOL bLeapYear;

	// One-based array of days in year at month start
	int MonthDays[13] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365};

	// Validate year and month (ignore day of week and milliseconds)
	if (wYear <1980 || wYear > 2038 || wMonth < 1 || wMonth > 12)	goto errend;

	//  Check for leap year and set the number of days in the month
	bLeapYear = ((wYear & 3) == 0) && ((wYear % 100) != 0 || (wYear % 400) == 0);

	nDaysInMonth = MonthDays[wMonth] - MonthDays[wMonth-1] +
		((bLeapYear && wDay == 29 && wMonth == 2) ? 1 : 0);

	// Finish validating the date
	if (wDay < 1 || wDay > nDaysInMonth || wHour > 23 || wMinute > 59 || wSecond > 59) 	goto errend;

	// Cache the date in days and time in fractional days

	//It is a valid date; make Jan 1, 1AD be 1
	ti = wYear*365 + wYear/4 - wYear/100 + wYear/400 + 	MonthDays[wMonth-1] + wDay;

	//  If leap year and it's before March, subtract 1:
	if (wMonth <= 2 && bLeapYear) --ti;

	//  Offset so that 1/1/1970 is 0 
	ti -= 719528;

	ti = ((wHour * 3600L) + (wMinute * 60L) +  wSecond) + (ti*86400);

errend:
	SetMyTime(ti);

	return ti;
}

time_t  CTimeUTC::getSynopTime(int wDay, int wHour, int wMinute)
{
	SYSTEMTIME st;
	::GetSystemTime(&st);
	int wYear=st.wYear;
	int	wMonth=st.wMonth;


	time_t ti;
	// One-based array of days in year at month start
	int MonthDays[13] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365};

	// Validate year and month (ignore day of week and milliseconds)
	if (wYear > 9999 || wMonth < 1 || wMonth > 12)	return -1;

	//  Check for leap year and set the number of days in the month
	BOOL bLeapYear = ((wYear & 3) == 0) && ((wYear % 100) != 0 || (wYear % 400) == 0);

	if(wDay>st.wDay)
		{ //liegt der Tag in der Zukunft, dann ist die reference time aus dem Monat davor.
		wMonth--; if(wMonth<1) {wMonth=12; wYear--; } 
		}

	int nDaysInMonth = MonthDays[wMonth] - MonthDays[wMonth-1] +
		((bLeapYear && wDay == 29 && wMonth == 2) ? 1 : 0);

	// Finish validating the date
	if (wDay < 1 || wDay > nDaysInMonth || wHour > 23 || wMinute > 59) 	return -1;

	// Cache the date in days and time in fractional days

	//It is a valid date; make Jan 1, 1AD be 1
	ti = wYear*365 + wYear/4 - wYear/100 + wYear/400 + 	MonthDays[wMonth-1] + wDay;

	//  If leap year and it's before March, subtract 1:
	if (wMonth <= 2 && bLeapYear) --ti;

	//  Offset so that 1/1/1970 is 0 
	ti -= 719528;

	ti = (wHour * 3600L) + (wMinute * 60L) + (ti*86400);
	return ti;
}



time_t CTimeUTC::MakeLocalTime(int wYear, int wMonth, int wDay,int wHour, int wMinute, int wSecond)
{
	int MonthDays[13] = {0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365};

	// Validate year and month (ignore day of week and milliseconds)
	if (wYear > 9999 || wMonth < 1 || wMonth > 12)	return -1;

	//  Check for leap year and set the number of days in the month
	BOOL bLeapYear = ((wYear & 3) == 0) && ((wYear % 100) != 0 || (wYear % 400) == 0);

	int nDaysInMonth = MonthDays[wMonth] - MonthDays[wMonth-1] +
		((bLeapYear && wDay == 29 && wMonth == 2) ? 1 : 0);

	// Finish validating the date
	if (wDay < 1 || wDay > nDaysInMonth || wHour > 23 || wMinute > 59 || wSecond > 59) 	return -1;


	struct tm atm;
	atm.tm_sec = wSecond;
	atm.tm_min = wMinute;
	atm.tm_hour = wHour;
	atm.tm_mday = wDay;
	atm.tm_mon = wMonth - 1;        // tm_mon is 0 based
	atm.tm_year = wYear - 1900;     // tm_year is 1900 based
	atm.tm_isdst = -1;
	time_t ti = mktime(&atm);
	return ti;
}

void CTimeUTC::SetMyTime(time_t ti)
{
	if(!ti) ti=::time(NULL);

	m_time=ti;
	tm *m=gmtime(&ti);

	if(!m) 
		{
		ti=::time(NULL);
		m_time=ti;
		m=gmtime(&ti);
		}

	m_year=m->tm_year+1900;
	m_mon=m->tm_mon+1;
	m_day=m->tm_mday;
	m_hour=m->tm_hour;
	m_min=m->tm_min;
	m_sec=m->tm_sec;
	m_wday=m->tm_wday;
}


time_t CTimeUTC::AddHours(int hours,time_t tref)
{
	int			i,daymax;
	tm			*m;

	if(tref) m=gmtime(&tref);
	else m=gmtime(&m_time);

	m->tm_isdst=-1;

   	for(i=0; i<hours; i++)
		{
		m->tm_hour++;
		if(m->tm_hour>23)
			{
			m->tm_hour=0;
			m->tm_mday++;
			
			daymax=cDaysInMonth[m->tm_mon];
			// Check for leap year.
			if(m->tm_mon==1 && m->tm_year % 100 != 0 && m->tm_year % 4 == 0) daymax++;

			if(m->tm_mday>daymax)
				{
				m->tm_mday=1;
				m->tm_mon++;
				if(m->tm_mon>12) 
					{
					m->tm_mon=0;
					m->tm_year++;
					}
				}	
			}
		}
  	
	m_time = mktime(m);
	ASSERT(m_time != -1);       // indicates an illegal input m_time

	return m_time;
}

time_t CTimeUTC::SubHours(int hours,time_t tref)
{
	int			i;
	tm			*m;

	if(tref) m=gmtime(&tref);
	else m=gmtime(&m_time);

	m->tm_isdst=-1;

   	for(i=0; i<hours; i++)
		{
		m->tm_hour--;
		if(m->tm_hour<0)
			{
			m->tm_hour=23;
			m->tm_mday--;
			if(m->tm_mday<1)
				{
				m->tm_mon--;
				if(m->tm_mon<0) 
					{
					m->tm_year--;
					m->tm_mon=12;
					}

				m->tm_mday=cDaysInMonth[m->tm_mon];
				// Check for leap year.
				if(m->tm_mon==1 && m->tm_year % 100 != 0 && m->tm_year % 4 == 0) m->tm_mday++;
				}
			}
		}
  	
	m_time = mktime(m);
	ASSERT(m_time != -1);       // indicates an illegal input m_time

	return m_time;
}

CTimeUTC PASCAL CTimeUTC::GetCurrentTime()
// return the current system time
{
	return CTimeUTC(::time(NULL));
}

BOOL CTimeUTC::GetAsSystemTime(SYSTEMTIME& timeDest) const
{
	timeDest.wYear = m_year;
	timeDest.wMonth = m_mon;
	timeDest.wDayOfWeek = 0;
	timeDest.wDay = m_day;
	timeDest.wHour = m_hour;
	timeDest.wMinute = m_min;
	timeDest.wSecond = m_sec;
	timeDest.wMilliseconds = 0;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// String formatting

#define maxTimeBufferSize       128
	// Verifies will fail if the needed buffer size is too large
#include <TIME.H>

CString CTimeUTC::FormatLocal(LPCTSTR pFormat) const
{
	TCHAR szBuffer[maxTimeBufferSize];
	struct tm* ptmTemp = localtime(&m_time);
	if (ptmTemp == NULL ||
		!_tcsftime(szBuffer, _CountOf(szBuffer), pFormat, ptmTemp))
		szBuffer[0] = '\0';
	return szBuffer;
}


CString CTimeUTC::FormatGMT(LPCTSTR pFormat) const
{
	TCHAR szBuffer[maxTimeBufferSize];

	struct tm* ptmTemp = gmtime(&m_time);
	if (ptmTemp == NULL ||
		!_tcsftime(szBuffer, _CountOf(szBuffer), pFormat, ptmTemp))
		szBuffer[0] = '\0';
	return szBuffer;
}

CString CTimeUTC::Format(LPCTSTR pFormat) const
{
	TCHAR szBuffer[maxTimeBufferSize];

	struct tm* ptmTemp = gmtime(&m_time);
	if (ptmTemp == NULL ||
		!_tcsftime(szBuffer, _CountOf(szBuffer), pFormat, ptmTemp))
		szBuffer[0] = '\0';
	return szBuffer;
}

CString CTimeUTC::Format(time_t my_time, LPCTSTR pFormat) const
{
	TCHAR szBuffer[maxTimeBufferSize];

	struct tm* ptmTemp = gmtime(&my_time);
	if (ptmTemp == NULL ||
		!_tcsftime(szBuffer, _CountOf(szBuffer), pFormat, ptmTemp))
		szBuffer[0] = '\0';
	return szBuffer;
}

time_t CTimeUTC::SetDosTime(WORD date,WORD time)
{
    int wDay	= (UINT)(date&0x1f);
    int wMonth	=  (UINT)((((date)&0x1E0)/0x20));
    int	wYear	= (UINT)(((date&0x0FE00)/0x0200)+1980);

	int	wHour = (UINT) ((time&0xF800)/0x800);
	int	wMinute =  (UINT) ((time&0x7E0)/0x20);
    int wSecond =  (UINT) (2*(time&0x1f));

	SetMyTime(MakeLocalTime(wYear,wMonth,wDay,wHour,wMinute,wSecond));

	return m_time;
}


time_t PASCAL CTimeUTC::GetFileTimeAsCTime(FILETIME &fileTime)
{
	CTimeUTC timeT(fileTime);
	return timeT.m_time;
}

time_t CTimeUTC::GetTimeFromFile(char *filename)
{
	FILETIME	LastWrite; 
	HANDLE		hFile;

	//return FALSE is the same as file not exist;
	SetMyTime();

	hFile = CreateFile(filename,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile==INVALID_HANDLE_VALUE) return m_time;	//file not exist;
	BOOL get=::GetFileTime(hFile, NULL,NULL,&LastWrite);
	CloseHandle(hFile);

	SYSTEMTIME sysTime;
	if (!FileTimeToSystemTime(&LastWrite, &sysTime))
		{
		SetMyTime();
		return m_time;
		}

	CTimeUTC timeT((int)sysTime.wYear, (int)sysTime.wMonth, (int)sysTime.wDay,
				(int)sysTime.wHour, (int)sysTime.wMinute, (int)sysTime.wSecond);
	*this = timeT;

	return m_time;
}

BOOL CTimeUTC::GetAsFileTime(FILETIME &fileTime)
{
	SYSTEMTIME	sysTime;
	
	sysTime.wYear = m_year;
	sysTime.wMonth = m_mon;
	sysTime.wDayOfWeek = 0;
	sysTime.wDay = m_day;
	sysTime.wHour = m_hour;
	sysTime.wMinute = m_min;
	sysTime.wSecond = m_sec;
	sysTime.wMilliseconds = 0;

	
	if (!SystemTimeToFileTime(&sysTime,&fileTime)) return NULL;

	return TRUE;
}












