// MyPanoramaCtrl.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"
#include "MyPanoramaCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MyPanoramaCtrl dialog


MyPanoramaCtrl::MyPanoramaCtrl(CWnd* pParent)
	: CDialog(MyPanoramaCtrl::IDD, pParent)
{
	//{{AFX_DATA_INIT(MyPanoramaCtrl)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void MyPanoramaCtrl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MyPanoramaCtrl)
	DDX_Control(pDX, IDC_IF_TOP_OFF,		b_topOFF);
	DDX_Control(pDX, IDC_PA_AMPL_POTI,		p_Ampl);
	DDX_Control(pDX, IDC_PA_WIDTH_POTI,		p_Width);
	DDX_Control(pDX, IDC_PANORAMA_VIEW,		m_View);
	DDX_Control(pDX, IDC_IFSTYLE_DEC,		b_LIN);
	DDX_Control(pDX, IDC_PA_IFSTYLE_TSV,	b_TSV);
	DDX_Control(pDX, IDC_PA_DLG_ONOFF,		b_ExtDLG);
	DDX_Control(pDX, IDC_PA_CMP_LINE,		b_CMP);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MyPanoramaCtrl, CDialog)
	//{{AFX_MSG_MAP(MyPanoramaCtrl)
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_IF_TOP_OFF,		OnIfTopOff)
	ON_BN_CLICKED(IDC_IFSTYLE_DEC,		OnSetLIN)
	ON_BN_CLICKED(IDC_PA_IFSTYLE_TSV,	OnSetTSV)
	ON_BN_CLICKED(IDC_PA_DLG_ONOFF,		OnShowExtDialog)
	ON_BN_CLICKED(IDC_PA_CMP_LINE,		OnSetCompareLine)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_POTICHANGE,			OnPotiChange)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MyPanoramaCtrl message handlers

BOOL MyPanoramaCtrl::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	p_Ampl.Init("Bright",540,10,NULL,SET_LEFT);

	myPanoramaStyle.m_ampl=AfxGetApp()->GetProfileInt("PANORAMA","Ampl",0);
	myIQPara.width=AfxGetApp()->GetProfileInt("PANORAMA","Width",myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq);
	myIQPara.pos=AfxGetApp()->GetProfileInt("PANORAMA","Position",0);
	myPanoramaStyle.m_style=AfxGetApp()->GetProfileInt("PANORAMA","Style",IF_STYLE_DEC);

	myPanoramaStyle.topAmpl=AfxGetApp()->GetProfileInt("PANORAMA","TopAmpl",0);
	myPanoramaStyle.topLevel=AfxGetApp()->GetProfileInt("PANORAMA","TopLevel",0);
	myPanoramaStyle.topStyle=AfxGetApp()->GetProfileInt("PANORAMA","TopStyle",IF_STYLE_TOP_TIV);
	myPanoramaStyle.topOFF=AfxGetApp()->GetProfileInt("PANORAMA","TopOFF",0);
	myPanoramaStyle.topYPos=AfxGetApp()->GetProfileInt("PANORAMA","TopYPos",45);
	myPanoramaStyle.m_DecLevel=AfxGetApp()->GetProfileInt("PANORAMA","DecLevel",100);
	myPanoramaStyle.m_DecScale=AfxGetApp()->GetProfileInt("PANORAMA","DecScale",0);
	myPanoramaStyle.m_smoothing=AfxGetApp()->GetProfileInt("PANORAMA","Delay",50);

	CRect myRect;
	myMainFrm->GetWindowRect(myRect);
	myRect.top=myRect.bottom-180; if(myRect.top<0) {myRect.top=0; myRect.bottom=180;}

	myRect.top=AfxGetApp()->GetProfileInt("PANORAMA","RectTop",myRect.top);
	myRect.left=AfxGetApp()->GetProfileInt("PANORAMA","RectLeft",myRect.left);
	myRect.bottom=AfxGetApp()->GetProfileInt("PANORAMA","RectBot",myRect.bottom);
	myRect.right=AfxGetApp()->GetProfileInt("PANORAMA","RectRight",myRect.right);

	p_Ampl.Set(myPanoramaStyle.m_ampl);
	p_Width.Set(myIQPara.width);
	b_topOFF.SetCheck(myPanoramaStyle.topOFF);
	b_CMP.SetImage(IDB_CMP_LINE);
	b_ExtDLG.SetImage(IDB_DLGBAR);

	AdjustBottons();
	myCtrl.Create(IDD_EXTIO_DIALOG,this);
	SetCheckPlacement(m_hWnd,myRect,0);
	AdjustView();
	InitParameter(myExtRxPara.IQ_type);

	myCtrl.GetWindowRect(myRect);
	myRect.top=AfxGetApp()->GetProfileInt("EXTIO_CTRL","WindowTop",myRect.top);
	myRect.left=AfxGetApp()->GetProfileInt("EXTIO_CTRL","WindowLeft",myRect.left);
	if(AfxGetApp()->GetProfileInt("EXTIO_CTRL","show",0)) SetCheckPlacement(myCtrl.m_hWnd,myRect,SWP_NOSIZE|SWP_SHOWWINDOW);
	else SetCheckPlacement(myCtrl.m_hWnd,myRect,SWP_NOSIZE|SWP_HIDEWINDOW);
	m_View.SetOff(CLEAR_DRAW); //let's draw
	//without a original RadioJet Directory, we are missing the ExtIQ-Directory too, that make big problems
	if(myExtRxPara.IQ_noAccess) myCtrl.ShowWindow(SW_HIDE);
	return TRUE;            
}

void MyPanoramaCtrl::OnCancel() 
{
	if(myCtrl.IsWindowVisible()) OnShowExtDialog();
	myIFControl.SetExternView(0);
	CDialog::OnCancel();
}

void MyPanoramaCtrl::OnClose() 
{
	if(myCtrl.IsWindowVisible()) OnShowExtDialog();
	myIFControl.SetExternView(0);
	CDialog::OnClose();
}

void MyPanoramaCtrl::InitParameter(UINT type)   
// type  = of Receiver-Type  0= RadioJet 1=FiFiSDR 2=Pappradio
{
	if(type!=myExtRxPara.IQ_type)
		{
		myExtRxPara.IQ_default=1;
		myExtRxPara.IQ_type=type;
		PepareExtIQDataSet(&myExtRxPara);
		}

	if(myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_multiplex)
		{
		myExtIQScanner.scann_blocks=myMultiplexer[myExtRxPara.IQ_mode].scann_blocks;
		myExtIQScanner.scann_blockcount=myMultiplexer[myExtRxPara.IQ_mode].scann_blocks;
		myExtIQScanner.scann_max=myMultiplexer[myExtRxPara.IQ_mode].scann_max;
		myExtIQScanner.scann_count=0;
		myExtIQScanner.scann_active=1;

		myExtIQScanner.scann_frq_offfset=-(int)((myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq>>1)	-90000);
		myIQPara.m_sample_num=myMultiplexer[myExtRxPara.IQ_mode].smpl_size;
		myMultiplexer[0].smpl_num=myMultiplexer[myExtRxPara.IQ_mode].smpl_num;
		}
	else
		{
		myExtIQScanner.SupportWindow=NULL;	
		myExtIQScanner.scann_active=0;
		myIQPara.m_sample_num=(1<<(myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_spow+6));
		}

	myIQPara.m_sample_freq=myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_freq<<1;  

	if(myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_downsampling)
		{
		myIQPara.m_sample_freq=myIQPara.m_sample_freq<<myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_downsampling;
		myIQPara.m_sample_num=myIQPara.m_sample_num<<myExtRxPara.RTLPara.SampleSets[myExtRxPara.IQ_mode].IQ_downsampling;
		}

	int	minstep=100, steps=2000, width=myIQPara.m_sample_freq>>1;

	if(width<60000)			steps=1000; 
	else if(width<120000)	steps=2000; 
	else if(width<250000)	{steps=5000; minstep=500;}
	else if(width<500000)	{steps=10000; minstep=1000;}
	else if(width<1000000)	{steps=20000; minstep=1000;}
	else {steps=50000; minstep=5000;}

	p_Width.Init("Width",width,steps,NULL,SET_RIGHT); //spectrum band width in KHz
	p_Width.m_minstep=minstep;
	p_Width.Set(width); //view all times the value      
	myIQPara.pos=0;
	myIQPara.width=width;
	PotiNormalisation();


	//now init the View 
	m_View.SetOff(DONT_DRAW); //do not draw
	m_View.Init();
	myCtrl.EnableOptions();
	SetFilterParameter();

	CString str,title;
	switch(myExtRxPara.IQ_type)
		{
		default:				str=""; break;
		case ExtIO_TYPE_PANO:	str=radios[0]; break;
		case ExtIO_TYPE_FIFI:	str=radios[1]; break;
		case ExtIO_TYPE_PAPP:	str=radios[2]; break;
		case ExtIO_TYPE_FDM1:	str=radios[3]; break;
		case ExtIO_TYPE_IQ14:	str=radios[4]; break;
		case ExtIO_TYPE_PMSDR:	str=radios[5]; break;
		case ExtIO_TYPE_PERSEUS:str=radios[6]; break;
		case ExtIO_TYPE_G31DCD:	str=radios[7]; break;
		case ExtIO_TYPE_G33DCD:	str=radios[8]; break;
		}

	title.Format(" %d kHz resizable Panorama Spectroscope of the I/Q Receiver %s / Open Source Examples of Bonito RJ10.DLL",width/1000,str);
	SetWindowText(title);
	Invalidate();

	InDeviceList &mDeviceList=GetInputDeviceList();
	myInDeviceList.RemoveAll();
	myInDeviceList.SetSize(mDeviceList.GetSize());
	memcpy(myInDeviceList.GetData(),mDeviceList.GetData(),sizeof(IN_DEVICE_INFO)*mDeviceList.GetSize());
	m_View.SetOff(RESTORE_DRAW); //restore draw-off-state 

}

void MyPanoramaCtrl::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(m_View.init)
		{
		AdjustView();
		m_View.ReSizeSpectrum(1);
		}
}

void MyPanoramaCtrl::AdjustView() 
{
	CRect re,ra,rx;
	GetClientRect(re);
	b_TSV.GetWindowRect(ra);
	ScreenToClient(ra);
	m_View.GetWindowRect(rx);
	ScreenToClient(rx);

	re.top=rx.top;
	re.left=rx.left;
	if(re.Width()>50 && re.Height()>100) m_View.SetWindowPos(NULL,0,0,re.Width(),re.Height(),NO_MOVE);
}

LRESULT MyPanoramaCtrl::OnPotiChange(WPARAM wParam, LPARAM lParam)
{
	int x=(int)lParam;
	int pos=lParam;

	if((HWND)wParam==p_Ampl.m_hWnd)
		{
		SetAmpl(lParam);
		}
	else if((HWND)wParam==p_Width.m_hWnd)
		{
		SetWidth(lParam);
		}
	return NULL;
}

void MyPanoramaCtrl::SetWidth(int pos)
{
	if(pos <1000) pos=1000;
	int mid=((myIQPara.m_hi+myIQPara.m_lo)/2)-(pos/2);
	if(mid<0) mid=0;
	myIQPara.pos=mid;
	myIQPara.width=pos;
	SetFilterParameter();
}

void MyPanoramaCtrl::SetPosition(int pos)
{
	myIQPara.pos=pos;
	SetFilterParameter();
}

void MyPanoramaCtrl::PotiNormalisation()
{
	int lo,hi,max=myIQPara.m_sample_freq>>1;

	if(myIQPara.width >max) myIQPara.width	=max;
	if(myIQPara.pos  >max) myIQPara.pos	=max;
	if(myIQPara.width <1000) myIQPara.width	=1000;
	if(myIQPara.pos	<0) myIQPara.pos=0;

	lo=myIQPara.pos;
	hi=lo+myIQPara.width;
	if(hi>max)
		{
		lo=max-myIQPara.width;
		hi=lo+myIQPara.width;
		}
	
	myIQPara.width=hi-lo;
	myIQPara.pos=lo;

	int pos=(int)((float)myIQPara.width/20.f+.5f)*20;
	p_Width.Set(pos);
	p_Ampl.Set(myPanoramaStyle.m_ampl);

	myIQPara.m_lo=int(lo);
	myIQPara.m_hi=int(hi);
}

void MyPanoramaCtrl::SetAmpl(int ampl) 
{	
	myPanoramaStyle.m_ampl=ampl;
	p_Ampl.Set(ampl);
	m_View.SetAmpl(myPanoramaStyle.m_ampl);
	m_View.RefreschWindow(2);
}

void MyPanoramaCtrl::SetFilterParameter() 
{
	PotiNormalisation();
	m_View.OnFilterChanged();
	m_View.RefreschWindow(2);
}

void MyPanoramaCtrl::OnIfTopOff() 
{
	if(myPanoramaStyle.topOFF) myPanoramaStyle.topOFF=0;
	else myPanoramaStyle.topOFF=1;
	b_topOFF.SetCheck(myPanoramaStyle.topOFF);
	m_View.ReSizeSpectrum(3);
}

void MyPanoramaCtrl::AdjustBottons()
{
	int m_style=myPanoramaStyle.m_style&IF_STYLE_MASK;
	b_topOFF.SetCheck(myPanoramaStyle.topOFF);
	b_TSV.SetCheck(m_style&IF_STYLE_TIV);
	b_LIN.SetCheck(myPanoramaStyle.m_style&IF_STYLE_DEC);
}

void MyPanoramaCtrl::OnSetTSV() 
{
	myPanoramaStyle.m_style=IF_STYLE_TIV;
	m_View.RefreschWindow(2);
	AdjustBottons();
}

void MyPanoramaCtrl::OnSetLIN()
{
	myPanoramaStyle.m_style=IF_STYLE_DEC;
	m_View.RefreschWindow(2);
	AdjustBottons();
}

void MyPanoramaCtrl::SetExtIODialog(int set) 
{
	if(b_ExtDLG.GetSafeHwnd())
		{
		if(!myExtRxPara.IQ_open)
			{
			b_ExtDLG.SetCheck(0);
			myIFControl.b_ExtDLG.SetCheck(0);
			//b_ExtDLG.SetImage(IDB_DLGBAR2);
			//b_ExtDLG.EnableWindow(FALSE);
			}
		else
			{
			b_ExtDLG.EnableWindow(TRUE);
			b_ExtDLG.SetCheck(set);
			myIFControl.b_ExtDLG.SetCheck(set);
			if(set) 
				{
				b_ExtDLG.SetImage(IDB_DLGBAR1);
				myIFControl.b_ExtDLG.SetImage(IDB_DLGBAR1);
				}
			else
				{
				b_ExtDLG.SetImage(IDB_DLGBAR);
				myIFControl.b_ExtDLG.SetImage(IDB_DLGBAR);
				}
			}
		}
}

void MyPanoramaCtrl::OnShowExtDialog() 
{
	//without a original RadioJet Directory, we are missing the ExtIQ-Directory too, that make big problems
	if(myExtRxPara.IQ_noAccess) myCtrl.ShowWindow(SW_HIDE);
	else
		{
		myCtrl.ShowWindow(!myCtrl.IsWindowVisible());
		SetExtIODialog(myCtrl.IsWindowVisible());
		}
}

void MyPanoramaCtrl::OnSetCompareLine() 
{
	if(!m_View.DrawDoubleLine)
		{
		m_View.SetDoupleLine(1,DEF_IF_SAMPLE_FRQ,DEF_IF_SAMPLE_NUM);
		b_CMP.SetImage(IDB_CMP_LINE1);
		}
	else
		{
		m_View.SetDoupleLine(0);
		b_CMP.SetImage(IDB_CMP_LINE);
		}
	b_CMP.SetCheck(m_View.DrawDoubleLine);
}