////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10FiFi
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#if !defined(MY_PANORAMA_CTRL)
#define MY_PANORAMA_CTRL

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyPanoramaCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// MyPanoramaCtrl dialog
#include "MyClasses/MyPanoramaView.h"
#include "MyClasses/MyPoti.h"
#include "MyClasses/MyButton.h"
#include "MyClasses/ExtIQControl.h"
#include "RJ10M-DLL.h"

class MyPanoramaCtrl : public CDialog
{
// Construction
public:
	MyPanoramaCtrl(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(MyPanoramaCtrl)
	enum { IDD = IDD_PANORAMA_CTRL };
	MyButton		b_topOFF;
	MyPoti			p_Width;
	MyPoti			p_Ampl;
	MyPanoramaView	m_View;
	MyButton		b_LIN;
	MyButton		b_TSV;
	MyButton		b_ExtDLG;
	MyButton		b_CMP;
	//}}AFX_DATA

	friend class IFScopeControl;
	ExtIQControl	myCtrl;

	void			InitParameter(UINT type);
	void			SetWidth(int pos);
	void			SetPosition(int pos);
	void			PotiNormalisation();
	void			SetAmpl(int ampl);
	void			SetFilterParameter();
	void			SetStyle(int style);
	void			AdjustBottons();
	void			SetExtIODialog(int set);
	void			AdjustView();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(MyPanoramaCtrl)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(MyPanoramaCtrl)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual void OnCancel();
	afx_msg void OnClose();
	afx_msg void OnIfTopOff();
	afx_msg void OnSetLIN();
	afx_msg void OnSetTSV();
	afx_msg void OnShowExtDialog();
	afx_msg void OnSetCompareLine();
	//}}AFX_MSG
	afx_msg LRESULT OnPotiChange(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(MY_PANORAMA_CTRL)

