// RJ10MiniDlg.cpp : implementation file
//
////////////////////////////////////////////////////
////////////////////////////////////////////////////
// !!! this is not public domain !!!
// You can do what you want if it never hurt bonito.
// Otherwise, you will need the consent of Bonito.	
////////////////////////////////////////////////////
// RadioJet Open Source Project RJ10Mini
// www.bonito.net/radiojet/opensource
////////////////////////////////////////////////////
////////////////////////////////////////////////////

#include "stdafx.h"
#include "GlobalTools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	MyButton	b_web;
	MyButton	b_src;
	CStatic		t_app;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	afx_msg void GoWebLink();
	afx_msg void GoSourceLink();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_WEBLINK,	b_web);
	DDX_Control(pDX, IDC_SOURCELINK,b_src);
	DDX_Control(pDX, IDC_APP_TEXT,	t_app);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_WEBLINK,		GoWebLink)
	ON_BN_CLICKED(IDC_SOURCELINK,	GoSourceLink)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if(DiRaWaveFlag)
		{
		b_web.SetWindowText("go --> NTi WebSite");
		t_app.SetWindowText("Example Source and Mini-Aplication for the DiRaWave 0032U");
		}
	else
		{
		b_web.SetWindowText("go ---> Bonito WebSites");
		t_app.SetWindowText("Example Source and Mini-Aplication for the RadioJet 1102S");
		}

	return TRUE;  
}

void CAboutDlg::GoWebLink() 
{
	if(DiRaWaveFlag) 
		{
		LANGID l=GetSystemDefaultLangID();
		int lang=l&=15;
		if(lang==7) ShellExecute(NULL, NULL,"http://www.nti-online.de/dirawave032.htm", NULL,NULL, SW_SHOWNORMAL);
		else ShellExecute(NULL, NULL,"http://www.nti-online.de/edirawave032.htm", NULL,NULL, SW_SHOWNORMAL);
		}
	else ShellExecute(NULL, NULL,"http://www.bonito.net/radiojet", NULL,NULL, SW_SHOWNORMAL);
	EndDialog(0);	
}

void CAboutDlg::GoSourceLink() 
{
	ShellExecute(NULL, NULL,"http://www.bonito.net/manuals/radiojet/sites/en_Overview.htm", NULL,NULL, SW_SHOWNORMAL);
	EndDialog(0);	
}



/////////////////////////////////////////////////////////////////////////////
// CRJ10MiniDlg dialog

CRJ10MiniDlg::CRJ10MiniDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRJ10MiniDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRJ10MiniDlg)
	m_frqedit = _T("");
	//}}AFX_DATA_INIT

	m_frq=LastDeviceCheck=ImOpen=0;
	m_steps=100;
	m_mode=REC_AM;
	m_filterwidth=9000;
	m_ATT,m_MM,m_CHN,m_TOPMOST=0;
	viewcntr=Ext_viewcntr=drm_update=0;
	m_sql=m_volume=m_stereoON=0;
	RxAction=0;
	IFGainLevel=SaveIFGainLevel=IFOutLevel=AFInLevel=AFOutLevel=16;
	IFGainOff=m_spkON=1;
	DrawDelaySum=0;
	DrawDelayFac=.1f;
	DrawInputFac=(float)IF_SAMPLE_NUM/(float)IF_SAMPLE_FRQ;
	DrawImmediately=0;
}

void CRJ10MiniDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRJ10MiniDlg)
	DDX_Control(pDX, IDC_GB1,				m_gb1);
	DDX_Control(pDX, IDC_GB3,				m_gb2);
	DDX_Control(pDX, IDC_FRQBUTTON,			m_FrqButton);
	DDX_Control(pDX, IDC_MIN_MAX,			b_MinMax);
	DDX_Control(pDX, IDC_MANUAL,			b_manual);
	DDX_Control(pDX, IDC_ATT,				b_ATT);
	DDX_Control(pDX, IDC_CHN_RX,			b_RX);
	DDX_Control(pDX, IDC_CHN_DX,			b_DX);
	DDX_Text(pDX, IDC_FRQ_EDIT,				m_frqedit);
	DDX_Control(pDX, IDC_FRQ_EDIT,			e_frqedit);
	DDX_Control(pDX, IDC_IGC,				b_IGC);
	DDX_Control(pDX, IDC_MODE,				b_mode);
	DDX_Control(pDX, IDC_FILTER,			b_filter);
	DDX_Control(pDX, IDC_POTI_SQL,			poti_sql);
	DDX_Control(pDX, IDC_VOLUME_POTI,		poti_vol);


	DDX_Control(pDX, IDC_AUDIO_ONOFF,		b_speaker);
	DDX_Control(pDX, IDC_AUDIO_STEREO,		b_stereo);
	DDX_Control(pDX, IDC_AUDIO_MIXER,		b_mixer);
	DDX_Control(pDX, IDC_SET_IFGAIN,		b_gainset);

	DDX_Control(pDX, IDC_IFGAIN_POTI,		poti_gain);
	DDX_Control(pDX, IDC_AUDIO_OUT_POTI,	poti_out);

	DDX_Control(pDX, IDC_IN_LEVEL,			m_inpeek);
	DDX_Control(pDX, IDC_OUT_LEVEL,			m_outpeek);
	DDX_Control(pDX, IDC_SMETER,			m_smeter);
	DDX_Control(pDX, IDC_SYSTEM_MODAL,		m_symod);
	
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_FRQ_FIG_1,		b_fig[0]);
	DDX_Control(pDX, IDC_FRQ_FIG_2,		b_fig[1]);
	DDX_Control(pDX, IDC_FRQ_FIG_3,		b_fig[2]);
	DDX_Control(pDX, IDC_FRQ_FIG_4,		b_fig[3]);
	DDX_Control(pDX, IDC_FRQ_FIG_5,		b_fig[4]);
	DDX_Control(pDX, IDC_FRQ_FIG_6,		b_fig[5]);
	DDX_Control(pDX, IDC_FRQ_FIG_7,		b_fig[6]);
	DDX_Control(pDX, IDC_FRQ_FIG_8,		b_fig[7]);
	DDX_Control(pDX, IDC_FRQ_FIG_9,		b_fig[8]);
	DDX_Control(pDX, IDC_FRQ_FIG_0,		b_fig[9]);
	DDX_Control(pDX, IDC_FRQ_FIG_POINT,	b_fig[10]);
	DDX_Control(pDX, IDC_FRQ_FIG_CLR,	b_fig[11]);
	DDX_Control(pDX, IDC_FRQ_FIG_SET,	b_fig[12]);

	DDX_Control(pDX, IDC_FRQ_MEM1,		b_mem[0]);
	DDX_Control(pDX, IDC_FRQ_MEM2,		b_mem[1]);
	DDX_Control(pDX, IDC_FRQ_MEM3,		b_mem[2]);
	DDX_Control(pDX, IDC_FRQ_MEM4,		b_mem[3]);

	DDX_Control(pDX, IDC_UTIL_LED_MSC,	ledMCS);
	DDX_Control(pDX, IDC_UTIL_LED_FAC,	ledFAC);
	DDX_Control(pDX, IDC_UTIL_LED_SDC,	ledSDC);
	DDX_Control(pDX, IDC_UTIL_LED_IO,	ledIO);
}

BEGIN_MESSAGE_MAP(CRJ10MiniDlg, CDialog)
	
	ON_MESSAGE(WM_DRM_STATE_CHANGE,		OnDRMChange)

	//{{AFX_MSG_MAP(CRJ10MiniDlg)
	ON_WM_DEVICECHANGE()
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_MIN_MAX,			OnSetMinOrMax)
	ON_BN_CLICKED(IDC_ATT,				OnAtt)
	ON_BN_CLICKED(IDC_CHN_DX,			OnChnDx)
	ON_BN_CLICKED(IDC_CHN_RX,			OnChnRx)
	ON_BN_CLICKED(IDC_IGC,				OnSetIGC)
	ON_BN_CLICKED(IDC_MODE,				OnSetMode)
	ON_BN_CLICKED(IDC_FILTER,			OnSetFilter)
	ON_BN_CLICKED(IDC_SET_IFGAIN,		OnSetGain)
	ON_BN_CLICKED(IDC_SYSTEM_MODAL,		OnSetSystemModal)
	ON_BN_CLICKED(IDC_AUDIO_MIXER,		OnAudioMixer)
	ON_BN_CLICKED(IDC_AUDIO_ONOFF,		OnSetSpeaker)
	ON_BN_CLICKED(IDC_AUDIO_STEREO,		OnSetStereo)
	ON_BN_CLICKED(IDC_MANUAL,			OnManual)
	//}}AFX_MSG_MAP

	ON_MESSAGE(WM_RBCLICK,				OnRightButton)
	ON_MESSAGE(WM_EDIT_CR,				OnFrqEditCR)
	ON_MESSAGE(WM_GET_SPECTRUM,			OnIFInput)
	ON_MESSAGE(WM_SET_OUTPEAK,			OnScopeOut)
	ON_MESSAGE(WM_START_ACTION,			StartAction)
	ON_MESSAGE(WM_HID_JET_ADD,			DeviceAdd)
	ON_MESSAGE(WM_HID_JET_REMOVE,		DeviceRemoved)
	ON_MESSAGE(WM_HID_EXT_ADD,			ExtDeviceAdd)
	ON_MESSAGE(WM_HID_EXT_REMOVE,		ExtDeviceRemoved)
	ON_MESSAGE(WM_HID_JET_GPI,			DeviceIOChanged)
	ON_MESSAGE(WM_UDP_SMETER_DBSM,		OnUpdateSmeterButton)
	ON_MESSAGE(WM_POTICHANGE,			OnPotiChange)
	ON_MESSAGE(WM_SET_SMETER,			SetSMeter)
	ON_MESSAGE(WM_SET_SQLLED,			SetSquelch)
	ON_MESSAGE(MM_MIXM_CONTROL_CHANGE,	OnMixCtrlChange)
	ON_MESSAGE(WM_SET_IF_INLEVEL,		IFinLevelChange)
	ON_MESSAGE(WM_SET_WAVEVOLUME,		WaveOutVolumeChange)
	ON_MESSAGE(WM_DRAW_FRQ,				DrawFrqAction)
	ON_MESSAGE(WM_EXTIQ_SHOW_CHNG,		OnExtIQSHOWChange)
	ON_MESSAGE(WM_EXTIQ_ATT_CHNG,		OnExtIQATTChange)
	ON_MESSAGE(WM_EXTIQ_PRE_CHNG,		OnExtIQPREChange)
	ON_MESSAGE(WM_EXTIQ_SMPL_CHNG,		OnExtIQSampleChange)
	ON_MESSAGE(WM_EXTIQ_CORR_CHNG,		OnExtIQCORRChange)
	ON_MESSAGE(WM_EXTIQ_SCAL_CHNG,		OnExtIQSCALChange)
	ON_MESSAGE(WM_EXTIQ_OFFS_CHNG,		OnExtIQOFFSChange)
	ON_MESSAGE(WM_EXTIQ_IFGN_CHNG,		OnExtIQIFGNChange)
	ON_MESSAGE(WM_EXTIQ_HFGN_CHNG,		OnExtIQHFGNChange)
	ON_MESSAGE(WM_EXTIQ_RTL_CHNG,		OnExtIQRTLChange)

	ON_CONTROL_RANGE(BN_CLICKED,IDC_FRQ_FIG_0,IDC_FRQ_FIG_CLR,	OnSetFrqDirect)
	ON_CONTROL_RANGE(BN_CLICKED,IDC_FRQ_MEM1,IDC_FRQ_MEM4,		OnSetFrqMemory)
	ON_NOTIFY_EX_RANGE(TTN_NEEDTEXT,0,0xFFFF,					OnToolTipText)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRJ10MiniDlg message handlers

BOOL CRJ10MiniDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	EnableToolTips();
	myMainFrm=this; //for global availability see --->GlobalTools.cpp

	CRect re;
	SystemParametersInfo(SPI_GETWORKAREA,NULL,re,NULL);
	if(re.Height()<760)	NetBookFormat=760-re.Height();	
	else NetBookFormat=0;

	
	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
		{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
			}
		strAboutMenu="set Mini or Maxi Control";
		pSysMenu->AppendMenu(MF_STRING, IDM_MIN_MAX, strAboutMenu);
		}

	
	// TODO: Add extra initialization here

	//standard routine for the first test work with HID.DLL
	//the RJ10.DLL works with the original Microsoft HID.dll --> see --> RJ10_GPIO = myHID
	//embedded in an Bonito Special Designs you can find instead the RJ1102S.DLL now.
	//the RJ1102S.dll serve the complex I / O background processes and keep all other useful routines
	//RJ1102S.dll and is now used by the RJ10.DLL.

	//Not because of the secrets you lack the description here, no,
	//because there is too much work for this small test example.
	
	if(!myHID.GetDeviceList()) //check the Radio Connetion
		{
		AfxMessageBox("the Receiver is not ready");
		CDialog::EndDialog(-1);
		return FALSE;
		}

	if(!Install_RJ10MDLL()) //now install the RJ10.dll
		{
		char buf[256];
		sprintf(buf,"DLL NOT FOUND -> %s\\RJ10.dll",myDIR);
		AfxMessageBox(buf);
		CDialog::EndDialog(-1);
		return FALSE;
		}

	//and now, we open the Receiver
	int result=OpenReceiver(m_hWnd,myDIR,-1);  //-1 == we conected this as MINI-APP
	if(result!=1)
		{
		if(result==-1) 	AfxMessageBox("RadioJet is not properly in the USB-Port, poor contact\nremove the device and connect it again !");
		else AfxMessageBox("RadioJet not found or device not connected");
		CDialog::EndDialog(-1);
		return FALSE;
		}

	memcpy(&myExtRxPara,&RJ10ExtRxPara,sizeof(EXT_IQRX)); //get the work parameters for the extern IQ moduls

	//the next genaration of the RadioJet will have a extern Panorama Receiver
	if(GetMyProfileInt("RADIO","internPanorama",5)==5) WriteMyProfileInt("RADIO","internPanorama",0); //the first one, this not exist
	internPanorama=GetMyProfileInt("RADIO","internPanorama",0);


	//catch the rectangles for the buttons (ATT,DX/RX Channel) MinMax Screen Adjustment
	b_ATT.GetWindowRect(maxRect);		   //get the position of Max-Screen left corner
	b_RX.GetWindowRect(re);	maxRect.right=re.right;  //and the right position
	ScreenToClient(maxRect); 

	m_smeter.GetWindowRect(minRect);	  //get the position of Min-Screen left and right corner
	ScreenToClient(minRect); 
	minRect.top+=4; //minRect.bottom++;
	//minRect.bottom= minRect.top+maxRect.Height(); //set the hight of the buttons
	//so we can use this rectangles for Adjust().......

		
	//!InitGraficUtilitys! --> newer use before RJ10M is installed 

	m_COL_KNOBFACE[0]=GetMyProfileInt("COLORS","KnobFace1",m_COL_KNOBFACE[0]);
	m_COL_KNOBFACE[1]=GetMyProfileInt("COLORS","KnobFace2",m_COL_KNOBFACE[1]);
	m_COL_KNOBFACE[2]=GetMyProfileInt("COLORS","KnobFace3",m_COL_KNOBFACE[2]);

	m_COL_SCOPE_B[0]=GetMyProfileInt("COLORS","ScopeBackL1",m_COL_SCOPE_B[0]);
	m_COL_SCOPE_B[1]=GetMyProfileInt("COLORS","ScopeBackL2",m_COL_SCOPE_B[1]);
    m_COL_SCOPE_B[2]=GetMyProfileInt("COLORS","ScopeBackL3",m_COL_SCOPE_B[2]);
 	m_COL_SCOPE_B2[0]=GetMyProfileInt("COLORS","ScopeBackH3",m_COL_SCOPE_B2[0]);
	m_COL_SCOPE_B2[1]=GetMyProfileInt("COLORS","ScopeBackH4",m_COL_SCOPE_B2[1]);
	m_COL_SCOPE_B2[2]=GetMyProfileInt("COLORS","ScopeBackH5",m_COL_SCOPE_B2[2]);

	InitGraficUtilitys(GetMyProfileInt("COLORS","selectedDesign",0));
	m_FrqButton.Init();

	m_IFctrl.Create(IDD_IF_SCOPE_CTRL,this);
	m_IFctrl.ReadEEpromData();

	DWORD  dwGetVer = GetVersion();
	WinVersion=LOBYTE(LOWORD(dwGetVer));

	if(WinVersion>5) 
		{
		 //window 7 have an light background
		if(DiRaWaveFlag) m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRM_DRW);
		else m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME); 
		}
	else
		{
		//XP have an dark background
		if(DiRaWaveFlag) m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRM_DRW_XP);
		else m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME_XP);	
		}

	SetIcon(m_hIcon, TRUE);		// Set small icon


	ledMCS.mini=ledFAC.mini=ledSDC.mini=ledIO.mini=1;

	b_manual.SetBold(1); 
	b_manual.SetColor(RGB(196,0,0),1);
	b_manual.SetStyle(1);
	m_symod.SetImage(IDB_SYSTEM_MODAL);
	m_symod.m_noBorder=2;
	b_fig[12].SetImage(IDB_SET_FRQ);

	m_frq=GetMyProfileInt("RADIO","LastFrq",177000);
	m_ATT=GetMyProfileInt("RADIO","ATT",m_ATT);
	m_MM=GetMyProfileInt("RADIO","MinMaxView",m_MM);
	m_CHN=GetMyProfileInt("RADIO","RXDXChannel",m_CHN);
	m_spkON=GetMyProfileInt("RADIO","SpeakerON",1);
	m_stereoON=GetMyProfileInt("RADIO","StereoON",0);

	m_TOPMOST=GetMyProfileInt("RADIO","SystemModal",0);
	m_IGC=GetMyProfileInt("RADIO","IGC",1);
	m_mode=GetMyProfileInt("RADIO","mode",3);

	//we have all times trouble and problems 
	//if a blind user does not know that the DRM is active
	//and he heard nothing
	if(m_mode==REC_DRM) m_mode=REC_AM; 

	m_filterwidth=GetMyProfileInt("RADIO","filterwidth",9000);
	m_sql=GetMyProfileInt("RADIO","squelch",0);
	m_volume=GetMyProfileInt("RADIO","volume",100);
	IFGainOff=GetMyProfileInt("RADIO","IFGainOff",1);
	IFGainLevel=GetMyProfileInt("RADIO","IFGainLevel",16);
	SaveIFGainLevel=GetMyProfileInt("RADIO","SaveIFGainLevel",16);
	IFOutLevel=GetMyProfileInt("RADIO","IFOutLevel",64);
	AFInLevel=GetMyProfileInt("AUDIO","AFInLevel",64);
	AFOutLevel=GetMyProfileInt("AUDIO","AFOutLevel",64);

	m_memfrq[0]=GetMyProfileInt("RADIO","memory1",153000);
	m_memfrq[1]=GetMyProfileInt("RADIO","memory2",177000);
	m_memfrq[2]=GetMyProfileInt("RADIO","memory3",7000000);
	m_memfrq[3]=GetMyProfileInt("RADIO","memory4",14000000);
	
	poti_vol.Init("Radio",200,2,NULL,SET_TOP);  
	strcpy(poti_vol.myInfo.ExtraText,"Volume");
	poti_sql.Init("SQL",160,1,RGB(38,168,38),SET_LEFT); //COL_GREEN); 	
	m_smeter.Init(GetMyProfileInt("RADIO","SmeterType",0));
	poti_out.Init("AF Out",256,2,NULL,MARK_L14); 
	poti_gain.Init("IF Gain",IF_GAIN_FACTOR,1,NULL,MARK_L14); 

	m_inpeek.Init(NULL,"IF Input Level"); 
	m_outpeek.Init(NULL,"AF Output Level"); 
	b_stereo.m_bRighImage=3; //set image and text center
	b_mixer.SetImage(IDB_MIXER);

	m_inpeek.Set(50);
	m_outpeek.Set(51);

	b_mode.SetMenu(IDR_MODE_MENU);
	b_filter.SetMenu(IDR_FILTER_MENU);
	b_IGC.SetMenu(IDR_IGC_MENU);

	//now load the switch states
	UpdateData(FALSE);
	SetFrq(m_frq,1);

	ImOpen=OpenIFInput(m_hWnd,m_IFinpuThread->m_nThreadID);
	OpenAFOutput(m_hWnd,NULL,NULL);



	//if myEEpromInfo.RegistryDate==0 or or myExtRxPara.IQ_noAccess==1 then....
	//without a original RadioJet Directory, we are missing the ExtIQ-Directory too, that make big problems
	OpenExtIQ(&myExtRxPara);
	m_IFctrl.SetExtIQ();

	SetSystemModal(m_TOPMOST);
	Adjust(m_MM);

	GetWindowRect(re);
	re.top=AfxGetApp()->GetProfileInt("RADIO","MainRectTop",re.top);
	re.left=AfxGetApp()->GetProfileInt("RADIO","MainRectLeft",re.left);
	SetCheckPlacement(m_hWnd,re,SWP_NOSIZE);
	myExtIOControl.SetState(); 

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRJ10MiniDlg::OnCancel() {CDialog::OnCancel();}
void CRJ10MiniDlg::OnOK() {}
void CRJ10MiniDlg::OnManual()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

LRESULT CRJ10MiniDlg::OnUpdateSmeterButton(WPARAM wParam, LPARAM lParam)
{
	AfxGetApp()->WriteProfileInt("RADIO","SmeterType",(int)(lParam&3));
	return NULL; 
}

LRESULT CRJ10MiniDlg::SetSMeter(WPARAM wParam, LPARAM lParam)
{
	m_smeter.SetSMeter(wParam, lParam);
	return NULL;
}

LRESULT CRJ10MiniDlg::SetSquelch(WPARAM wParam, LPARAM lParam)
{
	poti_sql.SetLed(wParam);
	return NULL;
}

LRESULT CRJ10MiniDlg::OnMixCtrlChange(WPARAM hMixer,LPARAM dwControlID)
{
	return MixerChange(hMixer,dwControlID);
}

LRESULT CRJ10MiniDlg::IFinLevelChange(WPARAM wParam, LPARAM lParam)
{
	IFGainLevel=wParam;
	IFGainOff=lParam;
	SetGain();
	return NULL;
}

LRESULT CRJ10MiniDlg::WaveOutVolumeChange(WPARAM wParam, LPARAM lParam)
{
	poti_out.Set(wParam);
	if(lParam==WM_SET_WAVEVOLUME) 
		{
		SetAFOutLevel(wParam);
		}
	return NULL;
}


LRESULT CRJ10MiniDlg::StartAction(WPARAM wParam, LPARAM lParam) 
{	
	StopFlag=1;
	SetFrq(m_frq-1,1);
	SetFrq(m_frq+1,1); //force set frq
	SetVolume(m_volume,1);
	SetInputChannel(m_CHN);
	SetGain(); 
	SetAFOutLevel(AFOutLevel);
	SetSpeaker(m_spkON);
	SetStereo(m_stereoON);

	ActivateIFInput(1);

	SetIGC(m_IGC); 
	SetRadioModeButtons(m_mode);
	SetRadioATT(m_ATT);
	SetFilterWidth(m_filterwidth);
	SetSquelch(m_sql);

	b_ATT.SetCheck(m_ATT);
	b_RX.SetCheck(m_CHN);
	b_DX.SetCheck(!m_CHN);

	m_IFctrl.ReadEEpromData();
	m_IFctrl.ViewInfo();
	Adjust(m_MM);

	//if myEEpromInfo.RegistryDate==0 or or myExtRxPara.IQ_noAccess==1 then...
	//without a original RadioJet Directory, we are missing the ExtIQ-Directory too, that make big problems
	if(!myExtRxPara.IQ_noAccess)
		{
		m_IFctrl.ViewPamorama(GetMyProfileInt("PANORAMA","onoff",0));
		m_IFctrl.myPanorama.SetExtIODialog(myExtRxPara.IQ_showGUI);
		}


	m_IFctrl.myPanorama.m_View.SetOff(0); //now start the view
	m_IFctrl.m_View.SetOff(0); //now start the view

	StopFlag=0;
	return NULL;
}


#include <dbt.h>
BOOL CRJ10MiniDlg::OnDeviceChange( UINT nEventType, DWORD dwData )
{
	int ret=CheckDeviceChangings(nEventType,dwData);
	return FALSE;
}

LRESULT CRJ10MiniDlg::DeviceAdd(WPARAM wParam, LPARAM lParam)
{
	LastDeviceCheck=CheckDeviceChangings(0,0);
	if(LastDeviceCheck==DEVICE_READY) return TRUE;

	if(LastDeviceCheck==DEVICE_NOW_READY)
		{
		int type=myExtRxPara.IQ_type;
		m_IFctrl.myPanorama.m_View.SetOff(1); //stop the view
		m_IFctrl.m_View.SetOff(1); //stop the view

		OpenReceiver(m_hWnd,myDIR,0);
		myExtRxPara.IQ_type=type;
		if(OpenIFInput(m_hWnd,m_IFinpuThread->m_nThreadID)) 
			{
			OpenAFOutput(m_hWnd,NULL,NULL);
			ImOpen=1;
			if(myExtRxPara.IQ_onoff) ExtDeviceAdd(0,0);
			else
				{
				StartAction(0,0);
				if(m_MM)
					{
					m_IFinpuThread->ResumeThread();
					RxAction=1;
					PostMessage(WM_START_ACTION,1,1); 
					}
				}
			}
		}
	return NULL;
}

LRESULT CRJ10MiniDlg::DeviceRemoved(WPARAM wParam, LPARAM lParam)
{
	ImOpen=0;
	LastDeviceCheck=CheckDeviceChangings(-1,-1);
	RxAction=0;
	m_IFinpuThread->SuspendThread();
	ActivateIFInput(0); 
	memset(&m_IFctrl.myEEpromInfo,0,sizeof(RJ10_EEROM_INFO));
	m_IFctrl.ViewInfo();
	m_IFctrl.m_View.ClearView();
	myPanoramaView.ClearView();
	Adjust(m_MM);
	return NULL;
}

LRESULT CRJ10MiniDlg::DeviceIOChanged(WPARAM wParam, LPARAM lParam)
{
	return CheckDeviceChangings(WM_HID_JET_GPI,wParam);
}

LRESULT CRJ10MiniDlg::ExtDeviceAdd(WPARAM wParam, LPARAM lParam)
{//	CheckDeviceChangings->>> PostMessage(MAIN_hWnd,WM_HID_EXT_ADD,ret,&myExtRxPara);


	m_IFctrl.myPanorama.m_View.SetOff(1); //stop the view
	m_IFctrl.m_View.SetOff(1); //stop the view

	//if myEEpromInfo.RegistryDate not set then....
	//without a original RadioJet Directory, we are missing the ExtIQ-Directory too, that make big problems
	
	OpenExtIQ(&myExtRxPara);

	StartAction(wParam,lParam);
	if(m_MM)
		{
		m_IFinpuThread->ResumeThread();
		RxAction=1;
		PostMessage(WM_START_ACTION,1,1); 
		}

	myExtIOControl.SetDeviceList();
	myExtIOControl.SetState(); 
	myPanoramaCtrl.SetExtIODialog(myExtRxPara.IQ_showGUI);
	return NULL;
}

LRESULT CRJ10MiniDlg::ExtDeviceRemoved(WPARAM wParam, LPARAM lParam)
{// CheckDeviceChangings->>> PostMessage(MAIN_hWnd,WM_HID_EXT_REMOVE,ret,&myExtRxPara);
	EXT_IQRX *ext=(EXT_IQRX*)lParam;
	myExtRxPara.IQ_open=0;
	myPanoramaView.ClearView();
	myExtIOControl.SetDeviceList();
	myExtIOControl.SetState(); 
	myPanoramaCtrl.SetExtIODialog(myExtRxPara.IQ_showGUI);
	return NULL;
}

void CRJ10MiniDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == SC_MAXIMIZE)
		{
		OnSetMinOrMax();
		return;
		}

	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
		{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
		}

	else if ((nID & 0xFFF0) == IDM_MIN_MAX) 
		{
		Adjust(++m_MM);
		}
	else CDialog::OnSysCommand(nID, lParam);

}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRJ10MiniDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
	
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRJ10MiniDlg::OnQueryDragIcon()
{
return (HCURSOR) m_hIcon;
}

BOOL CRJ10MiniDlg::OnToolTipText(UINT id, NMHDR *pNMH, LRESULT *pResult)
{
	/*TOOLTIPTEXT *pText=(TOOLTIPTEXT*)pNMH;

	USHORT ObjectID =  ::GetDlgCtrlID((HWND)pText->hdr.idFrom);

	switch(ObjectID)
		{
		case IDC_FRQ_MEM1:
		case IDC_FRQ_MEM2:
		case IDC_FRQ_MEM3:
		case IDC_FRQ_MEM4: 

#ifdef _C8COMPILER
							CToolTipCtrl* ptt = AfxGetModuleThreadState()->m_pToolTip;
#else
							CToolTipCtrl* ptt = AfxGetThreadState()->m_pToolTip;
#endif
							pText->lpszText="Copy Frequency in MEMORY ?, --> click with the right mouse button";
							return TRUE;
		}*/

	return FALSE;
}

void CRJ10MiniDlg::OnSetSystemModal() 
{
	if(m_TOPMOST) SetSystemModal(0);
	else SetSystemModal(1);
	Adjust(m_MM);
}

void CRJ10MiniDlg::SetSystemModal(int modalmode) 
{
	m_TOPMOST=modalmode;
	DWORD style=GetStyle();

	if(m_TOPMOST)
		{
		if(!(style&DS_SYSMODAL))
			{
			ModifyStyle(NULL,DS_SYSMODAL,SWP_NOACTIVATE); 
			ModifyStyleEx(0,WS_EX_TOPMOST,SWP_NOACTIVATE);
			}
		m_symod.SetCheck(1);
		}
	else
		{
		if(style&DS_SYSMODAL)
			{
			ModifyStyle(DS_SYSMODAL, NULL); 
			ModifyStyleEx(WS_EX_TOPMOST,0);
			}
		m_symod.SetCheck(0);
		}
	style=GetStyle();
}

void CRJ10MiniDlg::Adjust(int mm, int set)
{
	int xpOffset=0;
	if(mm==2) m_MM=2;
	else if(mm==1) m_MM=1;
	else m_MM=0;

	CRect re,ra,rx;
	GetWindowRect(re);
	m_gb1.GetWindowRect(ra);
	ScreenToClient(ra);
	m_IFctrl.b_EXP.GetWindowRect(rx);
	ScreenToClient(rx);

	if(WinVersion>5) xpOffset=-4; //the XP-Layout is different


	const CWnd *pWndInsertAfter=&wndNoTopMost;
	if(m_TOPMOST) pWndInsertAfter=&wndTopMost; 

	if(!m_MM) 
		{
		m_smeter.ShowWindow(SW_HIDE);
		SetVariButtonLine(minRect,b_sw,3);
		}
	else
		{
		SetVariButtonLine(maxRect,b_sw,3); 
		m_smeter.ShowWindow(SW_SHOW);
		}



//	hier muss eine -Offset rein fr XP

	switch(m_MM)
		{
		case	0:	re.bottom=re.top+ra.bottom+37+xpOffset;
					re.right=re.left+ra.right+11;
					b_MinMax.SetImage(IDB_MAXWIN);
					m_gb2.ShowWindow(SW_HIDE);
					m_IFctrl.ShowWindow(SW_HIDE);
					SetWindowText(mTitle1);
					SetWindowPos(pWndInsertAfter,re.left,re.top,re.Width(),re.Height(),MOVEALL);
					if(m_IFctrl.myPanorama.IsWindowVisible()) m_IFctrl.ViewPamorama(0);
					break;
		case	1:
					re.bottom=re.top+574+xpOffset;
					re.right=re.left+1024;
					b_MinMax.SetImage(IDB_MINWIN);
					m_gb2.ShowWindow(SW_SHOW);
					if(DiRaWaveFlag) SetWindowText(mTitle3);
					else SetWindowText(mTitle2);

				
					ra.left=5; ra.right=1016; 
					ra.top=ra.bottom; 
					ra.bottom=re.bottom;
					m_IFctrl.b_EXP.SetCheck(0);
					m_IFctrl.b_EXP.SetImage(IDB_EXPAND,1);
					m_IFctrl.Adjust(ra,m_MM);
					SetWindowPos(pWndInsertAfter,re.left,re.top,re.Width(),re.Height(),MOVEALL);
					m_IFctrl.gb2.ShowWindow(SW_HIDE);
					m_IFctrl.gb3.ShowWindow(SW_HIDE);
					m_IFctrl.gb4.ShowWindow(SW_HIDE);
					m_IFctrl.gb5.ShowWindow(SW_HIDE);
					m_IFctrl.gb12.ShowWindow(SW_HIDE);
					break;

		case	2:
					re.bottom=re.top+750-NetBookFormat;
					re.right=re.left+1024;
					if(WinVersion<6) 
						{
						//XP too small frames
						re.bottom+=4;
						}

					b_MinMax.SetImage(IDB_MINWIN);
					if(DiRaWaveFlag) SetWindowText(mTitle3);
					else SetWindowText(mTitle2);
					ra.left=5; ra.right=1016; 
					ra.top=ra.bottom; 
					ra.bottom=re.bottom;
					m_IFctrl.b_EXP.SetCheck(1);
					m_IFctrl.b_EXP.SetImage(IDB_EXPAND1,1);
					m_IFctrl.Adjust(ra,m_MM);
					SetWindowPos(pWndInsertAfter,re.left,re.top,re.Width(),re.Height(),MOVEALL);
					m_IFctrl.gb2.ShowWindow(SW_SHOW);
					m_IFctrl.gb3.ShowWindow(SW_SHOW);
					m_IFctrl.gb4.ShowWindow(SW_SHOW);
					m_IFctrl.gb5.ShowWindow(SW_SHOW);
					m_IFctrl.gb12.ShowWindow(SW_SHOW);
					break;

		}
	
	if(set)
		{
		if(m_MM && !RxAction)
			{//switch RX on
			m_IFinpuThread->ResumeThread();
			RxAction=1;
			PostMessage(WM_START_ACTION,1,1); 
			}
		else if(!m_MM && RxAction)
			{//switch RX off
			RxAction=0;
			m_IFinpuThread->SuspendThread();
			ActivateIFInput(0); 
			}
		}
	RedrawWindow();
}

LRESULT CRJ10MiniDlg::OnPotiChange(WPARAM wParam, LPARAM lParam)
{
	if((HWND)wParam==poti_sql.m_hWnd)
		{
		SetSquelch((int)lParam); 
		}
	else if((HWND)wParam==poti_vol.m_hWnd)
		{
		SetVolume((int)lParam,poti_vol.lastDoubleClick);
		}
	else if((HWND)wParam==poti_out.m_hWnd)
		{
		SetAFOutLevel((int)lParam);	
		}
	else if((HWND)wParam==poti_gain.m_hWnd)
		{
		if(!IFGainOff) SetIFGain((int)lParam,1);
		}

	return NULL;
}

void CRJ10MiniDlg::SetRepeatation(int repeat)
{
	myIFStyle.m_repeatation=repeat;
	if(repeat<4) repeat=4;
	DrawDelayFac=1.f/(float)repeat;
	DrawImmediately=1;
}

LRESULT CRJ10MiniDlg::OnIFInput(WPARAM wParam, LPARAM lParam)
{
	//we use only every second view - the sequence is 48000/2048=23.4375 = ~24 
	if(!StopFlag) 
		{
		if(m_mode==REC_DRM)
			{
			drm_update++; 
			if(drm_update>=20)
				{
				drm_update=0;
				RefreshDRMState();
				}
			}

		DrawDelaySum+=DrawInputFac;
		if(DrawDelaySum>=DrawDelayFac || DrawImmediately)
			{
			if(!DrawImmediately) DrawDelaySum-=DrawDelayFac;
			DrawImmediately=0;
			int chn=wParam&3;  //wParam = (imax<<2|chn);
			int imax=wParam>>2; 
			if(chn&1) 
				{
				m_IFctrl.m_View.GetDrawData();	// 48000/2048 ~23 x per sec.
				m_inpeek.SetPeakMeter(imax);	// set input level
				}
			if(chn&2) 
				{
				m_IFctrl.myPanorama.m_View.GetDrawData(lParam); 
				}
			}
		}
	return NULL;
}

LRESULT CRJ10MiniDlg::OnScopeOut(WPARAM wParam,LPARAM lParam)
{
	m_outpeek.SetPeakMeter(wParam);
	return NULL;
}

void CRJ10MiniDlg::SetAFOutLevel(int out) 
{
	AFOutLevel=out;
	SetWaveOutMainLevel(out);	
	poti_out.Set(out);
}

void CRJ10MiniDlg::SetGain() 
{
	if(SaveIFGainLevel<0 || SaveIFGainLevel>IF_GAIN_FACTOR) SaveIFGainLevel=16;
	if(IFGainLevel<0 || IFGainLevel>IF_GAIN_FACTOR)IFGainLevel=16;

	if(IFGainOff && IFGainLevel!=16) 
		{
		SaveIFGainLevel=IFGainLevel;
		IFGainLevel=16;
		SetIFInputLevel(IFGainLevel,IFGainOff);
		}

	poti_gain.EnableWindow(!IFGainOff);
	poti_gain.RedrawWindow();
	b_gainset.SetCheck(!IFGainOff);
	SetIFGain(IFGainLevel);
}

void CRJ10MiniDlg::OnSetGain() 
{
	if(IFGainOff) IFGainOff=0;
	else IFGainOff=1;
	if(!IFGainOff)
		{
		IFGainLevel=SaveIFGainLevel;
		}	
	else 
		{
		SaveIFGainLevel=IFGainLevel;
		}
	SetIFInputLevel(IFGainLevel,IFGainOff);

	SetGain();
}

void CRJ10MiniDlg::SetIFGain(int pos, int set)
{
	if(set) SetIFInputLevel(pos,IFGainOff);
	IFGainLevel=pos;
	int x=-16+IFGainLevel;

	if(x<1) sprintf(poti_gain.myInfo.ExtraText,"%d dB",x);
	else sprintf(poti_gain.myInfo.ExtraText,"+%d dB",x);
	poti_gain.Set(pos);
}


void CRJ10MiniDlg::SetVolume(int vol,int reset) 
{
	m_volume=vol;
	poti_vol.Set(vol);
	SetRadioVolume(vol,reset);
}

void CRJ10MiniDlg::SetSquelch(int sql) 
{
	m_sql=sql;
	m_smeter.SetSquelchLevel(sql);

	//dB Value for level viewing

	if(m_sql>15) sprintf(poti_sql.myInfo.ExtraText,"%d dBm",-160+sql);
	else strcpy(poti_sql.myInfo.ExtraText,"is OFF");
	
	poti_sql.Set(sql);
	poti_sql.SetLed(SetRadioSquelch(sql)^1);
}

void CRJ10MiniDlg::OnSetMinOrMax() 
{
	if(m_MM) Adjust(0);
	else Adjust(1);
}

void CRJ10MiniDlg::OnSetMode()
{
	switch(b_mode.m_nMenuResult)
		{
		case IDC_MODE_LSB:	m_mode=REC_LSB; break;
		case IDC_MODE_USB:	m_mode=REC_USB; break;
		case IDC_MODE_CW:	m_mode=REC_CW;	break;
		default:
		case IDC_MODE_AM:	m_mode=REC_AM;	break;
		case IDC_MODE_FM:	m_mode=REC_FM;	break;
		case IDC_MODE_DRM:	m_mode=REC_DRM;	break;
		}
	SetRadioModeButtons(m_mode);
}

void CRJ10MiniDlg::SetRadioModeButtons(int mode) 
{
	int		nIDItem=0;
	char	txt[256];
	CString str;
	CMenu	menu,*submenu;

	m_mode=mode;
	switch(mode)
		{
		case REC_LSB:	nIDItem=0; break;
		case REC_USB:	nIDItem=1; break;
		case REC_CW:	nIDItem=2; break;
		default:		m_mode=REC_AM;
		case REC_AM:	nIDItem=3;	break;
		case REC_FM:	nIDItem=4;	break;
		case REC_DRM:	nIDItem=5;	break;
		}

	menu.LoadMenu(IDR_MODE_MENU);
	submenu = menu.GetSubMenu(0);
	submenu->GetMenuString(nIDItem,str,MF_BYPOSITION);
	sprintf(txt,"Radio Mode: %s",str);
	b_mode.CheckMenuItem(nIDItem,txt);
	SetRadioMode(m_mode); 

	switch(m_mode)
		{
		case REC_LSB:	myIFStyle.m_fftrangehi=myIFStyle.m_centermark; 
						myIFStyle.m_fftrangelo=myIFStyle.m_centermark-m_filterwidth;
						break;
		case REC_USB:	myIFStyle.m_fftrangehi=myIFStyle.m_centermark+m_filterwidth;
						myIFStyle.m_fftrangelo=myIFStyle.m_centermark;
						break;
		default:		
						myIFStyle.m_fftrangelo=myIFStyle.m_centermark-(m_filterwidth>>1); 
						myIFStyle.m_fftrangehi=myIFStyle.m_centermark+(m_filterwidth>>1); 
						break;
		}
	m_IFctrl.SetFilterParameter();

	myRxSignalState.MSCState=myRxSignalState.SDCState=myRxSignalState.FACState=myRxSignalState.IOState=(char)DRM_MSC_NOT_PRESENT;	
	//if(m_mode==REC_DRM) myRxSignalState.IOState=(char)DRM_IO_STATE_RX_OK;
	myIFControl.m_View.myStatus[0]=0;
	ledMCS.SetState(myRxSignalState.MSCState);
	ledFAC.SetState(myRxSignalState.FACState);
	ledSDC.SetState(myRxSignalState.SDCState);
	ledIO.SetState(myRxSignalState.IOState);
}

void CRJ10MiniDlg::SetFilterWidth(int width) 
{
	int		nIDItem=0;
	char	txt[256];
	CString str;
	CMenu	menu,*submenu;

	menu.LoadMenu(IDR_FILTER_MENU);
	submenu = menu.GetSubMenu(0);

	switch(width)
		{
		case 500:		nIDItem=0; break;
		case 1000:		nIDItem=1; break;
		case 2000:		nIDItem=2; break;
		case 2500:		nIDItem=3; break;
		case 3000:		nIDItem=4; break;
		case 6000:		nIDItem=5; break;
		default:		width=9000;
		case 9000:		nIDItem=6; break;
		case 10000:		nIDItem=7; break;
		case 12000:		nIDItem=8; break;
		}

	m_filterwidth=width;

	submenu->GetMenuString(nIDItem,str,MF_BYPOSITION);
	sprintf(txt,"IF-Filter: %s",str);
	b_filter.CheckMenuItem(nIDItem,txt);
	SetRadioIF(width);

	switch(m_mode)
		{
		case REC_LSB:	myIFStyle.m_fftrangehi=myIFStyle.m_centermark; 
						myIFStyle.m_fftrangelo=myIFStyle.m_centermark-m_filterwidth;
						break;
		case REC_USB:	myIFStyle.m_fftrangehi=myIFStyle.m_centermark+m_filterwidth;
						myIFStyle.m_fftrangelo=myIFStyle.m_centermark;
						break;
		default:		
						myIFStyle.m_fftrangelo=myIFStyle.m_centermark-(m_filterwidth>>1); 
						myIFStyle.m_fftrangehi=myIFStyle.m_centermark+(m_filterwidth>>1); 
						break;
		}
	m_IFctrl.SetFilterParameter();
}

void CRJ10MiniDlg::OnSetFilter() 
{
	int width;
	switch(b_filter.m_nMenuResult)
		{
		case IDC_FILTER_0:	width=500; break;
		case IDC_FILTER_1:	width=1000; break;
		case IDC_FILTER_2:	width=2000; break;
		case IDC_FILTER_3:	width=2500; break;
		case IDC_FILTER_4:	width=3000; break;
		case IDC_FILTER_5:	width=6000; break;
		default:
		case IDC_FILTER_6:	width=9000; break;
		case IDC_FILTER_7:	width=10000; break;
		case IDC_FILTER_8:	width=12000; break;
		}
	SetFilterWidth(width);
}

void CRJ10MiniDlg::OnSetIGC() 
{
	switch(b_IGC.m_nMenuResult)
		{
		case IDC_IGC_OFF:		m_IGC=0; break;
		case IDC_IGC_FAST:		m_IGC=1; break;
		case IDC_IGC_MEDIUM:	m_IGC=8; break;
		default:
		case IDC_IGC_SLOW:		m_IGC=15; break;
		}
	SetIGC(m_IGC);
}

void CRJ10MiniDlg::SetIGC(int igc) 
{
	int		nIDItem=0;
	char	txt[256];
	CString str;
	CMenu	menu,*submenu;

	menu.LoadMenu(IDR_IGC_MENU);
	submenu = menu.GetSubMenu(0);

	m_IGC=igc;
	switch(m_IGC)
		{
		case 0:			nIDItem=0; break;
		case 1:			nIDItem=1; break;
		case 8:			nIDItem=2; break;
		default:		m_IGC=15;
		case 15:		nIDItem=3; break;
		}

	submenu->GetMenuString(nIDItem,str,MF_BYPOSITION);
	sprintf(txt,"IGC state: %s",str);
	b_IGC.CheckMenuItem(nIDItem,txt);
	SetRadioIGC(m_IGC);
}

void CRJ10MiniDlg::SetATT(int att) 
{
	m_ATT=att;
	SetRadioATT(m_ATT);
	b_ATT.SetCheck(m_ATT);
}

void CRJ10MiniDlg::SetCHN(int chn) 
{
	m_CHN=chn;
	b_RX.SetCheck(m_CHN);
	b_DX.SetCheck(!m_CHN);
	SetInputChannel(m_CHN);
}

void CRJ10MiniDlg::OnAtt() 
{
	if(m_ATT) SetATT(0);
	else SetATT(1);
}

void CRJ10MiniDlg::OnChnDx() 
{
	SetCHN(0);
}

void CRJ10MiniDlg::OnChnRx() 
{
	SetCHN(1);
}

void CRJ10MiniDlg::OnSetFrqMemory(UINT id)
{
	switch(id)
		{
		case IDC_FRQ_MEM1:			SetFrq(m_memfrq[0]); break;
		case IDC_FRQ_MEM2:			SetFrq(m_memfrq[1]); break;
		case IDC_FRQ_MEM3:			SetFrq(m_memfrq[2]); break;
		case IDC_FRQ_MEM4:			SetFrq(m_memfrq[3]); break;
		}
}

LRESULT CRJ10MiniDlg::OnRightButton(WPARAM wParam, LPARAM lParam)
{
	switch(wParam)
		{
		case IDC_FRQ_MEM1:		m_memfrq[0]=m_frq; break;
		case IDC_FRQ_MEM2:		m_memfrq[1]=m_frq;	break;
		case IDC_FRQ_MEM3:		m_memfrq[2]=m_frq;	break;
		case IDC_FRQ_MEM4:		m_memfrq[3]=m_frq;	break;
		}
	return NULL;
}

void CRJ10MiniDlg::OnSetFrqDirect(UINT id)
{
	UINT nChar=0;
	
	switch(id)
		{
		case IDC_FRQ_FIG_0:		nChar=0x30; break;
		case IDC_FRQ_FIG_1:		nChar=0x31; break;
		case IDC_FRQ_FIG_2:		nChar=0x32; break;
		case IDC_FRQ_FIG_3:		nChar=0x33; break;
		case IDC_FRQ_FIG_4:		nChar=0x34; break;
		case IDC_FRQ_FIG_5:		nChar=0x35; break;
		case IDC_FRQ_FIG_6:		nChar=0x36; break;
		case IDC_FRQ_FIG_7:		nChar=0x37; break;
		case IDC_FRQ_FIG_8:		nChar=0x38; break;
		case IDC_FRQ_FIG_9:		nChar=0x39; break;
		case IDC_FRQ_FIG_CLR:	nChar=0x8; break;
		case IDC_FRQ_FIG_POINT:	nChar=0x2E; break;
		case IDC_FRQ_FIG_SET:	SetEditFrq(); return;
		}
	e_frqedit.SendMessage(WM_CHAR,nChar,0);
}

void CRJ10MiniDlg::SetEditFrq() 
{
	UpdateData(TRUE);

	double dfrg=atof(m_frqedit);
	int frq=(int)dfrg;

	if(frq<=32)
		{
		frq=(int)(dfrg*1000000.);
		}
	else frq=(int)(dfrg*1000.);

//	if(frq=CheckFrqLimits(frq))
		{
		SetFrq(frq); 
		m_frqedit.Empty();
		UpdateData(FALSE);
		}
	
}

LRESULT CRJ10MiniDlg::OnFrqEditCR(WPARAM wParam, LPARAM lParam)
{
	if((HWND)wParam==e_frqedit.m_hWnd) SetEditFrq();
	return NULL;
}

int CRJ10MiniDlg::SetFrq(int frq, int force) 
{
	if(m_frq!=frq || force) 
		{	
		frq=SetRadioFrq(frq);
		if(frq)
			{
			DrawImmediately=1;
			m_frq=frq;
			myIFStyle.m_radiofrq=myPanoramaStyle.m_radiofrq=m_frq;
			m_FrqButton.Set(m_frq);	
			myPanoramaView.PostMessage(WM_DRAW_FRQ,m_frq,m_frq);
			}
		//the DLL post back a messages PostMessage(WM_DRAW_FRQ,0,0) (see DrawFrqAction)
		//but, only if the frq command buffer is empty 
		}
	return m_frq;
}

LRESULT CRJ10MiniDlg::DrawFrqAction(WPARAM wParam, LPARAM lParam)
{
	if(m_IFctrl.m_hWnd)	
		{
		m_IFctrl.SetFilterParameter();
		}
	
	return NULL;
}

LRESULT CRJ10MiniDlg::OnExtIQSHOWChange(WPARAM wParam, LPARAM lParam)
{
	return myExtIOControl.OnExtIQSHOWChange(wParam,lParam);
}

LRESULT CRJ10MiniDlg::OnExtIQSCALChange(WPARAM wParam, LPARAM lParam)
{
	myExtIOControl.SetXtalFrqScaling((short)wParam,0);
	return NULL;
}

LRESULT CRJ10MiniDlg::OnExtIQIFGNChange(WPARAM wParam, LPARAM lParam)
{
	myExtIOControl.OnExtIQIFGNChange(wParam,lParam);
	return NULL;
}
LRESULT CRJ10MiniDlg::OnExtIQHFGNChange(WPARAM wParam, LPARAM lParam)
{
	myExtIOControl.OnExtIQHFGNChange(wParam,lParam);
	return NULL;
}

LRESULT CRJ10MiniDlg::OnExtIQRTLChange(WPARAM wParam, LPARAM lParam)
{
	myExtIOControl.OnExtIQRTLChange(wParam,lParam);
	return NULL;
}

LRESULT CRJ10MiniDlg::OnExtIQOFFSChange(WPARAM wParam, LPARAM lParam)
{
	myExtIOControl.SetDBOfset((short)wParam,0);
	return NULL;
}

LRESULT CRJ10MiniDlg::OnExtIQCORRChange(WPARAM wParam, LPARAM lParam)
{
	myExtIOControl.SetXtalFrqCorr((short)wParam,0);
	return NULL;
}

LRESULT CRJ10MiniDlg::OnExtIQATTChange(WPARAM wParam, LPARAM lParam)
{
	return myExtIOControl.OnExtIQATTChange(wParam,lParam);
}

LRESULT CRJ10MiniDlg::OnExtIQPREChange(WPARAM wParam, LPARAM lParam)
{
	return myExtIOControl.OnExtIQPREChange(wParam,lParam);
}

LRESULT CRJ10MiniDlg::OnExtIQSampleChange(WPARAM wParam, LPARAM lParam)
{
	return myExtIOControl.OnExtIQSampleChange(wParam,lParam);
}

void CRJ10MiniDlg::MouseWheel(UINT nFlags, short zDelta,int step) 
{
	if(zDelta<0) step=m_frq-step; 
	else step=m_frq+step;
	step-=step%m_steps; 	
	if(step<40000000 && step>10) SetFrq(step);
}

BOOL CRJ10MiniDlg::DestroyWindow() 
{
	StopFlag=1;
	CRect myRect;
	if(	m_IFctrl.GetSafeHwnd())
		{
		AfxGetApp()->WriteProfileInt("PANORAMA","onoff",m_IFctrl.myPanorama.IsWindowVisible());
		m_IFctrl.myPanorama.GetWindowRect(myRect);
		AfxGetApp()->WriteProfileInt("PANORAMA","RectTop",myRect.top);
		AfxGetApp()->WriteProfileInt("PANORAMA","RectLeft",myRect.left);
		AfxGetApp()->WriteProfileInt("PANORAMA","RectBot",myRect.bottom);
		AfxGetApp()->WriteProfileInt("PANORAMA","RectRight",myRect.right);
		m_IFctrl.myPanorama.ShowWindow(SW_HIDE);	

		AfxGetApp()->WriteProfileInt("RADIO","ATT",m_ATT);
		AfxGetApp()->WriteProfileInt("RADIO","MinMaxView",m_MM);
		AfxGetApp()->WriteProfileInt("RADIO","RXDXChannel",m_CHN);
		AfxGetApp()->WriteProfileInt("RADIO","SystemModal",m_TOPMOST);

		AfxGetApp()->WriteProfileInt("RADIO","IGC",m_IGC);
		AfxGetApp()->WriteProfileInt("RADIO","mode",m_mode);
		AfxGetApp()->WriteProfileInt("RADIO","filterwidth",m_filterwidth);
		AfxGetApp()->WriteProfileInt("RADIO","LastFrq",m_frq);
		AfxGetApp()->WriteProfileInt("RADIO","squelch",m_sql);
		AfxGetApp()->WriteProfileInt("RADIO","volume",m_volume);
		AfxGetApp()->WriteProfileInt("RADIO","SpeakerON",m_spkON);
		AfxGetApp()->WriteProfileInt("RADIO","StereoON",m_stereoON);
		AfxGetApp()->WriteProfileInt("RADIO","memory1",m_memfrq[0]);
		AfxGetApp()->WriteProfileInt("RADIO","memory2",m_memfrq[1]);
		AfxGetApp()->WriteProfileInt("RADIO","memory3",m_memfrq[2]);
		AfxGetApp()->WriteProfileInt("RADIO","memory4",m_memfrq[3]);
		AfxGetApp()->WriteProfileInt("RADIO","IFGainOff",IFGainOff);
		AfxGetApp()->WriteProfileInt("RADIO","IFGainLevel",IFGainLevel);
		AfxGetApp()->WriteProfileInt("RADIO","SaveIFGainLevel",SaveIFGainLevel);
		AfxGetApp()->WriteProfileInt("RADIO","IFOutLevel",IFOutLevel);
		AfxGetApp()->WriteProfileInt("RADIO","CalibFrq1",m_IFctrl.CalibFrq1);
		AfxGetApp()->WriteProfileInt("RADIO","CalibFrq2",m_IFctrl.CalibFrq2);

		AfxGetApp()->WriteProfileInt("AUDIO","AFInLevel",AFInLevel);
		AfxGetApp()->WriteProfileInt("AUDIO","AFOutLevel",AFOutLevel);

		AfxGetApp()->WriteProfileInt("SCOPE","Delay",myIFStyle.m_smoothing);
		AfxGetApp()->WriteProfileInt("SCOPE","Ampl",myIFStyle.m_ampl);
		AfxGetApp()->WriteProfileInt("SCOPE","Width",myIFPara.width);
		AfxGetApp()->WriteProfileInt("SCOPE","Position",myIFPara.pos);
		AfxGetApp()->WriteProfileInt("SCOPE","Style",myIFStyle.m_style);
		AfxGetApp()->WriteProfileInt("SCOPE","TopAmpl",myIFStyle.topAmpl);
		AfxGetApp()->WriteProfileInt("SCOPE","TopLevel",myIFStyle.topLevel);
		AfxGetApp()->WriteProfileInt("SCOPE","TopStyle",myIFStyle.topStyle);
		AfxGetApp()->WriteProfileInt("SCOPE","TopOFF",myIFStyle.topOFF);
		AfxGetApp()->WriteProfileInt("SCOPE","TopYPos",myIFStyle.topYPos);
		AfxGetApp()->WriteProfileInt("SCOPE","repeat",myIFStyle.m_repeatation);
		AfxGetApp()->WriteProfileInt("SCOPE","AmplCut",myIFStyle.m_amplCut);
		AfxGetApp()->WriteProfileInt("SCOPE","DecLevel",myIFStyle.m_DecLevel);
		AfxGetApp()->WriteProfileInt("SCOPE","DecScale",myIFStyle.m_DecScale);

		AfxGetApp()->WriteProfileInt("COLORS","selectedDesign",selectedDesign);
		AfxGetApp()->WriteProfileInt("COLORS","KnobFace1",m_COL_KNOBFACE[0]);
		AfxGetApp()->WriteProfileInt("COLORS","KnobFace2",m_COL_KNOBFACE[1]);
		AfxGetApp()->WriteProfileInt("COLORS","KnobFace3",m_COL_KNOBFACE[2]);
		AfxGetApp()->WriteProfileInt("COLORS","ScopeBackL1",m_COL_SCOPE_B[0]);
		AfxGetApp()->WriteProfileInt("COLORS","ScopeBackL2",m_COL_SCOPE_B[1]);
		AfxGetApp()->WriteProfileInt("COLORS","ScopeBackL3",m_COL_SCOPE_B[2]);
		AfxGetApp()->WriteProfileInt("COLORS","ScopeBackH3",m_COL_SCOPE_B2[0]);
		AfxGetApp()->WriteProfileInt("COLORS","ScopeBackH4",m_COL_SCOPE_B2[1]);
		AfxGetApp()->WriteProfileInt("COLORS","ScopeBackH5",m_COL_SCOPE_B2[2]);

		
		AfxGetApp()->WriteProfileInt("PANORAMA","Delay",myPanoramaStyle.m_smoothing);
		AfxGetApp()->WriteProfileInt("PANORAMA","Ampl",myPanoramaStyle.m_ampl);
		AfxGetApp()->WriteProfileInt("PANORAMA","Width",myIQPara.width);
		AfxGetApp()->WriteProfileInt("PANORAMA","Position",myIQPara.pos);
		AfxGetApp()->WriteProfileInt("PANORAMA","Style",myPanoramaStyle.m_style);

		AfxGetApp()->WriteProfileInt("PANORAMA","TopAmpl",myPanoramaStyle.topAmpl);
		AfxGetApp()->WriteProfileInt("PANORAMA","TopLevel",myPanoramaStyle.topLevel);
		AfxGetApp()->WriteProfileInt("PANORAMA","TopStyle",myPanoramaStyle.topStyle);
		AfxGetApp()->WriteProfileInt("PANORAMA","TopOFF",myPanoramaStyle.topOFF);
		AfxGetApp()->WriteProfileInt("PANORAMA","TopYPos",myPanoramaStyle.topYPos);

		AfxGetApp()->WriteProfileInt("PANORAMA","DecLevel",myPanoramaStyle.m_DecLevel);
		AfxGetApp()->WriteProfileInt("PANORAMA","DecScale",myPanoramaStyle.m_DecScale);
	
		myExtIOControl.GetWindowRect(myRect);
		AfxGetApp()->WriteProfileInt("EXTIO_CTRL","WindowTop",myRect.top);
		AfxGetApp()->WriteProfileInt("EXTIO_CTRL","WindowLeft",myRect.left);
		AfxGetApp()->WriteProfileInt("EXTIO_CTRL","show",myExtIOControl.IsWindowVisible());

		GetWindowRect(myRect);
		AfxGetApp()->WriteProfileInt("RADIO","MainRectTop",myRect.top);
		AfxGetApp()->WriteProfileInt("RADIO","MainRectLeft",myRect.left);
		}

	Suspend_RJ10MDLL();  //RJ10 Thread OFF
	myInDeviceList.RemoveAll();
	return CDialog::DestroyWindow();
}

void CRJ10MiniDlg::OnAudioMixer() 
{
	if(WinVersion>5) 	 ShellExecute(NULL, NULL,"SNDVOL.EXE",NULL,NULL, SW_SHOWNORMAL); //Windows 7
	else ShellExecute(NULL, NULL,"SNDVOL32.EXE",NULL,NULL, SW_SHOWNORMAL); //windows XP 
}

void CRJ10MiniDlg::SetSpeaker(int onoff) 
{
	m_spkON=onoff;
	if(m_spkON) SetSpeakerOnOff(-2); //on is = -2  
	else SetSpeakerOnOff(-1); // off is = -1
	if(m_spkON) b_speaker.SetImage(IDB_SPEAKER1);
	else b_speaker.SetImage(IDB_SPEAKER);
	b_speaker.SetCheck(m_spkON);
}

void CRJ10MiniDlg::OnSetSpeaker() 
{
	if(m_spkON) SetSpeaker(0);
	else SetSpeaker(1);
}

void CRJ10MiniDlg::SetStereo(int onoff) 
{
	m_stereoON=onoff;
	SetStereoOnOff(m_stereoON);
	b_stereo.SetCheck(m_stereoON);
	if(m_stereoON) b_stereo.SetImage(IDB_STEREO1);
	else b_stereo.SetImage(IDB_STEREO);
}

void CRJ10MiniDlg::OnSetStereo() 
{
	if(m_stereoON) SetStereo(0);
	else SetStereo(1);
}

void CRJ10MiniDlg::RefreshDRMState()
{
	RX_SIGNAL_STATE m_status={0};

	if(m_mode!=REC_DRM) 
		{
		if(!myIFControl.m_View.myStatus[0]
		|| myRxSignalState.MSCState!=DRM_MSC_NOT_PRESENT
		|| myRxSignalState.SDCState!=DRM_MSC_NOT_PRESENT
		|| myRxSignalState.FACState!=DRM_MSC_NOT_PRESENT
		|| myRxSignalState.IOState!=DRM_MSC_NOT_PRESENT)
			{
			myRxSignalState.MSCState=myRxSignalState.SDCState=myRxSignalState.FACState=myRxSignalState.IOState=(char)DRM_MSC_NOT_PRESENT;	
			myIFControl.m_View.myStatus[0]=0;
			ledMCS.SetState(myRxSignalState.MSCState);
			ledFAC.SetState(myRxSignalState.FACState);
			ledSDC.SetState(myRxSignalState.SDCState);
			ledIO.SetState(myRxSignalState.IOState);
			}
		}
	else
		{
		RX_SIGNAL_STATE m_status={0};
		CopyRxStatus(&m_status,1);
		if(memcmp(&myRxSignalState,&m_status,sizeof(RX_SIGNAL_STATE)))
			{
			if(m_status.ServiceLabel[0]) 
				{
				if(m_status.activeService)
					{
					if(m_status.ProgrammTypeIdx==2 || m_status.ProgrammTypeIdx==3) sprintf(myIFControl.m_View.myStatus,"ID:%06X - %s - (Stereo)",m_status.iServiceID,m_status.ServiceLabel);
					else sprintf(myIFControl.m_View.myStatus,"ID:%06X - %s - (Mono)",m_status.iServiceID,m_status.ServiceLabel);
					}
				else strcpy(myIFControl.m_View.myStatus,m_status.ServiceLabel);
				}
			else myIFControl.m_View.myStatus[0]=0;
			memcpy(&myRxSignalState,&m_status,sizeof(RX_SIGNAL_STATE));
			ledMCS.SetState(myRxSignalState.MSCState);
			ledFAC.SetState(myRxSignalState.FACState);
			ledSDC.SetState(myRxSignalState.SDCState);
			//myRxSignalState.IOState=(char)DRM_IO_STATE_RX_OK;
			ledIO.SetState(myRxSignalState.IOState);
			}
		}
}

LRESULT CRJ10MiniDlg::OnDRMChange(WPARAM wParam, LPARAM lParam)
{
	if(!ImOpen) return NULL;

	if(!wParam && !lParam) RefreshDRMState();
	else
		{
		if(lParam==DRM_SIGLEV_CHANGES) return NULL;
	
		BYTE state=(BYTE)(lParam&DRM_STATE_MASK);
		switch(lParam)
			{
			case	DRM_MSC_NOT_PRESENT:
			case	DRM_MSC_CRC_ERROR:
			case	DRM_MSC_DATA_ERROR:
			case	DRM_MSC_STATE_RX_OK: myRxSignalState.MSCState=state; break;
			case	DRM_SDC_NOT_PRESENT:
			case	DRM_SDC_CRC_ERROR:
			case	DRM_SDC_DATA_ERROR:
			case	DRM_SDC_STATE_RX_OK: myRxSignalState.SDCState=state; break;
			case	DRM_FAC_NOT_PRESENT:
			case	DRM_FAC_CRC_ERROR:
			case	DRM_FAC_DATA_ERROR:
			case	DRM_FAC_STATE_RX_OK: myRxSignalState.FACState=state; break;
			case	DRM_FSYNC_NOT_PRESENT:
			case	DRM_FSYNC_CRC_ERROR:
			case	DRM_FSYNC_DATA_ERROR:
			case	DRM_FSYNC_STATE_RX_OK: myRxSignalState.FSYNCState=state; break;
			case	DRM_TYSNC_NOT_PRESENT:
			case	DRM_TYSNC_CRC_ERROR:
			case	DRM_TYSNC_DATA_ERROR:
			case	DRM_TYSNC_STATE_RX_OK: myRxSignalState.TSYNCState=state; break;
			case	DRM_IO_NOT_PRESENT:
			case	DRM_IO_CRC_ERROR:
			case	DRM_IO_DATA_ERROR:
			case	DRM_IO_STATE_RX_OK: myRxSignalState.IOState=state; break;
			}
		RefreshDRMState();
		}
	return NULL;
}
