// RJ10MiniDlg.h : header file
//

#if !defined(AFX_RJ10MINIDLG_H__C6689DB7_CB0C_469E_B13B_F7F4FC029E34__INCLUDED_)
#define AFX_RJ10MINIDLG_H__C6689DB7_CB0C_469E_B13B_F7F4FC029E34__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CRJ10MiniDlg dialog

#include "FrqButton.h"
#include "MyClasses/MyEdit.h"
#include "MyClasses/MyPoti.h"
#include "MyClasses/MyButton.h"
#include "MyClasses/MyPeekMeter.h"
#include "MyClasses/MySMeter.h"
#include "MyClasses/MyStateLED.h"
#include "RJ10-GPIO.h"
#include "IFScopeControl.h"
class CRJ10MiniDlg : public CDialog
{
// Construction
public:
	CRJ10MiniDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRJ10MiniDlg)
	enum { IDD = IDD_RJ10MINI_DIALOG };
	CButton		m_gb1;
	CButton		m_gb2;
	FrqButton	m_FrqButton;
	BOOL		m_ATT;
	BOOL		m_MM;
	int			m_CHN;
	CString		m_frqedit;
	MyEdit		e_frqedit;
IFScopeControl  m_IFctrl;
	MyButton	b_MinMax;	
	MyButton	b_IGC;
	MyButton	b_mode;
	MyButton	b_filter;

	MyButton	b_speaker;
	MyButton	b_stereo;
	MyButton	b_mixer;
	MyButton	b_gainset;
	MyButton	b_manual;
	MyButton	m_symod;

	MyPeekMeter	m_inpeek;
	MyPeekMeter	m_outpeek;
	MySMeter	m_smeter;

	MyPoti		poti_sql;
	MyPoti		poti_vol;
	MyPoti		poti_out;
	MyPoti		poti_gain;


	//}}AFX_DATA

	MyButton	b_fig[13];
	MyButton	b_mem[4];
	MyButton	b_sw[3];

#define 	b_ATT b_sw[0]
#define 	b_DX  b_sw[1]
#define 	b_RX  b_sw[2]

	MyStateLED	ledSDC,ledFAC,ledMCS,ledIO;


	RJ10_GPIO	myHID;

	int			RxAction, m_mode,Ext_viewcntr,viewcntr,drm_update,m_IGC,m_TOPMOST,m_memfrq[4],WinVersion;
	int			IFGainOff,IFGainLevel,SaveIFGainLevel,IFOutLevel,AFInLevel,AFOutLevel;
	int			m_filterwidth,m_sql,m_volume,m_spkON,m_stereoON,DrawImmediately;
	CRect		minRect,maxRect;
	float		DrawDelaySum,DrawDelayFac,DrawInputFac;


	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRJ10MiniDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

public:
	int		m_frq,m_steps,LastDeviceCheck,ImOpen;

	void	SetEditFrq();
	int		SetFrq(int frq, int force=0);

	void	Adjust(int mm, int set=1);

	void	SetRadioModeButtons(int mode);
	void	SetFilterWidth(int width);
	void	SetIGC(int igc);
	void	SetVolume(int vol,int reset=0);
	void	SetSquelch(int sql);
	void	SetATT(int att);
	void	SetCHN(int chn);
	void	SetSystemModal(int modalmode);
	void	SetIFGain(int pos, int set=0);
	void	SetGain();
	void	SetAFOutLevel(int out); 
	void	SetStereo(int onoff);
	void	SetSpeaker(int onoff);
	void	MouseWheel(UINT nFlags, short zDelta,int RoundWidth);
	void	SuspendRX();
	void	ReActivateRX();
	void	RefreshDRMState();
	void	SetRepeatation(int repeat);


// Implementation
protected:
	HICON m_hIcon;

	afx_msg LRESULT OnDRMChange(WPARAM wParam, LPARAM lParam);
	// Generated message map functions
	//{{AFX_MSG(CRJ10MiniDlg)
	afx_msg BOOL OnDeviceChange( UINT nEventType, DWORD dwData );
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSetMinOrMax();
	afx_msg void OnAtt();
	afx_msg void OnChnDx();
	afx_msg void OnChnRx();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnSetIGC();
	afx_msg void OnSetMode();
	afx_msg void OnSetFilter();
	afx_msg void OnSetGain();
	afx_msg void OnSetSystemModal();
	afx_msg void OnAudioMixer();
	afx_msg void OnSetSpeaker();
	afx_msg void OnSetStereo();
	afx_msg void OnManual();
	//}}AFX_MSG
	afx_msg void OnSetFrqMemory(UINT id);
	afx_msg void OnSetFrqDirect(UINT id);
	afx_msg LRESULT OnRightButton(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnFrqEditCR(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnIFInput(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT StartAction(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT DeviceAdd(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT DeviceRemoved(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT ExtDeviceAdd(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT ExtDeviceRemoved(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT DeviceIOChanged(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUpdateSmeterButton(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT SetSMeter(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT SetSquelch(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPotiChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnScopeOut(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMixCtrlChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT IFinLevelChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT WaveOutVolumeChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT DrawFrqAction(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnExtIQSHOWChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQCORRChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQSCALChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQOFFSChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQATTChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQPREChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQSampleChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQRTLChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQIFGNChange(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnExtIQHFGNChange(WPARAM wParam, LPARAM lParam);
	afx_msg BOOL OnToolTipText(UINT id, NMHDR * pNotifyStruct, LRESULT * result);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RJ10MINIDLG_H__C6689DB7_CB0C_469E_B13B_F7F4FC029E34__INCLUDED_)
